.comment comments *-------------------------------------------------------------*
|										|
|	GIF(16/256) Graphic Loader for over1024/512				|
|										|
|					original program v1.07 by Herzen	|
|										|
comments *----------------------------------------------------------------------*

	.ifdef	PiH
* PiH SYS p
		.include	pih.h
		.include	lib.h
		.xdef		header_read
		.xdef		decode
	.else
* MPH p
		.include	mph.h
		.include	mph_lib.h
	.endif
* ȉCʒ`

		.include	config.h
		.include	gif_load.h
		.include	doscall.mac

		.xdef	gif_header_read__
		.xdef	gif_decode__
		.xdef	gif_RasterCopy

		.xref	skip_mac_binary
		.xref	getc
		.xref	getw
		.xref	comment_get

* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*
* GIF(16/256)摜WJ
*
* in  a1.l = ꂩWJׂ摜f[^ۑĂꏊDREADDATA
*            ( DOS _READ œǂݍ񂾃f[^̐擪AhX )
*
* out d0.w =        0 : I
*            ȊO : G[R[h
*
* (l) 2`256Fɂ炸CPsNZPoCgœWJD
*        zGRAMpłCGRAMWJ͂ȂD
*        in  a1.l ̎wAhX̒O(FOR_PI256)Byte[NƂD
*        idecode: ȉ [] QƁj
*
*----------------------------------------------------------------------------*

decode:
gif_decode__:
	.ifndef PiH
* MPH2p
		movem.l	d3-d7/a3-a6,-(sp)
		movea.l	a1,a6
		suba.l	#FOR_PI256,a6			* []
		movea.l	_buff_addr(a5),a4
		tst.b	_gif_hispeed(a5)
		beq	@f
		move.l	a4,interlace_trans_addr(a6)
		movea.l	a6,a4
		move.w	_colum(a5),d0
		mulu.w	_line(a5),d0
		and.w	#$fffe,d0
		addq.l	#2,d0
		suba.l	d0,a4
@@:		bsr	expand
		movem.l	(sp)+,d3-d7/a3-a6
		rts
	.else
* PiHp
		movem.l	d3-d7/a3-a6,-(sp)
		movea.l	a1,a6
		suba.l	#FOR_PI256,a6			* []
		clr.w	error_flag(a6)
		movea.l	_buff_addr256(a5),a4
		move.l	_buff_addr(a5),interlace_trans_addr(a6)
		tst.b	_256to64K_flag(a5)
		beq	@f
			tst.w	_gif_hispeed(a5)
			beq	@f
				movea.l	_buff_addr(a5),a4
				move.l	_buff_addr256(a5),interlace_trans_addr(a6)
@@:		bsr	expand
		movem.l	(sp)+,d3-d7/a3-a6
		rts

	.endif


*----------------------------------------------------------------------------*
*
* GIFwb_ǂݍ
*
* in  Ȃ
*
* out d0.w =        0 : 
*            ȊO : G[id6.w = G[R[hj
*
* (l) EDOS _OPEN ŁCt@Cnh _file(a5) Ɋi[ĂƁD
*        EMAC binary ΉD
*        Eŏ image descriptor ܂œǂݍށD
*
*----------------------------------------------------------------------------*

header_read:
		bsr	getc
		cmp.b	#'G',d0
		bne	@f
		bsr	getc
		cmp.b	#'I',d0
		bne	@f
		bsr	getc
		cmp.b	#'F',d0
		bne	@f
		bsr	getc
		cmp.b	#'8',d0
		beq	gif_header_cont02
@@:
		move.w	#0,-(sp)
		pea.l	0.w
		move.w	_file(a5),-(sp)
		.dc.w	$FF42		* DOS	__SEEK
		addq.l	#8,sp
		bsr	skip_mac_binary
		bra	gif_header_cont

gif_header_read__:
		bsr	skip_mac_binary
gif_header_cont:
		moveq.l	#0,d7
*------------------------------------------------------- mfheʋLn
*							  GIF signature
*							  UoCgŒ
		moveq.l	#30,d6
		bsr	getc
		cmp.b	#'G',d0		* GIF signature
		bne	error_
		bsr	getc
		cmp.b	#'I',d0
		bne	error_
		bsr	getc
		cmp.b	#'F',d0
		bne	error_
		bsr	getc
		cmp.b	#'8',d0
		bne	error_
gif_header_cont02:
		bsr	getc
		cmp.b	#'7',d0		* 87
		beq	@f
		cmp.b	#'9',d0		* 89
		bne	error_
@@:
		move.w	d0,d1
		bsr	getc
		cmp.b	#'a',d0
		bne	error_

**		lea.l	_image_tmp(a5),a1
		lea.l	image_tmp(pc),a1
		ext.w	d1
		move.w	d1,gif_ver(a1)

*------------------------------------------------------- mXN[擾n
*							  screen descriptor
*							  VoCgŒ

		bsr	getc		* XN[̕
		move.b	d0,d1
		bsr	getc
		lsl.w	#8,d0
		move.b	d1,d0
		move.w	d0,sc_xsize(a1)

		bsr	getc		* XN[̍
		move.b	d0,d1
		bsr	getc
		lsl.w	#8,d0
		move.b	d1,d0
		move.w	d0,sc_ysize(a1)

		moveq.l	#0,d3
		bsr	getc
		btst.l	#7,d0		* O[oJ[}bv̗L
		beq	error_		* ͎̂דłD
		move.w	d0,d1
		lsr.w	#4,d1
		and.w	#%111,d1	* |F𑜓xicolor resolutionj
		addq.w	#1,d1		* |̗Lrbg
		move.w	d1,sc_cr(a1)
		and.w	#%111,d0	* color pixel bit
		addq.w	#1,d0		*
		move.w	d0,sc_pixel(a1)	* 1sNZbit

		bsr	getc
		and.w	#$00ff,d0
		move.w	d0,bg_col(a1)	* wiF

		bsr	getc		* aspect
		and.w	#$00ff,d0
		move.w	d0,aspect(a1)

		move.w	sc_pixel(a1),d0	* 1sNZbit
		bsr	palet_get	* pbg擾

		move.w	#0,_color(a5)
		move.w	sc_pixel(a1),d0	* 1sNZbit
		beq	@f
		move.w	#8,_color(a5)
		cmp.w	#4,d0
		bhi	@f
		move.w	#4,_color(a5)
@@:

		move.w	#0,animated_gif(a1)

to_img_sep_lop:
		bsr	getc		* C[WL܂Ŕ΂
		cmp.b	#',',d0		* C[WL
		beq	cont02
		cmp.b	#'!',d0
		bne	to_img_sep_lop	* {̓G[łD
		bsr	getc	* g@\ԍ
		bsr	getc
ext_block_lop:
		moveq.l	#0,d1
		move.b	d0,d1
		subq.w	#1,d1
@@:		bsr	getc
		dbra	d1,@b
		bsr	getc
		tst.b	d0
		bne	ext_block_lop
		bra	to_img_sep_lop

cont02:
*------------------------------------------------------- m摜擾n
*							  image descriptor
*							  10oCgŒiC[WL ܁j

		bsr	getc		* wW
		move.b	d0,d1
		bsr	getc
		lsl.w	#8,d0
		move.b	d1,d0
		move.w	d0,_scolum(a5)
		bsr	getc		* xW
		move.b	d0,d1
		bsr	getc
		lsl.w	#8,d0
		move.b	d1,d0
		move.w	d0,_sline(a5)

		bsr	getc		* 摜̕
		move.b	d0,d1
		bsr	getc
		lsl.w	#8,d0
		move.b	d1,d0
		move.w	d0,_colum(a5)
		bsr	getc		* 摜̍
		move.b	d0,d1
		bsr	getc
		lsl.w	#8,d0
		move.b	d1,d0
		move.w	d0,_line(a5)

		moveq.l	#31,d6
		bsr	getc		* [JJ[}bvCC^[XCF𑜓x
		clr.b	_gif_hispeed+1(a5)
		btst.l	#6,d0		* InterlaceH
		sne.b	_gif_hispeed+1(a5)

		btst.l	#7,d0		* [JJ[}bvp邩H
		beq	notexist_localpalet
		and.w	#%111,d0
		addq.w	#1,d0		* 1sNZbit

		bsr	palet_get	* ēx擾
notexist_localpalet:

*------------------------------------------------------- mX^[f[^n
*							  Raster data

		bsr	getc		* pixel_bit
		and.w	#$ff,d0
		move.w	d0,img_CodeSize(a1)
		tst.w	_color(a5)
		bne	@f
		move.w	#8,_color(a5)
		cmp.w	#4,d0
		bhi	@f
		move.w	#4,_color(a5)
@@:
		moveq.l	#1,d1
		lsl.w	d0,d1
		ext.l	d1
		subq.l	#1,d1
		move.l	d1,img_BitMask(a1)

		move.w	_scolum(a5),d0
		add.w	_colum(a5),d0
		subq.w	#1,d0
		move.w	d0,_ecolum(a5)
		move.w	_sline(a5),d0
		add.w	_line(a5),d0
		subq.w	#1,d0
		move.w	d0,_eline(a5)

		bsr	pal16_chk

		moveq.l	#0,d0
		rts

error_:
		moveq.l	#-1,d0
		rts

image_tmp:
	.ds.b	GIFWORK2_SIZE

*----------------------------------------------------------------------------*
*  pbg擾
*----------------------------------------------------------------------------*

palet_get:
		moveq.l	#1,d2
		lsl.w	d0,d2
		subq.w	#1,d2

		tst.w	_palet(a5)
		beq	palet_get_main
@@:		bsr	getc
		bsr	getc
		bsr	getc
		dbra	d2,@b
		rts
palet_get_main:
		st.b	_rgb_flag(a5)
		lea.l	_rgb(a5),a2
		lea.l	_pal_buf(a5),a0
palet_loop:
		bsr	getc		* R
		move.b	d0,(a2)+
		and.w	#$00f8,d0
		rol.w	#3,d0
		move.w	d0,d1
		bsr	getc		* G
		move.b	d0,(a2)+
		and.w	#$00f8,d0
		ror.w	#8,d0
		or.w	d0,d1
		bsr	getc		* B
		move.b	d0,(a2)+
		and.w	#$00f8,d0
		ror.w	#2,d0
		or.w	d0,d1
		move.w	d1,(a0)+
@@:		dbra	d2,palet_loop
		rts

pal16_chk:	* 16Ԗڈȍ~ 0000 ȏꍇ́C16FƂB
		lea.l	_pal_buf+16*2(a5),a0
*		.rept 5
		move.w	#256-16-1,d0
@@:
		tst.w	(a0)+
		dbne	d0,@b
		tst.w	d0
		bge	@f
		move.w	#4,_color(a5)
@@:
		rts


*----------------------------------------------------------------------------*
*
* 16/256摜WJC
*
*----------------------------------------------------------------------------*

expand:
	move.l	a4,vgram(a6)
	move.w	_colum(a5),d0
	mulu.w	_line(a5),d0
	addq.l	#1,d0
	and.w	#$fffe,d0
	move.l	a4,d1
	add.l	d1,d0
	move.l	d0,chk_addr(a6)

	moveq.l	#0,d3			* d3.l = BitOffset(a6)
	move.l	d3,d4			* d4.w = OutCount(a6)
	move.l	d3,d5			* d5.w = ReadMask(a6)
	move.l	d3,d7			* d7.w = FreeCode(a6)
	move.l	d3,XC(a6)
	move.w	_colum(a5),XC(a6)
	move.w	#-1,oldYC(a6)
	move.w	d3,Pass(a6)
	move.w	d3,one(a6)

**	lea.l	_image_tmp(a5),a2
	lea.l	image_tmp(pc),a2
	move.l	img_BitMask(a2),d0
	move.w	d0,BitMask(a6)
	move.w	d0,d5
	swap.w	d5

	move.w	d3,Interlace(a6)
	tst.b	_gif_hispeed+1(a5)
	sne.b	Interlace+1(a6)

	moveq.l	#1,d6			* PreLen
	swap.w	d6			* PreLen  CodeSize
	move.w	img_CodeSize(a2),d6	* d6.w = CodeSize
	moveq.l	#1,d1
	lsl.w	d6,d1
	move.w	d1,ClearCode(a6)
	addq.w	#1,d1
	move.w	d1,d2			* d2.w = EOFCode(a6)
	move.w	d1,EOFCode(a6)		* d2.w = EOFCode(a6)
	addq.w	#1,d1
	move.w	d1,d7			* d7.w = FreeCode(a6)
	move.w	d1,FirstFree(a6)

	addq.w	#1,d6
	move.w	d6,InitCodeSize(a6)
	moveq.l	#1,d1
	lsl.w	d6,d1
	swap.w	d2
	move.w	d1,d2		*	move.w	d1,MaxCode(a6)
	move.w	d1,InitMaxCode(a6)
	subq.w	#1,d1
	move.w	d1,d5		* d5.w = ReadMask(a6)
	move.w	d1,InitReadMask(a6)

	movea.l	a1,a3		* a3 = Raster

	bsr	RasterCopy
*	movem.l	a0-a1,-(sp)
*	lea.l	_image_tmp(a5),a0
*	move.w	#0,animated_gif(a5)
*	bsr	next_data_chk_lop
*	movem.l	(sp)+,a0-a1

*	tst.w	Interlace(a6)
*	beq	@f
*	tst.b	_gif_hispeed(a5)
*	beq	decode_interlace
*@@:

	move.l	a5,-(sp)

	lea.l	Length(a6),a5

	move.w	d7,d0
	add.w	d0,d0
	lea.l	(a5,d0.w),a1		* ݐp
	move.l	a1,MOV(a6)
	add.w	d0,d0
	lea.l	(a6,d0.w),a2		* ݐp
	move.l	a2,MOV+4(a6)

*----------------------------------------------------------------------------*
* LZWWJ

while_lop:
	readCode
	cmp.w	EOFCode(a6),d1		* EOFCode(a6),d1
	beq	while_end

		cmp.w	ClearCode(a6),d1
		bne	if1_else

			moveq.l	#1,d6
			swap.w	d6
			move.w	InitCodeSize(a6),d6	* CodeSize = InitCodeSize;
			move.w	InitMaxCode(a6),d2	* MaxCode(a6)
			move.w	InitReadMask(a6),d5	* ReadMask(a6)
			move.w	FirstFree(a6),d7	* FreeCode(a6)	FreeCode = FirstFree;
			readCode

			lea.l	MOV(a6),a0
			movem.l	(a0)+,a1-a2

			move.b	d1,(a4)+		* FinChar+1(a6),(a4)+

		bra	while_lop
if1_else:
		cmp.l	chk_addr(a6),a4
		bhi	while_end

		swap.w	d5			* ReadMask  BitMask
		swap.w	d3			* readCodeSize d3  FinChar
		swap.w	d6			* EOFCode  OldCode

		cmp.w	d7,d1			* CurCode >= FreeCode
		bcs	next_bit_chk
			move.w	d6,d0
			movea.l	a4,a0
			suba.w	d0,a0

			addq.w	#1,d6
			cmp.w	#4095,d7
			bhi	@f
			move.w	d6,(a1)+
			move.l	a0,(a2)+
@@:			move.b	(a0)+,(a4)+
			dbra	d0,@b
			bra	while_cont
next_bit_chk:
		cmp.w	d5,d1		*cmp.w	BitMask(a6),d1
		bls	while2_end

			move.w	d1,d0
			add.w	d0,d0
			move.w	(a5,d0.w),d3	* 
			add.w	d0,d0
			movea.l	(a6,d0.w),a0

		cmp.w	#4095,d7
		bhi	@f

			move.l	a4,d0
			move.w	d6,d1		* O̒
			ext.l	d1
			sub.l	d1,d0
			move.l	d0,(a2)+
			addq.w	#1,d1
			move.w	d1,(a1)+
@@:

			move.w	d3,d6
			subq.w	#1,d3
@@:			move.b	(a0)+,(a4)+
			dbra	d3,@b

			bra	while_cont

while2_end:
			move.w	d1,d3
		cmp.w	#4095,d7
		bhi	@f

			move.l	a4,d0
			move.w	d6,d1	* O̒
			ext.l	d1
			sub.l	d1,d0
			move.l	d0,(a2)+
			addq.w	#1,d1
			move.w	d1,(a1)+
@@:
			move.w	#1,d6
			move.b	d3,(a4)+

			bra	while_cont

while_cont:
		addq.w	#1,d7		* FreeCode(a6)

		swap.w	d5		* BitMask  ReadMask
		swap.w	d3		* FinChar  readCodeSize d3
		swap.w	d6		* OldCode  EOFCode

		cmp.w	d2,d7
		bcs	while_lop
			cmp.w	#12,d6
			bcc	while_lop
				addq.w	#1,d6
				add.w	d2,d2
*				move.w	MaxCode(a6),d0
*				add.w	d0,MaxCode(a6)
				moveq.l	#1,d1
				lsl.w	d6,d1
				subq.w	#1,d1
				move.w	d1,d5	* ReadMask(a6)
@@:

if1_else_end:
	bra	while_lop
while_end:
	move.l	(sp)+,a5

	tst.w	Interlace(a6)
	bne	from_interlace

	moveq.l	#0,d0
	rts


*----------------------------------------------------------------------------*
* C^[X
*----------------------------------------------------------------------------*

from_interlace:
	movea.l	interlace_trans_addr(a6),a4
	movea.l	vgram(a6),a3
	moveq.l	#0,d3
	moveq.l	#0,d2
	move.w	_line(a5),d2
	swap.w	d2

	moveq.l	#0,d0
	move.l	d0,d1
	move.w	_colum(a5),d0
	move.w	d0,d1
	lsl.l	#3,d0		* 8{
	sub.l	d1,d0
	move.l	d0,colum8(a6)

	moveq.l	#0,d0
	move.w	d1,d0
	lsl.l	#2,d0		* 4{
	sub.l	d1,d0
	move.l	d0,colum4(a6)

	move.w	_line(a5),d1
	subq.w	#1,d1
@@:
	bsr	timatima
	bsr	address_chg

	dbra	d1,@b

	moveq.l	#0,d0
	rts


address_chg:
	move.w	d2,d0
	add.w	d0,d0
	jmp	pass_tbl_(pc,d0.w)
	rts

pass_tbl_:
	bra.s	pass0_
	bra.s	pass1_
	bra.s	pass2_
	bra.s	pass3_

pass0_:
	swap.w	d2
	addq.w	#8,d3
	cmp.w	d3,d2
	bhi.b	@f
	swap.w	d2
	addq.w	#1,d2
	move.w	#4,d3
		moveq.l	#0,d0
		move.w	_colum(a5),d0
		lsl.l	#2,d0		* S{
*		move.w	d3,d0
*		mulu.w	_colum(a5),d0
		movea.l	interlace_trans_addr(a6),a4
		adda.l	d0,a4

	rts
@@:
	swap.w	d2
	adda.l	colum8(a6),a4
	rts

pass1_:
	swap.w	d2
	addq.w	#8,d3
	cmp.w	d3,d2
	bhi.b	@f
	swap.w	d2
	addq.w	#1,d2
	move.w	#2,d3
		moveq.l	#0,d0
		move.w	_colum(a5),d0
		lsl.l	#1,d0		* Q{
*		move.w	d3,d0
*		mulu.w	_colum(a5),d0
		movea.l	interlace_trans_addr(a6),a4
		adda.l	d0,a4
	rts
@@:
	swap.w	d2
	adda.l	colum8(a6),a4
	rts

pass3_:
	addq.w	#2,d3
	adda.w	_colum(a5),a4
	rts

pass2_:
	swap.w	d2
	addq.w	#4,d3
	cmp.w	d3,d2
	bhi.b	@f
	swap.w	d2
	addq.w	#1,d2
	move.w	#1,d3
		movea.l	interlace_trans_addr(a6),a4
		adda.w	_colum(a5),a4
	rts
@@:
	swap.w	d2
	adda.l	colum4(a6),a4
	rts

timatima:
	move.w	_colum(a5),d0
@@:
	sub.w	#256,d0
	bmi	@f
	bsr	tima
	bra	@b
@@:
	add.w	#256,d0
	move.w	#256,d4
	sub.w	d0,d4
	add.w	d4,d4
	jmp	tima(pc,d4.w)
	nop

tima:
	.rept 256
	move.b	(a3)+,(a4)+
	.endm
	rts


*----------------------------------------------------------------------------*
* X^[f[^擾
*----------------------------------------------------------------------------*

gif_RasterCopy:
RasterCopy:
	movea.l	a1,a0
rc_lop:
	moveq.l	#0,d0
	move.b	(a1)+,d0
	beq	RasterCopy_end
	cmp.l	_enddata_addr(a5),a1
	bhi	destroyed_data
	cmp.w	#$fe,d0
	beq	rc_t
	subq.w	#1,d0
@@:	move.b	(a1)+,(a0)+
	dbra	d0,@b
	bra	rc_lop
*	tst.b	(a1)
*	bne	rc_lop
RasterCopy_end:
	move.l	a1,next_readdata_addr(a6)
	rts

rc_t:
	.rept 254
	move.b	(a1)+,(a0)+
	.endm
	bra	rc_lop


*----------------------------------------------------------------------------*
* ꂽf[^p
* GIF ͉Ăf[^ :-<

destroyed_data:
	st.b	error_flag(a6)
	movem.l	a1-a2,-(sp)
	suba.l	a1,a1
	movea.l	a1,a2
	moveq.l	#10,d0
	.ifndef PiH
* MPH
	pea.l	0.w
	DOS	_SUPER
	move.l	d0,(sp)
	bsr	v_bell
	DOS	_SUPER
	addq.l	#4,sp
	moveq.l	#44,d0
	.xref	IPRINT
	bsr	IPRINT
	.else
* PiH SYS
	bsr	v_bell
	.endif
	movem.l	(sp)+,a1-a2
	rts

	.ifndef PiH
error_mes:
	.dc.b	'EWarningFf[^Ă܂D',13,0
	.even
	.endif


*----------------------------------------------------------------------------*
* ʃtbV(rWAx)

* ̂̓CuƂĕʂɂĂׂȂ̂ :-)

vsync	.macro
@@:		btst.b	#4,$e88001
		beq	@b
@@:		btst.b	#4,$e88001
		bne	@b
	.endm

v_bell:
		move.w	$e82200,-(sp)
@@:		btst.b	#4,$e88001
		bne	@b

		.rept 4
		move.w	#$fffe,$e82200
		vsync
		vsync
		move.w	#1,$e82200
		vsync
		vsync
		.endm

		move.w	(sp)+,$e82200
		rts

*		move.w	#49152,$e82200
*		move.w	#52,$e82200
*		move.w	#1664,$e82200

		.end



































































































*----------------------------------------------------------------------------*
* ܂
*----------------------------------------------------------------------------*

*----------------------------------------------------------------------------*
* Animated GIF `FbN

next_data_chk_lop:
		cmp.l	_enddata_addr(a5),a1
		bhi	I[LȂ
		move.b	(a1)+,d0
		cmp.b	#';',d0		* GIF I[L
		beq	next_data_chk_end
		cmp.b	#$2c,d0		* C[WL
		beq	next_data_chk_cont
		cmp.b	#'!',d0
		bne	next_data_chk_lop
@@:
		addq.l	#1,a1
		moveq.l	#0,d0
		move.b	(a1)+,d0
@@:		adda.w	d0,a1
		move.b	(a1)+,d0
		bne	@b
		bra	next_data_chk_lop
next_data_chk_end:
I[LȂ:
		rts

next_data_chk_cont:
		st.b	animated_gif(a0)
		rts


*----------------------------------------------------------------------------*
* C^[XWJiᑬŁj
*----------------------------------------------------------------------------*

* C^[XGIF łȂf[^̓WJ[`͖D

decode_interlace:
	lea.l	Suffix(a6),a2
	lea.l	Prefix(a6),a1

	moveq.l	#0,d0
	move.l	d0,d1
	move.w	_colum(a5),d0
	move.w	d0,d1
	lsl.l	#3,d0		* 8{
	sub.l	d1,d0
	move.l	d0,colum8(a6)

	moveq.l	#0,d0
	move.w	d1,d0
	lsl.l	#2,d0		* 4{
	sub.l	d1,d0
	move.l	d0,colum4(a6)

	move.w	_colum(a5),colum(a6)
	move.w	_line(a5),line(a6)
	move.l	a5,-(sp)
	movea.l	a4,a5
while_lop_i:
	readCode
	swap.w	d2		* MaxCode  EOFCode 
	cmp.w	d2,d1		* EOFCode(a6),d1
	beq	while_end_i
	swap.w	d2		* EOFCode  MaxCode

		cmp.w	ClearCode(a6),d1
		bne	if1_else_i

			moveq.l	#0,d0
			move.w	InitCodeSize(a6),d6		CodeSize = InitCodeSize;
			move.w	InitMaxCode(a6),d2	* MaxCode(a6)
			move.w	InitReadMask(a6),d5	* ReadMask(a6)
			move.w	FirstFree(a6),d7	* FreeCode(a6)	FreeCode = FirstFree;
			readCode
			swap.w	d6
			move.w	d1,d6			* d1,OldCode(a6)
			swap.w	d6
			and.w	BitMask(a6),d1
			swap.w	d3
			move.w	d1,d3			* d1,FinChar(a6)
			swap.w	d3
			lea.l	OutCode_tmp(a6),a0
			move.w	d1,(a0)+
	bsr	doInterlace

		bra	while_lop_i
if1_else_i:
		swap.w	d5			* ReadMask  BitMask
		swap.w	d3			* readCodeSize d3  FinChar
		swap.w	d6			* EOFCode  OldCode

*****		cmp.w	#4096,d7			* FreeCode(a6)	* FreeCode>=4096
*****		bcc	while_end
		move.w	d1,-(sp)		*InCode(a6)

		lea.l	OutCode(a6,d4.w),a0

		cmp.w	d7,d1			* CurCode >= FreeCode
		bcs	@f
			move.w	d6,d1		* OldCode(a6),d1
*****			cmp.w	#4096,d4
*****			bhi	while_end
			move.b	d3,(a0)+	* FinChar+1(a6),OutCode(a6,d4.w)
			addq.w	#1,d4
@@:
		cmp.w	d5,d1		*cmp.w	BitMask(a6),d1	* while (CurCode > BitMask) {
		bls	while2_end_i
while2_lop_i:
*****			cmp.w	#4096,d4
*****			bhi	while2_end
			move.b	(a2,d1.w),(a0)+		*OutCode(a6,d4.w)	* Suffix
			addq.w	#1,d4
			add.w	d1,d1
			move.w	(a1,d1.w),d1				* Prefix
		cmp.w	d5,d1	*cmp.w	BitMask(a6),d1		* while (CurCode > BitMask) {
		bhi	while2_lop_i
while2_end_i:
*****		cmp.w	#4096,d4
*****		bhi	while_end
		and.w	d5,d1		*and.w	BitMask(a6),d1
		move.w	d1,d3		* d1,FinChar(a6)
		move.b	d1,(a0)+		* OutCode(a6,d4.w)
*		addq.w	#1,d4

*	moveq.l	#0,d0
*	lea.l	OutCode(a6,d4.l),a0
*	subq.w	#1,d4
@@:
	bsr	doInterlace
	dbra	d4,@b

		moveq.l	#0,d4

		move.w	d7,d0		* FreeCode
		move.b	d3,(a2,d7.w)	* FinChar+1(a6),(a2,d7.w)		* Suffix
		add.w	d0,d0
		move.w	d6,(a1,d0.w)	* OldCode(a6),(a1,d0.w)		* Prefix
		move.w	(sp)+,d6	* InCode(a6),OldCode(a6)

		addq.w	#1,d7		* FreeCode(a6)

		swap.w	d5		* BitMask  ReadMask
		swap.w	d3		* FinChar  readCodeSize d3
		swap.w	d6		* OldCode  EOFCode

		cmp.w	d2,d7		* MaxCode(a6),d7		* FreeCode >= MaxCode)
		bcs	while_lop_i
			cmp.w	#12,d6
			bcc	while_lop_i
				addq.w	#1,d6
				add.w	d2,d2
*				move.w	MaxCode(a6),d0
*				add.w	d0,MaxCode(a6)
				moveq.l	#1,d1
				lsl.w	d6,d1
				subq.w	#1,d1
				move.w	d1,d5	* ReadMask(a6)
@@:
if1_else_end_i:
	bra	while_lop_i
while_end_i:
	move.l	(sp)+,a5
	moveq.l	#0,d0
	rts


* d0.b .
doInterlace:
*****	cmp.w	line(a6),d0		  if (YC<Height)
*****	bcc	@f
	move.b	-(a0),(a5)+
@@:

	subq.w	#1,XC(a6)
	bne	doInterlace_end

	move.w	colum(a6),XC(a6)
	move.w	line(a6),d0
	swap.w	d0
	move.w	Pass(a6),d0
	add.w	d0,d0
	jmp	pass_tbl(pc,d0.w)
doInterlace_end
*	move.l	(sp)+,d1
	rts

pass_tbl:
	bra.s	pass0
	bra.s	pass1
	bra.s	pass2
	bra.s	pass3

pass0:
	swap.w	d0
	addq.w	#8,YC(a6)
	cmp.w	YC(a6),d0
	bhi.b	@f
	addq.w	#1,Pass(a6)
	move.w	#4,YC(a6)
		move.w	YC(a6),d0
		mulu.w	colum(a6),d0
		lea.l	(a4,d0.l),a5
	rts
@@:
	adda.l	colum8(a6),a5
	rts

pass1:
	swap.w	d0
	addq.w	#8,YC(a6)
	cmp.w	YC(a6),d0
	bhi.b	@f
	addq.w	#1,Pass(a6)
	move.w	#2,YC(a6)
		move.w	YC(a6),d0
		mulu.w	colum(a6),d0
		lea.l	(a4,d0.l),a5
	rts
@@:
	adda.l	colum8(a6),a5
	rts

pass2:
	swap.w	d0
	addq.w	#4,YC(a6)
	cmp.w	YC(a6),d0
	bhi.b	@f
	addq.w	#1,Pass(a6)
	move.w	#1,YC(a6)
		movea.l	a4,a5
		adda.w	colum(a6),a5
	rts
@@:
	adda.l	colum4(a6),a5
	rts

pass3:
	addq.w	#2,YC(a6)
	adda.w	colum(a6),a5
	rts

	.end
