.comment comments *-------------------------------------------------------------*
|										|
|	Hyper Graphic Loader for over1024					|
|										|
|					original program by xtjh		|
|					rewrited program by Herzen		|
|										|
|				--         based on xhgl.has v1.80  --		|
|				--  modified for hg_load.has v1.11  --		|
comments *----------------------------------------------------------------------*

	.ifdef	PiH
* PiH SYS p
		.include	pih.h
		.include	lib.h
		.xdef		header_read
		.xdef		decode
	.else
* MPH p
		.include	mph.h
		.include	mph_lib.h
	.endif
* ȉCʒ`

		.include	hg_load.h

		.xdef	hg_decode__
		.xdef	hg_header_read__

		.xref	skip_mac_binary
		.xref	getc
		.xref	comment_get

* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*
* HG(16)摜WJ
*
* in  a1.l = ꂩWJׂ摜f[^ۑĂꏊDREADDATA
*            ( DOS _READ œǂݍ񂾃f[^̐擪AhX )
*
* out d0.w =        0 : 
*            ȊO : G[R[h
*
* (l) PsNZPoCgœWJD
*        zGRAMpłCGRAMWJ͂ȂD
*
*----------------------------------------------------------------------------*

decode:
hg_decode__:
		movem.l	d3-d7/a3-a6,-(sp)
		move.w	_colum(a5),d1		* d1.w = 摜TCY
		move.w	_line(a5),d2		* d2.w =     cTCY
		movea.l	_buff_addr(a5),a0	* a0 = zGRAM AhX
**		move.l	_hg_addr(a5),d3
		move.l	hg_half_addr(pc),d3
		movea.l	a1,a3			* a3 = READDATA AhX (bit data)
		lea.l	(a3,d3.l),a4		* a4 = half byte data address
		movea.l	_linewk_addr(a5),a1	* a1 = linewk AhX
		bsr	_HG_load
		movem.l	(sp)+,d3-d7/a3-a6
		rts

*----------------------------------------------------------------------------*
*
* HGwb_ǂݍ
*
* in  Ȃ
*
* out d0.w =        0 : 
*            ȊO : G[id6.w = G[R[hj
*
* (l) EDOS _OPEN ŁCt@Cnh _file(a5) Ɋi[ĂƁD
*        EMAC binary ΉD
*
*----------------------------------------------------------------------------*

header_read:
		bsr	getc
		cmp.b	#'H',d0
		bne	@f
		bsr	getc
		cmp.b	#'G',d0
		beq	hg_header_cont02
@@:
		move.w	#0,-(sp)
		pea.l	0.w
		move.w	_file(a5),-(sp)
		.dc.w	$FF42		* DOS	__SEEK
		addq.l	#8,sp
		bsr	skip_mac_binary
		bra	hg_header_cont

hg_header_read__:
		bsr	skip_mac_binary
hg_header_cont:
		moveq.l	#30,d6
		bsr	getc
		cmp.b	#'H',d0
		bne	error_
		bsr	getc
		cmp.b	#'G',d0
		bne	error_
hg_header_cont02:
		move.w	#4,_color(a5)

		bsr	getc
		move.w	d0,d3		; version get
		cmp.b	#'1',d0
		bne	@f
		move.b	d0,_PP_flag(a5)
@@:
		bsr	getc		* subversion check ͂Ȃ
		bsr	getc
		bsr	getc
		bsr	getc

		bsr	comment_get

		bsr	getc
		move.b	d0,d1
		bsr	getc
		lsl.w	#8,d0
		move.b	d1,d0
		lsl.w	#3,d0
		move.w	d0,_scolum(a5)

		bsr	getc
		move.b	d0,d1
		bsr	getc
		lsl.w	#8,d0
		move.b	d1,d0
		move.w	d0,_sline(a5)

		bsr	getc
		move.b	d0,d1
		bsr	getc
		lsl.w	#8,d0
		move.b	d1,d0
		lsl.w	#3,d0
		move.w	d0,_colum(a5)

		bsr	getc
		move.b	d0,d1
		bsr	getc
		lsl.w	#8,d0
		move.b	d1,d0
		move.w	d0,_line(a5)

		move.w	_colum(a5),d0
		subq.w	#1,d0
		add.w	_scolum(a5),d0
		move.w	d0,_ecolum(a5)
		move.w	_line(a5),d0
		subq.w	#1,d0
		add.w	_sline(a5),d0
		move.w	d0,_eline(a5)

		moveq.l	#31,d6			* T|[gĂȂ`
		cmp.b	#'1',d3
		beq	ver1
		cmp.b	#'2',d3
		beq	ver2
		bra	error_

ver1:
		bsr	color_set_1
		bra	check_next

ver2:
		bsr	color_set_2
		bra	check_next

check_next:
		moveq.l	#0,d1
bsglp:
		moveq.l	#0,d0
		bsr	getc
		move.b	d0,d2
		bsr	getc
		lsl.w	#8,d0
		move.b	d2,d0
		tst.w	d0
		bne	bsget
		add.l	#$00008000,d1
		bra	bsglp
bsget:
		add.l	d0,d1
		lea.l	hg_half_addr(pc),a0
**		move.l	d1,_hg_addr(a5)
		move.l	d1,(a0)
		moveq.l	#0,d0
		rts

error_:
		moveq.l	#-1,d0
		rts

hg_half_addr:
	.dc.l	0

*----------------------------------------------------------------------------*
*  pbg擾
*----------------------------------------------------------------------------*

* ver.1.x

color_set_1:
	lea.l	_pal_buf(a5),a0
	moveq.l	#16-1,d4
cslp1:
	bsr	getc
	move.b	d0,d1
	bsr	getc
	lsl.w	#8,d0
	move.b	d1,d0
	move.w	d0,d1

	ror.w	#8,d1
	moveq.l	#$f,d2
	moveq.l	#$f,d3
	and.w	d1,d3		; blue
	lsr.w	#4,d1
	and.w	d1,d2		; red
	lsr.w	#4,d1		; green

	add.w	d1,d1
	beq	@f
	addq.w	#1,d1		; g
@@:
	add.w	d2,d2
	beq	@f
	addq.w	#1,d2		; r
@@:
	add.w	d3,d3
	beq	@f
	addq.w	#1,d3		; b
@@:
	lsl.w	#5,d1
	or.w	d2,d1
	lsl.w	#5,d1
	or.w	d3,d1
	lsl.w	#1,d1		; color code
	tst.w	_palet(a5)
	bne	@f
	move.w	d1,(a0)+
@@:	dbra	d4,cslp1

	rts

*-------------------------------*
* ver.2.x

color_set_2:
	lea.l	_pal_buf(a5),a0
	moveq.l	#16-1,d4
cslp2:
		bsr	getc
		move.b	d0,d1
		bsr	getc
		lsl.w	#8,d0
		move.b	d1,d0
		tst.w	_palet(a5)
		bne	@f
	move.w	d0,(a0)+
@@:	dbra	d4,cslp2
	rts


*----------------------------------------------------------------------------*
*
* 16摜WJC
*
*----------------------------------------------------------------------------*

_HG_load:
	link	a6,#HG_LOAD_WORKSIZE
	movem.l	d1-d7/a0-a5,-(sp)

	move.l	a1,linewk(a6)
	subq.w	#1,d2
	move.w	d2,LPYY(a6)
	move.w	d2,EY(a6)
	move.w	d2,SETY(a6)
	subq.w	#1,d1
	move.w	d1,EX(a6)
	subq.w	#7,d1
	move.w	d1,X(a6)
	clr.w	SX(a6)
	clr.w	SY(a6)
	movem.l	a0-a5,-(sp)
	bsr	make_tbl		; table init
	movem.l	(sp)+,a0-a5

	moveq.l	#0,d7			; last bit
	moveq.l	#0,d6			; bit data & loopx
	moveq.l	#0,d5			; half-byte data

	move.w	a3,d0
	btst.l	#0,d0
	beq	@f
	moveq.l	#0,d6
	move.b	(a3)+,d6		; AhX̏ꍇ炩ߎoĂ
	lsl.w	#8,d6
	swap	d6
	moveq.l	#8,d7
@@:

	move.w	SETY(a6),d0
	move.w	d0,LPY(a6)


	lea	tbl(pc),a5
	moveq.l	#0,d4

	clr.w	d6
loopx:
	swap	d6
	movea.l	linewk(a6),a1
	adda.l	#8216+12288*2,a1
	bsr	line_load
	movea.l	linewk(a6),a1
	adda.l	#12320+12288*3,a1
	bsr	line_load
	movea.l	linewk(a6),a1
	adda.l	#8216+12288*2,a1
	bsr	line_store
	swap	d6

	addq.l	#8,a0
	addq.w	#8,d6
	cmp.w	EX(a6),d6
	bge	loopxq

	swap	d6
	movea.l	linewk(a6),a1
	adda.l	#8,a1
	bsr	line_load2
	movea.l	linewk(a6),a1
	adda.l	#4112+12288,a1
	bsr	line_load3
	movea.l	linewk(a6),a1
	adda.l	#8,a1
	bsr	line_store
	swap	d6

	addq.l	#8,a0
	addq.w	#8,d6

	cmp.w	EX(a6),d6
	blt	loopx

loopxq:
	moveq.l	#0,d0

decode_end:
	movem.l	(sp)+,d1-d7/a0-a5
	unlk	a6
	rts


*
*	1 line (4dots) decode
*----------------------------------------------------------------
*	a1.l	line start address
*
line_load:
	LINE_LOAD	-4104-12288,-8208-12288*2,0

line_load2:
	LINE_LOAD	12312+12288*3,8208+12288*2,1

line_load3:
	LINE_LOAD	-4104-12288,8208+12288*2,0

*
*	wk -> graphic
*----------------------------------------------------------------
*
line_store:
	move.w	X(a6),d1

	move.l	a3,d2
	lea	4104+12288(a1),a3
	movea.l	a0,a2
	move.w	LPY(a6),d0
lslp:

	move.l	(a1)+,(a2)+
	move.l	(a3)+,(a2)+
	lea.l	0(a2,d1.w),a2

	dbra	d0,lslp
	movea.l	d2,a3
	rts


*----------------------------------------------------------------------------*
* e[u

make_tbl:
	lea	tbl(pc),a0
	moveq.l	#1,d2
	moveq.l	#16-1,d0
mtlpy:
	moveq.l	#15-1,d1
	move.b	d2,d3
mtlpx:
	andi.b	#$f,d3
	move.b	d3,(a0)+
	addq.w	#1,d3
	dbra	d1,mtlpx

	move.b	#0,(a0)+
	addq.b	#1,d2
	dbra	d0,mtlpy

	move.l	linewk(a6),a0
	adda.l	#(4096+2)*16,a0

	moveq	#0,d1
	.irp	reg,d2,d3,d4,d5,d6,d7,a1,a2,a3,a4,a5
		move.l	d1,reg
	.endm

								* (4096+2)*16 / 48 = 1366

	.rept 16
		movem.l	d1-d7/a1-a5,-(a0)		; 12
	.endm

	move.w	#(1366-16)/18-1,d0				* (1024+2)*16 / 48 = 342
								* 342/18
@@:
	.rept 18
		movem.l	d1-d7/a1-a5,-(a0)		; 12
	.endm
	dbra	d0,@b
	rts

*----------------------------------------------------------------------------*
* [NGA

*
*	decode work
*

hbitwk:
	dc.b	0,0,0,0
wkbuff:
	dc.b	0,0

*
*	color tbl
*

tbl:
	dcb.b	(15+1)*16,0


		end
