.comment comments *-------------------------------------------------------------*
|										|
|	Hyper Graphic Saver for over1024					|
|										|
|					original program by xtjh		|
|					rewrited program by Herzen		|
|										|
|				--         based on xhgs.has v1.80  --		|
|				--  modified for hg_save.has v1.02  --		|
comments *----------------------------------------------------------------------*

		.include	doscall.mac
		.include	mph.h
		.include	mph_lib.h
		.include	hg_save.h

		.xdef	_HGSave__

* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*
* HG(16)摜k
*
* in  Ȃ
*
* out d0.w =        0 : I
*            ȊO : G[R[h
*
* (l) 16/256Fɂ炸CPsNZPoCgD
*        zGRAMpłCGRAMk͂ȂD
*
*----------------------------------------------------------------------------*

_HGSave__:
	link	a6,#HG_SAVE_WORKSIZE
	movem.l	d2-d7/a0-a5,-(sp)

	move.l	_linewk_addr(a5),linewk(a6)	* linewk(a6)  linewk AhX
	move.l	_slidewk_addr(a5),slidewk(a6)	* slidewk(a6) slidewk AhX

	move.w	_colum(a5),EX+2(a6)		* EX+2(a6) 摜TCY
	move.w	_line(a5),EY+2(a6)		* EY+2(a6)     cTCY

	move.l	_save_addr(a5),B_BUFF(a6)	* B_BUFF(a6) rbgf[^[N
	move.l	_save_addr2(a5),H_BUFF(a6)	* H_BUFF(a6) n[toCgf[^[N

	movea.l	_buff_addr(a5),a0		* a0 = zGRAMAhX

	move.l	a5,-(sp)
	bsr	HGSave
	move.l	(sp)+,a5

	bsr	data_save			* HG ́Cwb_̈ƃf[^ꊇ
						* o͂Cs悢D

	movem.l	(sp)+,d2-d7/a0-a5
	unlk	a6
	rts

HGSave:
	move.w	EX+2(a6),next(a6)

	subq.w	#1,EX+2(a6)
	subq.w	#1,EY+2(a6)
	bsr	make_tbl

	moveq	#0,d5
	moveq	#0,d6
	move.l	#$0007_0007,d7

* ȍ~ a5 ͎gȂ.
	movea.l	B_BUFF(a6),a4
	movea.l	H_BUFF(a6),a5
	move.l	d5,(BS,a6)	;clr
	move.l	d5,(HS,a6)	;clr
encode_x:
	swap.w	d6

	bsr	linewk_set
	move.l	a0,-(sp)
	movea.l	linewk(a6),a1
	lea.l	40(a1),a1
	movea.l	slidewk(a6),a0
	lea.l	4096*2*2(a0),a0
	bsr	encode_y
	movea.l	linewk(a6),a1
	lea.l	44(a1),a1
	movea.l	slidewk(a6),a0
	lea.l	4096*2*3(a0),a0
	bsr	encode_y
	move.l	(sp)+,a0

	swap.w	d6

	addq.l	#8,a0		* Whbg

	addq.w	#8,d6

	bsr	lldisp

	cmp.w	EX+2(a6),d6
	blt	encode_x

	swap	d6
bslp:
	cmpi.b	#7,d7
	beq	hslp
	_BIT_STORE0
	bra	bslp

hslp:
	move.l	d7,d1
	swap	d1
	cmpi.b	#7,d1
	beq	HGsave_end
	_HBYTE_STORE0
	bra	hslp

HGsave_end:
	rts

*
*	OtBbNobt@ɃRs[
*----------------------------------------------------------------
*
linewk_set:
	movem.l	d5/a2-a5,-(sp)

	move.l	a0,-(sp)

	move.l	#-(32+4096*2*2),d5
	movea.l	linewk(a6),a1
	lea.l	40(a1),a1
	movea.l	slidewk(a6),a0
	lea.l	4096*2*2(a0),a0
	move.w	#4096/8-1,d0
@@:
	movem.l	(a0)+,d1-d4/a2-a5
	movem.l	d1-d4/a2-a5,(a0,d5.l)

	movem.l	(a1)+,d1-d4/a2-a5
	movem.l	d1-d4/a2-a5,-(32+8)(a1)
	movem.l	(a1)+,d1-d4/a2-a5
	movem.l	d1-d4/a2-a5,-(32+8)(a1)
	movem.l	(a1)+,d1-d4/a2-a5
	movem.l	d1-d4/a2-a5,-(32+8)(a1)
	movem.l	(a1)+,d1-d4/a2-a5
	movem.l	d1-d4/a2-a5,-(32+8)(a1)
	dbra	d0,@b

	move.l	(sp)+,a0

	movea.l	a0,a1
	movea.l	linewk(a6),a2
	lea.l	40(a2),a2
	movea.l	slidewk(a6),a3
	lea.l	4096*2*2(a3),a3
	movea.l	slidewk(a6),a4
	lea.l	4096*2*3(a4),a4
	move.w	EY+2(a6),d0
	move.w	next(a6),d3
@@:
	move.l	(a1),d1
	move.l	d1,(a2)+
	move.w	d1,d2
	swap.w	d1
	lsl.w	#4,d1
	or.w	d1,d2
	move.w	d2,(a3)+		; slide

	move.l	4(a1),d1
	move.l	d1,(a2)+
	move.w	d1,d2
	swap.w	d1
	lsl.w	#4,d1
	or.w	d1,d2
	move.w	d2,(a4)+		; slide

	addq.l	#8,a2
	add.w	d3,a1			*** GRAMΏۂł΁Clea.l 2048(a1),a1ƂȂƂ.
	dbra	d0,@b

	movem.l	(sp)+,d5/a2-a5
	rts


encode_y:
	move.w	#0,d4

loopy:
	move.w	#0,CS(a6)		; TCYNA
	lea	slide_wk(pc),a2

	move.w	EY+2(a6),d0
	sub.w	d4,d0
	cmpi.w	#2,d0
	blt	prs_p0
	cmpi.w	#4,d0
	blt	prs_p2
	cmpi.w	#8,d0
	blt	prs_p4
	cmpi.w	#16,d0
	blt	prs_p8
prs_p16:
	moveq.l	#46,d0
	_PRESS_COPY_CHECK		; ( -2,  16)
	moveq.l	#44,d0
	_PRESS_COPY_CHECK		; ( -1,  16)
prs_p8:
	moveq.l	#42,d0
	_PRESS_COPY_CHECK		; ( -2,   8)
	moveq.l	#40,d0
	_PRESS_COPY_CHECK		; ( -1,   8)
prs_p4:
	moveq.l	#38,d0
	_PRESS_COPY_CHECK		; ( -2,   4)
	moveq.l	#36,d0
	_PRESS_COPY_CHECK		; ( -1,   4)
prs_p2:
	moveq.l	#34,d0
	_PRESS_COPY_CHECK		; ( -2,   2)
	moveq.l	#32,d0
	_PRESS_COPY_CHECK		; ( -1,   2)

prs_p0:
	move.w	d4,d0

	cmp.w	#1,d0
	blt	prs_m0
	cmp.w	#2,d0
	blt	prs_m1
	cmp.w	#4,d0
	blt	prs_m2
	cmp.w	#8,d0
	blt	prs_m4
	cmp.w	#16,d0
	blt	prs_m8
prs_m16:
	moveq.l	#30,d0
	_PRESS_COPY_CHECK		; ( -2, -16)
	moveq.l	#28,d0
	_PRESS_COPY_CHECK		; ( -1, -16)
	moveq.l	#26,d0
	_PRESS_COPY_CHECK		; (  0, -16)
prs_m8:
	moveq.l	#24,d0
	_PRESS_COPY_CHECK		; ( -2,  -8)
	moveq.l	#22,d0
	_PRESS_COPY_CHECK		; ( -1,  -8)
	moveq.l	#20,d0
	_PRESS_COPY_CHECK		; (  0,  -8)
prs_m4:
	moveq.l	#18,d0
	_PRESS_COPY_CHECK		; ( -2,  -4)
	moveq.l	#16,d0
	_PRESS_COPY_CHECK		; ( -1,  -4)
	moveq.l	#14,d0
	_PRESS_COPY_CHECK		; (  0,  -4)
prs_m2:
	moveq.l	#12,d0
	_PRESS_COPY_CHECK		; ( -2,  -2)
	moveq.l	#10,d0
	_PRESS_COPY_CHECK		; ( -1,  -2)
	moveq.l	#8,d0
	_PRESS_COPY_CHECK		; (  0,  -2)
prs_m1:
	moveq.l	#6,d0
	_PRESS_COPY_CHECK		; (  0,  -1)
prs_m0:
	moveq.l	#4,d0
	_PRESS_COPY_CHECK		; ( -2,   0)
	moveq.l	#2,d0
	_PRESS_COPY_CHECK		; ( -1,   0)

	cmpi.w	#2,CS(a6)
	blt	col_encode

*
*	XChZbg
*----------------------------------------------------------------
*
slide:
	_BIT_STORE1			; rkhcd

	move.w	CS(a6),d0

	moveq.l	#0,d1
	add.w	d0,d4			; xWXV
	move.w	d0,d1
	add.w	d1,d1
	lea	(a0,d1.w),a0
	lsl.l	#3,d1
	lea	(a1,d1.l),a1		; obt@ʒuXV

	subq.w	#1,d0
	move.w	d0,d1
	moveq.l	#0,d2
sllp0:
	lsr.w	#1,d1
	beq	@f
	addq.w	#1,d2
	bra	sllp0

@@:
	move.w	d2,d3			; [vJE^[ۑ
*	tst.w	d2	; ʂ
	beq	nc			; Q copy

	subq.w	#1,d2
c0:
*	addx.b	d1,d1			* Ȃ. ƋtɌ듮̉\. by Herzen
	_BIT_STORE0
	dbra	d2,c0

nc:
	add.w	d0,d0
	bpl	nc			; bgt(bge) ͎gĂ͂Ȃ

sllp1:
	addx.w	d0,d0
	_BIT_STORE
	dbra	d3,sllp1

	lea	slide_data(pc),a3
	adda.w	CD(a6),a3		; bit data address (size, data)
	moveq.l	#0,d0
	move.b	(a3)+,d0		; loop-size
	move.b	(a3)+,d1
sllp2:
	addx.b	d1,d1
	_BIT_STORE
	dbra	d0,sllp2

	bra	end_y

*
*	J[kZbg
*----------------------------------------------------------------
*
col_encode:
	_BIT_STORE0			; J[k

	moveq.l	#4-1,d3
col_encode_lp:
	moveq.l	#0,d0			; J[\
	move.b	-32(a1),d0	; b
	cmp.b	-16(a1),d0	; a
	beq	col_ok

	cmp.b	-34(a1),d0	; f
	bne	col_chk1
	cmp.b	-2(a1),d0	; d
	beq	col_ok

col_chk1:
	move.b	-1(a1),d0	; c
	cmp.b	-2(a1),d0	; d
	beq	col_ok

	move.b	-17(a1),d0	; e
col_ok:
	move.b	(a1)+,d2	; ۂ̐F
	cmp.b	d2,d0
	beq	col_encset	; \zƓ

	lsl.w	#4,d0
	lea	tbl(pc),a2
	lea	(a2,d0.w),a2	; e[u̐擪AhX
	movea.l	a2,a3

	moveq.l	#0,d1
cslp:
	addq.w	#1,d1
	cmp.b	(a3)+,d2
	bne	cslp

	subq.w	#1,d1
	beq	col_set

	subq.w	#1,d1
cslp2:
	move.b	(a2),d0
	move.b	d2,(a2)+
	move.b	d0,d2
	_BIT_STORE0
	dbra	d1,cslp2

	move.b	d2,(a2)+

col_set:
	moveq.l	#$ff,d0
	addx.b	d0,d0
	_BIT_STORE

col_encset:
	addx.w	d0,d0
	_HBYTE_STORE

	dbra	d3,col_encode_lp

	addq.w	#2,a0
	lea	12(a1),a1
	addq.w	#1,d4

********

end_y:
	cmp.w	EY+2(a6),d4
	ble	loopy

	rts


*----------------------------------------------------------------------------*
* J[e[ȕ

make_tbl:
	movem.l	d0-d7/a0-a5,-(sp)
	lea	tbl(pc),a0
	moveq.l	#1,d2
	moveq.l	#16-1,d0
mtlpy:
	moveq.l	#15-1,d1
	move.b	d2,d3
mtlpx:
	andi.b	#$f,d3
	move.b	d3,(a0)+
	addq.w	#1,d3
	dbra	d1,mtlpx

	move.b	#0,(a0)+
	addq.b	#1,d2
	dbra	d0,mtlpy

	move.l	linewk(a6),a0
	adda.l	#(4096+2)*16,a0

	moveq	#0,d1
	.irp	reg,d2,d3,d4,d5,d6,d7,a1,a2,a3,a4,a5
		move.l	d1,reg
	.endm

								* (4096+2)*16 / 48 = 1366

	rept 16
		movem.l	d1-d7/a1-a5,-(a0)		; 12
	endm

	move.w	#(1366-16)/18-1,d0				* (1024+2)*16 / 48 = 342
								* 342/18
@@:
	rept 18
		movem.l	d1-d7/a1-a5,-(a0)		; 12
	endm
	dbra	d0,@b

	move.l	slidewk(a6),a0
	adda.l	#4096*4*4,a0
	move.w	#4096-1,d0
@@:
	movem.l	d1-d4,-(a0)
	dbra	d0,@b

	movem.l	(sp)+,d0-d7/a0-a5
	rts


*----------------------------------------------------------------------------*
* f[^Z[u
*----------------------------------------------------------------------------*

* a5 ͎gp\łD

data_save:
	lea.l	_commentx(a5),a2

	move.l	#'HG2.',(a2)+		* wb_
	move.b	#'0',(a2)+
	move.b	#13,(a2)+
	move.b	#10,(a2)+

	lea.l	_comment(a5),a1		* Rg
clp:	move.b	(a1)+,d0
	bne	@f
	moveq.l	#$1a,d0
@@:	move.b	d0,(a2)+
	cmp.b	#$1a,d0
	bne	clp

	move.w	_scolum(a5),d0		* sx,syiFn_Włj
	lsr.w	#3,d0
	move.b	d0,(a2)+
	ror.w	#8,d0
	move.b	d0,(a2)+
	move.w	_sline(a5),d0
	move.b	d0,(a2)+
	ror.w	#8,d0
	move.b	d0,(a2)+

	move.w	_colum(a5),d0		* ex,eyiFTCYłj
	lsr.w	#3,d0
	move.b	d0,(a2)+
	ror.w	#8,d0
	move.b	d0,(a2)+
	move.w	_line(a5),d0
	move.b	d0,(a2)+
	ror.w	#8,d0
	move.b	d0,(a2)+

	lea.l	_pal_buf(a5),a1		* pbg
	moveq.l	#16-1,d1
@@:
	move.w	(a1)+,d0
	move.b	d0,(a2)+
	ror.w	#8,d0
	move.b	d0,(a2)+
	dbra	d1,@b

	move.l	BS(a6),d0
	moveq.l	#2,d1

sglp:
	cmpi.l	#$8000,d0		; TCY
	blt	@f
	addq.w	#2,d1
	subi.l	#$8000,d0
	move.b	#0,(a2)+
	move.b	#0,(a2)+
	bra	sglp
@@:
	move.b	d0,(a2)+
	ror.w	#8,d0
	move.b	d0,(a2)+

	moveq.l	#2,d6
	move.w	#%100000,-(sp)
	pea.l	_dstfile(a5)
	DOS	_CREATE
	addq.w	#6,sp
	tst.l	d0
	bmi	file_err
	move.w	d0,d7			; file handle

	move.l	a2,d1
	lea.l	_commentx(a5),a0
	sub.l	a0,d1
	move.l	d1,-(sp)
	pea.l	_commentx(a5)
	move.w	d7,-(sp)
	DOS	_WRITE		* ܂ł̃wb_o
	lea	10(sp),sp
	moveq.l	#4,d6
	tst.l	d0
	bmi	file_err
	moveq.l	#7,d6
	cmp.l	d1,d0
	bne	file_err

	move.l	BS(a6),d1
	move.l	d1,-(sp)
	move.l	B_BUFF(a6),-(sp)
	move.w	d7,-(sp)
	DOS	_WRITE			; bit data write
	lea	10(sp),sp
	moveq.l	#4,d6
	tst.l	d0
	bmi	file_err
	moveq.l	#7,d6
	cmp.l	d0,d1
	bne	file_err

	move.l	HS(a6),d1
	move.l	d1,-(sp)
	move.l	H_BUFF(a6),-(sp)
	move.w	d7,-(sp)
	DOS	_WRITE			; half byte data write
	lea	10(sp),sp
	moveq.l	#4,d6
	tst.l	d0
	bmi	file_err
	moveq.l	#7,d6
	cmp.l	d0,d1
	bne	file_err

	move.w	d7,-(sp)
	DOS	_CLOSE
	addq.l	#2,sp

	moveq.l	#0,d0
	rts

*----------------------------------------------------------------------------*
* XChRs[f[^
*----------------------------------------------------------------------------*

slide_wk:
	dc.w      0*2-0*4096*2		;  0 (      )
	dc.w	  0*2-1*4096*2		;  2 (-1,  0)
	dc.w	  0*2-2*4096*2		;  4 (-2,  0)
	dc.w	 -1*2-0*4096*2		;  6 ( 0, -1)
	dc.w	 -2*2-0*4096*2		;  8 ( 0, -2)
	dc.w	 -2*2-1*4096*2		; 10 (-1, -2)
	dc.w	 -2*2-2*4096*2		; 12 (-2, -2)
	dc.w	 -4*2-0*4096*2		; 14 ( 0, -4)
	dc.w	 -4*2-1*4096*2		; 16 (-1, -4)
	dc.w	 -4*2-2*4096*2		; 18 (-2, -4)
	dc.w	 -8*2-0*4096*2		; 20 ( 0, -8)
	dc.w	 -8*2-1*4096*2		; 22 (-1, -8)
	dc.w	 -8*2-2*4096*2		; 24 (-2, -8)
	dc.w	-16*2-0*4096*2		; 26 ( 0,-16)
	dc.w	-16*2-1*4096*2		; 28 (-1,-16)
	dc.w	-16*2-2*4096*2		; 30 (-2,-16)
	dc.w	  2*2-1*4096*2		; 32 (-1,  2)
	dc.w	  2*2-2*4096*2		; 34 (-2,  2)
	dc.w	  4*2-1*4096*2		; 36 (-1,  4)
	dc.w	  4*2-2*4096*2		; 38 (-2,  4)
	dc.w	  8*2-1*4096*2		; 40 (-1,  8)
	dc.w	  8*2-2*4096*2		; 42 (-2,  8)
	dc.w	 16*2-1*4096*2		; 44 (-1, 16)
	dc.w	 16*2-2*4096*2		; 46 (-2, 16)

slide_wk2:
	dc.w	  0			;  0 (      )
	dc.w	  0			;  2 (-1,  0)
	dc.w	  0			;  4 (-2,  0)
	dc.w	  0			;  6 ( 0, -1)
	dc.w	  0			;  8 ( 0, -2)
	dc.w	  0			; 10 (-1, -2)
	dc.w	  0			; 12 (-2, -2)
	dc.w	  0			; 14 ( 0, -4)
	dc.w	  0			; 16 (-1, -4)
	dc.w	  0			; 18 (-2, -4)
	dc.w	  0			; 20 ( 0, -8)
	dc.w	  0			; 22 (-1, -8)
	dc.w	  0			; 24 (-2, -8)
	dc.w	  0			; 26 ( 0,-16)
	dc.w	  0			; 28 (-1,-16)
	dc.w	  0			; 30 (-2,-16)
	dc.w	  2			; 32 (-1,  2)
	dc.w	  2			; 34 (-2,  2)
	dc.w	  4			; 36 (-1,  4)
	dc.w	  4			; 38 (-2,  4)
	dc.w	  8			; 40 (-1,  8)
	dc.w	  8			; 42 (-2,  8)
	dc.w	 16			; 44 (-1, 16)
	dc.w	 16			; 46 (-2, 16)

slide_data:
	dc.b	0-1,%00000000	;			;  0 (      )
	dc.b	4-1,%10000000	;	1,0,0,0		;  2 (-1,  0)
	dc.b	4-1,%11000000	;	1,1,0,0		;  4 (-2,  0)
	dc.b	2-1,%00000000	;	0,0		;  6 ( 0, -1)
	dc.b	3-1,%01000000	;	0,1,0		;  8 ( 0, -2)
	dc.b	5-1,%10010000	;	1,0,0,1,0	; 10 (-1, -2)
	dc.b	5-1,%11010000	;	1,1,0,1,0	; 12 (-2, -2)
	dc.b	4-1,%01100000	;	0,1,1,0		; 14 ( 0, -4)
	dc.b	6-1,%10011000	;	1,0,0,1,1,0	; 16 (-1, -4)
	dc.b	6-1,%11011000	;	1,1,0,1,1,0	; 18 (-2, -4)
	dc.b	5-1,%01110000	;	0,1,1,1,0	; 20 ( 0, -8)
	dc.b	7-1,%10011100	;	1,0,0,1,1,1,0	; 22 (-1, -8)
	dc.b	7-1,%11011100	;	1,1,0,1,1,1,0	; 24 (-2, -8)
	dc.b	5-1,%01111000	;	0,1,1,1,1	; 26 ( 0,-16)
	dc.b	7-1,%10011110	;	1,0,0,1,1,1,1	; 28 (-1,-16)
	dc.b	7-1,%11011110	;	1,1,0,1,1,1,1	; 30 (-2,-16)
	dc.b	5-1,%10110000	;	1,0,1,1,0	; 32 (-1,  2)
	dc.b	5-1,%11110000	;	1,1,1,1,0	; 34 (-2,  2)
	dc.b	6-1,%10111000	;	1,0,1,1,1,0	; 36 (-1,  4)
	dc.b	6-1,%11111000	;	1,1,1,1,1,0	; 38 (-2,  4)
	dc.b	7-1,%10111100	;	1,0,1,1,1,1,0	; 40 (-1,  8)
	dc.b	7-1,%11111100	;	1,1,1,1,1,1,0	; 42 (-2,  8)
	dc.b	7-1,%10111110	;	1,0,1,1,1,1,1	; 44 (-1, 16)
	dc.b	7-1,%11111110	;	1,1,1,1,1,1,1	; 46 (-2, 16)
	even

*----------------------------------------------------------------------------*
* e[u[N

tbl:
	dcb.b	(15+1)*16,0


*----------------------------------------------------------------------------*
* Z[uoߕ
*----------------------------------------------------------------------------*

lldisp:
		movem.l	d0-d1,-(sp)

		moveq.l	#1,d0
		add.w	EX+2(a6),d0
		move.w	d0,d1
		sub.w	d6,d1

		bsr	line_disp

		movem.l	(sp)+,d0-d1
		rts


*----------------------------------------------------------------------------*
* G[
*----------------------------------------------------------------------------*

file_err:
		move.l	d6,d0
		rts


		.end
