.comment comments *-------------------------------------------------------------*
|										|
|	MAG(16/256) Graphic Saver for over1024/512				|
|										|
|					original program by W-RINN		|
|					rewrited program by Herzen		|
|										|
|				--          based on MAGSV.S v1.10  --		|
|				-- modified for mag_save.has v2.01  --		|
comments *----------------------------------------------------------------------*

		.include	doscall.mac
		.include	mph.h
		.include	mph_lib.h

		.xdef	_MAGSave__
		.xdef	mag_memchk__

* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*
* MAG(16/256)摜k
*
* in  Ȃ
*
* out d0.w =        0 : I
*            ȊO : G[R[h
*
* (l) 16/256Fɂ炸CPsNZPoCgD
*        zGRAMpłCGRAMk͂ȂD
*
*----------------------------------------------------------------------------*

_MAGSave__:
		movem.l	d3-d7/a3-a6,-(sp)
		movea.l	_save_addr(a5),a6	* a6 = [NZbg
		cmp.w	#8,_color(a5)
		beq	@f
* 16F摜p
		move.l	_buff_addr(a5),d0
		move.w	_colum(a5),d1
		mulu.w	_line(a5),d1
		lsr.l	#1,d1			* 2Ŋ
		add.l	d1,d0
		add.l	#1024,d0		* Ô߁D
		and.b	#%1111_0000,d0		* .quad
		move.l	d0,a6			* a6 = [NZbg
		bsr	mag_byte2halfbyte	* 1pixel1byte => 2pixel1byte
@@:
		bsr	MAGSave
		movem.l	(sp)+,d3-d7/a3-a6
		rts

MAGSave:
		clr.w	file(a6)
		bsr	MAGSaveX
		rts

MAGSaveX:
		move.l	sp,stk(a6)

		bsr	mag_head_write

		cmp.w	#8,_color(a5)
		beq	1f
* 16F
		moveq.l	#0,d0
		move.w	_colum(a5),d0
		lsr.l	#1,d0
		move.l	d0,xnext(a6)

		lea.l	flag_a_size(a6),a0
		move.l	#0,(a0)+
		move.l	#32+48,(a0)+
		move.l	#32+48,(a0)+
		move.l	#0,(a0)+
		move.l	#32+48,(a0)+
		move.l	#0,(a0)+

		move.w	_scolum(a5),d0
		move.w	_ecolum(a5),d1
		lsr.w	#3,d0
		lsr.w	#3,d1
		sub.w	d0,d1
		move.w	d1,savesize_x(a6)	* w[v

		bra	cont01
* 256F
1:
		moveq.l	#0,d0
		move.w	_colum(a5),d0
		move.l	d0,xnext(a6)

		lea.l	flag_a_size(a6),a0
		move.l	#0,(a0)+
		move.l	#32+768,(a0)+
		move.l	#32+768,(a0)+
		move.l	#0,(a0)+
		move.l	#32+768,(a0)+
		move.l	#0,(a0)+

		move.w	_scolum(a5),d0
		move.w	_ecolum(a5),d1
		lsr.w	#2,d0
		lsr.w	#2,d1
		sub.w	d0,d1
		move.w	d1,savesize_x(a6)	* w[v

cont01:
		move.w	_sline(a5),d2
		move.w	_eline(a5),d1
		sub.w	d2,d1
		move.w	d1,savesize_y(a6)	* x[v

		move.l	a5,-(sp)
			move.l	_buff_addr(a5),d0
			movea.l	d0,a5
			bsr	search_pixel
		move.l	(sp)+,a5
		bsr	flag_encode

		bsr	datasave

		moveq.l	#0,d0
		rts


*----------------------------------------------------------------------------*
*
* MAGwb_o
*
* in  Ȃ
*
* out d0.w =        0 : 
*            ȊO : G[R[h
*     d5.w = t@Cnh
*
* (l) Ewb_̓XN[[htO܂łoD
*        E_comment(a5) 𐴏Ă邱ƁD
*
*----------------------------------------------------------------------------*

mag_head_write:
		lea.l	_commentx(a5),a0

		move.w	#$20,-(sp)
		pea.l	_dstfile(a5)
		DOS	_CREATE
		addq.l	#6,sp
		moveq.l	#2,d6
		move.w	d0,d5
		bmi	file_error
		move.w	d0,file(a6)

		move.l	#'MAKI',(a0)+
		move.l	#'02  ',(a0)+

		lea.l	_comment(a5),a1
		cmp.l	#'MAKI',(a1)
		bne	@f
		cmp.l	#'02  ',4(a1)
		bne	@f
		addq.l	#8,a1
@@:		bsr	strcpy
		move.b	#26,(a0)+

		move.b	#0,(a0)+	* wb_̐擪
		move.b	#0,(a0)+	* @R[h		* 98/68 0 ł.( PST)
		move.b	#0,(a0)+	* @ˑtO

		moveq.l	#0,d0
		tst.b	_200flag(a5)
		beq	@f
		bset.l	#0,d0		* n[t(200line)tOZbg
@@:		cmp.w	#8,_color(a5)
		bne	@f
		bset.l	#7,d0		* 256FtOZbg
@@:		move.b	d0,(a0)+	* XN[[htO

		move.w	_scolum(a5),d0
		move.b	d0,(a0)+
		ror.w	#8,d0		* to intel
		move.b	d0,(a0)+
		move.w	_sline(a5),d0
		move.b	d0,(a0)+
		ror.w	#8,d0		* to intel
		move.b	d0,(a0)+
		move.w	_ecolum(a5),d0
		move.b	d0,(a0)+
		ror.w	#8,d0		* to intel
		move.b	d0,(a0)+
		move.w	_eline(a5),d0
		move.b	d0,(a0)+
		ror.w	#8,d0		* to intel
		move.b	d0,(a0)+

		move.l	a0,d1
		lea.l	_commentx(a5),a0
		sub.l	a0,d1
		move.l	d1,-(sp)
		pea.l	_commentx(a5)
		move.w	d5,-(sp)
		DOS	_WRITE		܂ł̃wb_o
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error
		lea	10(sp),sp

		moveq.l	#0,d0
		rts


*----------------------------------------------------------------------------*
*
* 16/256摜kC
*
*----------------------------------------------------------------------------*

*----------------------------------------------------------------------------*
* sNZf[^TAΈʒutOɋL^

search_pixel:
**	lea.l	flag_b(a6),a1	* flag_a ̉̕NA
	movea.l	a6,a1
	adda.l	#flag_b-worktop,a1
	moveq.l	#1,d1
	move.w	#80*4-1,d0
@@:	move.w	d1,-(a1)
	dbra	d0,@b

**	lea.l	flag_b(a6),a1
	movea.l	a6,a1
	adda.l	#flag_b-worktop,a1
	movea.l	a6,a2
	adda.l	#pixel-worktop,a2

	suba.l	a4,a4
	moveq.l	#1,d6
	add.w	savesize_x(a6),d6
	add.l	d6,d6
	sub.l	d6,a4			* a4 = -160 : ̃tO

	move.w	savesize_y(a6),d5
	moveq.l	#0,d3
l_10:
	movea.l	a5,a0
	moveq.l	#0,d4
	moveq.l	#1,d6
	add.w	savesize_x(a6),d6
	add.w	savesize_x(a6),d6
l_11:
	move.w	(a0),d0		* ׂ͒鏇ԂŃtÖkς܂

	move.b	(a1,a4.l),d1	* ܂̃tOƓɂȂȂׂ
	and.w	#$0F,d1
	tst.w	d1
	beq	skip_01		* if d1=0 break
	add.w	d1,d1
	add.w	d1,d1
**	lsl.w	#2,d1
	lea.l	j_tbl(pc),a3
	move.l	(a3,d1.w),d1
	jsr	(a3,d1.l)
skip_01:
	bsr	j_01
	bsr	j_04
	bsr	j_05
	bsr	j_06
	bsr	j_07
	bsr	j_09
	bsr	j_10
	bsr	j_02
	bsr	j_08
	bsr	j_11
	bsr	j_12
	bsr	j_13
	bsr	j_14
	bsr	j_03
	bsr	j_15
	move.w	d0,(a2)+	* sNZ͖sNZf[^܂B
	move.b	#0,d1
tstpxl_end:
	move.b	d1,(a1)+	* tOf[^܂B
	addq.l	#2,a0
	addq.l	#1,d4
	dbra	d6,l_11

	adda.l	xnext(a6),a5
**	lea.l	512(a5),a5
	addq.l	#1,d3
	bsr	ldisp
	dbra	d5,l_10

	movea.l	a6,a0
	adda.l	#pixel-worktop,a0
	suba.l	a0,a2
	move.l	a2,pixel_size(a6)	* pixel size
	rts

*-------ǂɓsNZȂׂ}N--------------------------
tstpxl: macro	no,xoffs,yoffs
	local	tstpxl_next

	lea.l	(a0),a3			* obt@AhX
	move.l	d0,-(sp)
	move.l	xnext(a6),d0
	mulu.w	#yoffs,d0
	add.l	#xoffs*2,d0
	sub.l	d0,a3
	movem.l	(sp)+,d0
**	add.l	#yoffs*512+xoffs*2,a3
	cmp.w	(a3),d0
	bne	tstpxl_next

	cmp.w	#xoffs,d4		* NbsO
	blt	tstpxl_next
	cmp.w	#yoffs,d3
	blt	tstpxl_next

	move.b	#no,d1
	addq.l	#4,sp
	pea.l	tstpxl_end(pc)		* ^[AhXύX
tstpxl_next:
	rts
	endm
*----------------------------------------
j_01:	tstpxl	01,1,0
j_02:	tstpxl	02,2,0
j_03:	tstpxl	03,4,0
j_04:	tstpxl	04,0,1
j_05:	tstpxl	05,1,1
j_06:	tstpxl	06,0,2
j_07:	tstpxl	07,1,2
j_08:	tstpxl	08,2,2
j_09:	tstpxl	09,0,4
j_10:	tstpxl	10,1,4
j_11:	tstpxl	11,2,4
j_12:	tstpxl	12,0,8
j_13:	tstpxl	13,1,8
j_14:	tstpxl	14,2,8
j_15:	tstpxl	15,0,16

*-------Wve[u----------------
	.even
j_tbl:	dc.l	0,j_01-j_tbl,j_02-j_tbl,j_03-j_tbl
	dc.l	j_04-j_tbl,j_05-j_tbl,j_06-j_tbl,j_07-j_tbl
	dc.l	j_08-j_tbl,j_09-j_tbl,j_10-j_tbl,j_11-j_tbl
	dc.l	j_12-j_tbl,j_13-j_tbl,j_14-j_tbl,j_15-j_tbl
	.text
	.even

*----------------------------------------------------------------------------*
* tOf[^̈k

flag_encode:
	moveq.l	#1,d0
	move.l	d0,d1
	add.w	savesize_x(a6),d0
	add.w	savesize_y(a6),d1
	mulu	d1,d0			* 640*80
	add.l	d0,d0			* * 2
	movea.l	a6,a1
	adda.l	#flag_b-worktop,a1
**	lea.l	flag_b(a6),a1
	add.l	d0,a1

	suba.l	a4,a4
	moveq.l	#1,d6
	add.w	savesize_x(a6),d6
	add.l	d6,d6
	sub.l	d6,a4			* a4 = -160 : ̃tO

	move.w	savesize_y(a6),d5
	beq	l_22
	sub.w	#1,d5
l_20:	move.w	savesize_x(a6),d6
l_21:	move.w	-2(a1,a4.l),d0
	eor.w	d0,-(a1)		* PxorB
	dbra	d6,l_21
	dbra	d5,l_20
l_22:
	moveq.l	#0,d0			* 炩߃tO`SNA
	lea.l	flag_a(a6),a0
	move.w	#flagAsize_max/4-1,d5
l_23:	move.l	d0,(a0)+
	dbra	d5,l_23
*---------------------------------------
	lea.l	flag_a(a6),a0
	movea.l	a6,a1
	adda.l	#flag_b-worktop,a1
	movea.l	a1,a2
**	lea.l	flag_b(a6),a1	* ǂݏo
**	lea.l	flag_b(a6),a2	* o
	moveq.l	#0,d7		* d7:rbgANZXp

	move.w	savesize_y(a6),d5
l_24:	move.w	savesize_x(a6),d6
l_25:
	subq.l	#1,d7
	and.b	#%111,d7

	move.w	(a1)+,d0
	move.w	d0,d1
	and.w	#$F00,d0
	and.b	#$00F,d1
	lsr.w	#4,d0
	or.b	d1,d0		* tOQǂݏo

	tst.b	d0
	beq	l_26
	bset.b	d7,(a0)		* Oł͂Ȃ
	move.b	d0,(a2)+
l_26:
	tst.b	d7
	beq	l_28
	dbra	d6,l_25
	dbra	d5,l_24
	addq.l	#1,a0		* flag_a oCgxŏIȂ
	bra	l_29
l_28:
	addq.l	#1,a0
	dbra	d6,l_25
	dbra	d5,l_24
*---------------------------------------
b_check	macro	reg		* o_p}N
	local	skip
	btst.l	#0,reg
	beq	skip
	addq.l	#1,d0
skip:
	endm
l_29:
	move.l	a0,d0			* flag_a_size
	lea.l	flag_a(a6),a1
	sub.l	a1,d0
	b_check	d0
	move.l	d0,flag_a_size(a6)
	add.l	d0,flag_b_offs(a6)
	add.l	d0,pixel_offs(a6)

	move.l	a2,d0			* flag_b_size
	movea.l	a6,a1
	adda.l	#flag_b-worktop,a1
**	lea.l	flag_b(a6),a1
	sub.l	a1,d0
	b_check	d0
	move.l	d0,flag_b_size(a6)
	add.l	d0,pixel_offs(a6)
	rts

*----------------------------------------------------------------------------*
* Ce`g[`
*
intel_w:
	move.w	(a0),d0
	rol.w	#8,d0
	move.w	d0,(a0)+
	rts
intel_l:
	move.l	(a0),d0		* 1 2 3 4
	rol.w	#8,d0		* 1 2 4 3
	swap	d0		* 4 3 1 2
	rol.w	#8,d0		* 4 3 2 1
	move.l	d0,(a0)+
	rts

*----------------------------------------------------------------------------*
* pbg̎擾

getpalette:
	lea.l	_pal_buf(a5),a1
	moveq.l	#1,d6
	move.w	_color(a5),d0
	lsl.l	d0,d6
	subq.w	#1,d6
getp00:
	move.w	(a1)+,d1
	move.w	d1,d0
	lsr.w	#8,d0
	bsr	getp01
	move.w	d1,d0
	lsr.w	#3,d0
	bsr	getp01
	move.w	d1,d0
	lsl.w	#2,d0
	bsr	getp01
	dbra	d6,getp00
	rts
getp01:
	and.b	#%11111000,d0
	tst.b	d0
	beq	getp02
	or.b	#%00000111,d0
getp02:	move.b	d0,(a0)+
	rts

*----------------------------------------------------------------------------*
* f[^Z[u

datasave:
		moveq.l	#4,d6		* ݎs

						* tOZ[u
		lea.l	flag_data(pc),a0
		lea.l	flag_a_offs(a6),a1
		move.l	(a1)+,(a0)+
		move.l	(a1)+,(a0)+
		move.l	(a1)+,(a0)+
		move.l	(a1)+,(a0)+
		move.l	(a1),(a0)

		lea.l	flag_data(pc),a0
		bsr	intel_l
		bsr	intel_l
		bsr	intel_l
		bsr	intel_l
		bsr	intel_l

		moveq.l	#4*5,d1
		move.l	d1,-(sp)
		pea.l	flag_data(pc)
		move.w	file(a6),-(sp)
		DOS	_WRITE
		tst.l	d0
		bmi	file_error
		cmp.l	d1,d0
		bne	save_error
		lea	10(sp),sp

						* pbgZ[u

		lea.l	_tmp(a5),a0
		bsr	getpalette
		moveq.l	#1,d1
		move.w	_color(a5),d0
		lsl.w	d0,d1
		mulu.w	#3,d1
		move.l	d1,-(sp)
		pea.l	_tmp(a5)
		move.w	file(a6),-(sp)
		DOS	_WRITE
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error
		cmp.l	d1,d0
		bne	save_error
		lea	10(sp),sp

						* 摜Z[u

		move.l	flag_a_size(a6),d1	* tO`
		move.l	d1,-(sp)
		pea.l	flag_a(a6)
		move.w	file(a6),-(sp)
		DOS	_WRITE
		tst.l	d0
		bmi	file_error
		cmp.l	d1,d0
		bne	save_error
		lea	10(sp),sp

		move.l	flag_b_size(a6),d1	* tua
		move.l	d1,-(sp)
		movea.l	a6,a0
		adda.l	#flag_b-worktop,a0
		move.l	a0,-(sp)
		move.w	file(a6),-(sp)
		DOS	_WRITE
		tst.l	d0
		bmi	file_error
		cmp.l	d1,d0
		bne	save_error
		lea	10(sp),sp

		move.l	pixel_size(a6),d1	* sNZ
		move.l	d1,-(sp)
		movea.l	a6,a0
		adda.l	#pixel-worktop,a0
		move.l	a0,-(sp)
		move.w	file(a6),-(sp)
		DOS	_WRITE
		tst.l	d0
		bmi	file_error
		cmp.l	d1,d0
		bne	save_error
		lea	10(sp),sp

		move.w	file(a6),-(sp)
		DOS	_CLOSE
		addq.l	#2,sp

		moveq.l	#0,d0
		rts

flag_data:
	dc.l	80		* flag_a offset
	dc.l	80		* flag_b offset
	dc.l	0		* flag_b size
	dc.l	80		* pixel  offset
	dc.l	0		* pixel  size


*----------------------------------------------------------------------------*
* `FbN
*----------------------------------------------------------------------------*
* 16F摜pD
* ǂ邽߂̏uD

mag_memchk__:
	movem.l	d0-d2,-(sp)
	move.w	_colum(a5),d2
	mulu.w	_line(a5),d2
	lsr.l	#1,d2			* 2Ŋ
	clr.w	_locate_err(a5)
	move.l	_buff_size(a5),d0
	sub.l	d2,d0
	move.l	#workend-worktop,d1
	cmp.l	d1,d0
	bhi	@f
	st.b	_locate_err(a5)
@@:	movem.l	(sp)+,d0-d2
	rts


*----------------------------------------------------------------------------*
* oCg  n[toCg
*----------------------------------------------------------------------------*
* 16F摜pD

mag_byte2halfbyte:
	movem.l	d0-d2/a0-a1,-(sp)
* -- 2pixel1byte ɕϊ.
	movea.l	_buff_addr(a5),a0
	movea.l	a0,a1
	move.w	_colum(a5),d2
	mulu.w	_line(a5),d2
	lsr.l	#2,d2			* 4Ŋ
l_01:								* vNbN
	move.l	(a0)+,d0					* 12
	move.l	d0,d1						* 4
	lsr.l	#4,d1						* 16
	or.l	d1,d0						* 8
	move.l	d0,d1						* 4
	swap.w	d1						* 4
	move.b	d1,-(sp)					* 8
	move.w	(sp)+,d1					* 8
	move.b	d0,d1						* 4
	move.w	d1,(a1)+					* 8
								* v92
	dbra	d2,l_01
	clr.w	d2
	subq.l	#1,d2
	bcc	l_01
	movem.l	(sp)+,d0-d2/a0-a1
	rts


*----------------------------------------------------------------------------*
* Z[uoߕ
*----------------------------------------------------------------------------*

ldisp:
		movem.l	d0-d1,-(sp)
		move.w	savesize_y(a6),d0
		addq.w	#1,d0
		move.w	d5,d1
		bsr	line_disp
		movem.l	(sp)+,d0-d1
		rts


*----------------------------------------------------------------------------*
* G[
*----------------------------------------------------------------------------*

file_error			* t@CG[
Eo
		move.l	d6,d0
		clr.w	file(a6)
		move.l	stk(a6),sp
		rts

save_error			* fBXNς
		moveq.l	#7,d0
		clr.w	file(a6)
		move.l	stk(a6),sp
		rts


*----------------------------------------------------------------------------*
* ItZbg
*----------------------------------------------------------------------------*

flagAsize_max = (128*1024/8)*2

	.offset 0
worktop:
stk:		.ds.l	1
flag_a_size:	.ds.l	1
flag_a_offs:	.ds.l	1
flag_b_offs:	.ds.l	1
flag_b_size:	.ds.l	1
pixel_offs:	.ds.l	1
pixel_size:	.ds.l	1
file:		.ds.w	1
reserve:	.ds.w	1
xnext:		.ds.l	1

savesize_x:	ds.w	1
savesize_y:	ds.w	1
flag_a:		ds.b	flagAsize_max	* 128*1024/8=$4000
flag_b:		ds.b	(128*1024*2)*2	* 128*1024  =$20000 ̍Xɔ{Fj
pixel:		ds.b	(128*16*4)*2	* 128*16  *4=$2000 temp ƂPUsdȂȂ΂nj
					* ꂮ炢΂낤iKȓzHerzenj
workend:
	.text

		.end
