*-
*
*	1024hbgΉ16F摜Ro[^ < MPH3 > ver3.xx
*	512hbgΉ256F摜Ro[^
*
*					programmed 1994,95,96,97 by Herzen
*
*-

		.title	mph3 - mph.s

version:	.reg	'3.11'
localversion:	.reg	''
*localversion:	.reg	' test01'
patchlevel:	.reg	'+1'


* Include File -------------------------------- *

		.include	doscall.mac
		.include	iocscall.mac
		.include	mph.h
		.include	mph_lib.h
		.include	mph_misc.h
		.include	mph_ls_table.h
		.include	config.h
		.include	mph_format.h


* Global Symbol ------------------------------- *

		.xref	tonedown
		.xref	tonedown50
		.xref	tonedown_nowait
		.xref	to_gram
		.xref	to_gram_sabun
		.xref	trans_clr
		.xref	trans_clrx
		.xref	text_on
		.xref	text_off
		.xref	GCLR
		.xref	gram_to_buff
		.xref	gram_to_buff_only
		.xref	gram_to_buff256
		.xref	gram_to_buff256_only

		.xref	malloc
		.xref	malloc_free
		.xref	gram_malloc
		.xref	gram_malloc_free
	.if	0
		.xref	malloc_disp
	.endif
		.xref	ext_table_set

		.xref	dst_chk
		.xref	format_chk
		.xref	depend_chk

		.xref	comment_form
		.xref	comment_user_get

*		.xref	lus_set

*mph_switch.s
		.xref	GetArgCharInit,GetArgChar,UngetArgChar
		.xref	switch_arg,switch_env

		.xref	ERROR
		.xref	IPRINT
		.xref	DPRINT
* mph_info.has
		.xref	make_info
		.xref	make_infox
		.xref	make_info2
		.xref	make_info_size
		.xref	info_title
		.xref	info_line
		.xref	infopp_title
		.xref	infopp_line

** XCb`p
		.xdef	palet_set	* -rl p
		.xdef	title
		.xdef	chk_gram

**
		.xdef	error_dst
		.xdef	error_src
		.xdef	mph_header
		.xdef	con_on
		.xdef	con_off
		.xdef	ERROR_GROBAL_EXIT
		.xdef	ERROR_EXIT
		.xdef	usage

ToSuper:	.macro
		clr.l	-(sp)
		DOS	_SUPER
		move.l	d0,(sp)
		.endm
ToUser:		.macro
		DOS	_SUPER
		addq.l	#4,sp
		.endm

	.ifndef	_SYS_STAT
_SYS_STAT:	.equ	$ac
	.endif

MPU_TYPE:	.equ	$cbc

*-


* Fixed Number -------------------------------- *

T_ON:		.equ	$20
G_ON:		.equ	$1f

DIRECTORY:	.equ	4

STDOUT:		.equ	1

LF:		.equ	$0a
CR:		.equ	$0d

	.ifdef	__CRLF__
CRLF:		.reg	CR,LF
	.else
CRLF:		.equ	LF
	.endif


* I/O Address --------------------------------- *

CRTC:		.equ	$e80000

~CRTC_R12:	.equ	$18
~CRTC_R13:	.equ	$1a
~CRTC_R14:	.equ	$1c
~CRTC_R15:	.equ	$1e
~CRTC_R20h:	.equ	$28

VC_R0:		.equ	$e82400
VC_R2:		.equ	$e82600


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

ent:
		bra.s	@f
		.dc.b	'#HUPAIR',0
@@:
		lea	(16,a0),a0
		lea	(STACK_SIZE,a1),a1
		suba.l	a0,a1
		move.l	a1,-(sp)
		move.l	a0,-(sp)
		DOS	_SETBLOCK
		addq.l	#8,sp
		tst.l	d0
		bmi	NO_MEMORY
		lea	(-16,a0,a1.l),sp

		pea	(WORKSIZE+4)
		DOS	_MALLOC
		move.l	d0,(sp)+
		bmi	NO_MEMORY
		movea.l	d0,a5

		bsr	title
		bsr	work_init

		pea	(1,a2)
		bsr	env_get
		movea.l	(sp)+,a2
		bsr	switch_arg
		bsr	dst_format

	.if	0
		tst.b		(_human_ver_ignore,a5)
		bne		@f
		moveq.l		#42,d6			* Human68k̃o[WႢ.
		DOS		_VERNUM
		cmp.w		#$0300,d0
		bcs		NO_VER
@@:
	.endif
		tst.w		_gram_disp_mode(a5)	* GRAMgꍇ̓`FbN
		beq		@f
		bsr		chk_gram
@@:
		bsr	GetArgChar
		bsr	UngetArgChar
		tst.b	d0
		bne	@f

		moveq	#8,d6		* t@Cw肵Ă.
		move	(_mode,a5),d0
		btst.b	d0,#1<<MPH_INFO+1<<MPH_LOADER
		beq	ERROR_EXIT

		pea	(wildcard,pc)	;-pp,-l͏ȗ\
		bsr	GetArgCharInit
		addq.l	#4,sp
@@:
		bsr	con_init
		bsr	time_disp_init
		bsr	mode_jump
		bsr	time_disp
		bsr	con_restore
		bsr	key_flush
		DOS	_EXIT

mode_jump:
		move.w	_mode(a5),d0
		beq	mph_convert
		cmp.w	#MPH_LOADER,d0
		beq	mph_loader
		cmp.w	#MPH_SAVER,d0
		beq	mph_saver
		cmp.w	#MPH_INFO,d0
		beq	mph_info
		cmp.w	#MPH_VS,d0
		beq	mph_vs
		cmp.w	#MPH_SABUN,d0
		beq	mph_sabun
		move.w	#255,d6
		bra	ERROR_EXIT

NO_MEMORY:
	lea.l	no_memory_mes(pc),a1
	IOCS	_B_PRINT
	move.w	#6,-(sp)
	DOS	_EXIT2
no_memory_mes:
	.dc.b	'J삳: ̂m܂񂯂ǁc撣Ăˁ',CRLF
	.dc.b	'@@@@@@iȂ̂j',CRLF,0
	.even
wildcard:
	.dc.b	'*.*',0
	.even

	.if	0
NO_VER:
	suba.l	a1,a1
	move.w	d6,d0
	bsr	ERROR
	move.w	d6,-(sp)
	DOS	_EXIT2
	.endif

work_init:
		movem.l		d0-d1/a0,-(sp)
		movea.l		a5,a0
		moveq.l		#0,d0
		move.w		#WORKSIZE/4-1,d1
@@:		move.l		d0,(a0)+		* clr (a0)+.
		dbra		d1,@b

		move.w		#-1,_src(a5)
		move.w		#PI,_dst(a5)
		move.l		#".PI".shl.8,_ext_ofmt(a5)
		move.l		#"MAKI",_comment_mag(a5)
		move.l		#"02  ",_comment_mag+4(a5)
		move.w		#64,_hcolum(a5)
		move.w		#56,_hline(a5)
		move.l		#"MPHx",_mph_head(a5)
		move.l		#version,_mph_version(a5)
		move.b		_mph_version(a5),_mph_head+3(a5)
		lea		(_mph_user,a5),a0
		move.l		#"><",(a0)+
		move.l		#"    ",(a0)+
		move.l		#"    ",(a0)+
		move.l		#"    ",(a0)+
		move.l		#"   "<<8,(a0)+
		move.w		#640,_colum(a5)
		move.w		#400,_line(a5)
		move.w		#639,_ecolum(a5)
		move.w		#399,_eline(a5)
		move.l		#640*400/2,_buff_req(a5)
		move.l		#-1,_colum_Ssw(a5)
		move.l		#-1,_scolum_Ssw(a5)
		move.l		#-1,_ecolum_Ssw(a5)
		move.w		#50,_gram_disp_palet(a5)
		move.w		#0,_gram_disp_wait(a5)		* 20 ɂĂ...
		move.l		#4,_lus_wait_time(a5)
		move.w		#2-1,_lus_wait(a5)
		move.w		#4,_color(a5)
		move.w		#4,_screen_color(a5)

		bsr		ext_table_set
*		bsr		lus_set
		movem.l		(sp)+,d0-d1/a0
		rts

stdout_chk:
		tst.b	_no68_flag(a5)		* 68p̈ւ̃ANZX̋ۃ`FbN
		bne	@f
		move.w	#1,-(sp)		* STDOUT
		clr.w	-(sp)
		DOS	_IOCTRL
		addq.l	#4,sp
		btst.l	#7,d0			* _CNg`FbN
		bne	@f
		st.b	_redirect_flag(a5)
@@:
		rts

* gq`FbN ---------------------------------

chkext:
		clr.b	_isdir_flag(a5)
		tst.b	_ext_complete_flag(a5)		* gq⊮邩H
		bne	@f

		cmp.w	#'*'.shl.8,_arg(a5)
		bne	@f
		move.l	#'*.MA',_arg(a5)
		move.w	#'G'.shl.8,_arg+4(a5)
@@:
		pea.l	_nameck_buf(a5)
		pea.l	_arg(a5)
		DOS	_NAMECK
		addq.l	#8,sp
		cmp.b	#':',_arg+1(a5)			* EEE
		bne	@f
		move.b	_arg(a5),d0			* ̂QoCgڂłȂ
		cmp.b	#$7a,d0
		bhi	@f
		move.b	d0,_nameck_buf(a5)
@@:
		move.w	#-1,-(sp)			* fBNg`FbN
		pea.l	_arg(a5)
		DOS	_CHMOD
		addq.l	#6,sp
		tst.l	d0
		bmi	@f
		btst.l	#4,d0
		sne.b	_isdir_flag(a5)			* fBNg.
@@:
		tst.b	_nameck_ext+1(a5)		* gq݃`FbN
		bne	chkext_end			* ݂̂łΏI

		tst.b	_ext_complete_flag(a5)		* gq⊮邩H
		bne	chkext_end			* Ȃ̂łΏI

		lea.l	_arg(a5),a1
@@:		tst.b	(a1)+
		bne	@b
		subq.l	#2,a1
		cmp.b	#'.',(a1)+
		bne	@f
		subq.l	#1,a1
@@:		move.b	#'.',(a1)+
		move.b	#'M',(a1)+
		move.b	#'A',(a1)+
		move.b	#'G',(a1)+
		clr.b	(a1)
chkext_end:
		rts


*  .OFMT擾[` ---------------------------------

dst_format:
		lea	(_tmp,a5),a0

		pea	(a0)
		clr.l	-(sp)
		pea	(env_dst_string,pc)
		DOS	_GETENV
		addq.l	#12-4,sp
		move.l	d0,(sp)+
		bmi	dst_format_env_skip
		cmpi.b	#'.',(a0)
		bne	dst_format_env_skip
		tst.b	(1,a0)
		beq	dst_format_env_skip

		bsr	dst_format_sub
dst_format_env_skip:
***
		.xref	 ArgPtr
		lea	(ArgPtr,pc),a1
		move.l	(a1)+,-(sp)		;ArgPtr
		move.l	(a1)+,-(sp)		;ArgData
		move.b	(a1)+,-(sp)		;ArgFlag
***
		lea	(a0),a1
@@:
		bsr	GetArgChar
		move.b	d0,(a1)+
		bne	@b

		cmpi.b	#'.',(a0)
		bne	dst_format_ofmt_skip	;߂Kv...
		tst.b	(1,a0)
		beq	dst_format_ofmt_skip
		cmpi	#'..',(a0)
		beq	dst_format_ofmt_skip
		cmpi	#'./',(a0)
		beq	dst_format_ofmt_skip
		cmpi	#'.\',(a0)
		beq	dst_format_ofmt_skip

		bsr	dst_format_sub
		tst.b	(sp)+
		addq.l	#8,sp
		rts
dst_format_ofmt_skip:
***
		.xref	 ArgFlag
		lea	(ArgFlag+1,pc),a1
		move.b	(sp)+,-(a1)		;ArgFlag
		move.l	(sp)+,-(a1)		;ArgData
		move.l	(sp)+,-(a1)		;ArgPtr
***
		rts

dst_format_sub:
		move.l	(a0),d3
		lea	(a0),a1
		bsr	to_upper_a1
		move.l	a1,d0
		sub.l	a0,d0
		subq.l	#4,d0			;4=strlen(".mag")
		bhi	@f
		move.l	(a0),d0
		bsr	dst_chk
		tst	d1
		bne	@f
		move.l	d3,(_ext_ofmt,a5)
@@:		rts

* 񒆂̃At@xbg啶ɕϊ.
* in	a1.l	̃AhX
* out	a1.l	̏I[(NUL)̃AhX
* break	d0.b

to_upper_a1_loop:
		cmpi.b	#'a',d0
		bcs	to_upper_a1
		cmpi.b	#'z',d0
		bhi	to_upper_a1
		andi.b	#$df,(-1,a1)
to_upper_a1:
		move.b	(a1)+,d0
		bne	to_upper_a1_loop
		subq.l	#1,a1
		rts

env_dst_string:
		.dc.b	'MPH_OFMT',0
		.even


* ϐ˃XCb` ---------------------------------

env_get:
		move.l	a2,-(sp)
		lea	(_tmp,a5),a2
		pea	(a2)
		clr.l	-(sp)
		pea	(env_switch_str,pc)
		DOS	_GETENV
		addq.l	#12-4,sp
		move.l	d0,(sp)+
		bmi	dst_get_end
		bsr	switch_env
dst_get_end:
		move.l	(sp)+,a2
		rts

env_switch_str:
	.dc.b	'MPH',0
	.even


*-
*-
*
*  Z[o[EC[`
*

mph_saver:
		tst.b	(_s_disp_save_flag,a5)
		beq	mph_saver_main

		move.l	(_scolum,a5),-(sp)
		move.l	(_ecolum,a5),-(sp)
		move.l	(_colum,a5),-(sp)
		move.l	(_buff_req,a5),-(sp)
		bsr	mph_exp
		move.l	(sp)+,(_buff_req,a5)
		move.l	(sp)+,(_colum,a5)
		move.l	(sp)+,(_ecolum,a5)
		move.l	(sp)+,(_scolum,a5)
		move	#1,(_comm,a5)
		tst.l	d0
		bmi	ERROR_EXIT
mph_saver_main:
		lea	(_arg,a5),a0
@@:
		bsr	GetArgChar
		move.b	d0,(a0)+
		bne	@b

		pea	(_nameck_buf,a5)
		pea	(_arg,a5)
		DOS	_NAMECK
		addq.l	#8,sp

		bsr	dstfile_get_saver

*saver:						* ʃ[h擾
		moveq	#38,d6
		moveq	#-1,d1
		IOCS	$91			;move ($e82400),d0
		bclr	#2,d0
		bne	saver_16		;graphic 1024*1024 16color mode ?
		subq	#1,d0
		bne	setscreen16		;graphic 512*512 256color mode ?

*saver_256:					* 256FFWݒ
		move.w	#8,_screen_color(a5)

		tst.l	_colum_Ssw(a5)
		bmi	saver_256_default

		move.w	_ecolum_Ssw(a5),d0
		bsr	dot4m
		move.w	d0,_ecolum(a5)
		move.w	d0,d2
		move.w	_scolum_Ssw(a5),d0
		bsr	dot4
		move.w	d0,_scolum(a5)
		sub.w	d0,d2
		addq.w	#1,d2
		move.w	d2,_colum(a5)
		move.w	_eline_Ssw(a5),d3
		move.w	d3,_eline(a5)
		move.w	_sline_Ssw(a5),d1
		move.w	d1,_sline(a5)
		sub.w	d1,d3
		addq.w	#1,d3
		move.w	d3,_line(a5)
		mulu.w	d2,d3
		move.l	d3,_buff_req(a5)
		moveq.l	#39,d6			* sȍW
		move.w	_colum(a5),d0		* 256F́C512x512܂
		cmp.w	#512,d0
		bhi	ERROR_EXIT
*		move.w	_line(a5),d0
*		cmp.w	#512,d0
*		bhi	ERROR_EXIT
		bra	saver_cont
saver_256_default:
		move.w	#512,_colum(a5)
		move.w	#512,_line(a5)
		clr.l	(_scolum,a5)
		move.w	#511,_ecolum(a5)
		move.w	#511,_eline(a5)
		move.l	#512*512,_buff_req(a5)
		bra	saver_cont

setscreen16:
		tst	(_s_mode,a5)
		beq	ERROR_EXIT

		ToSuper
		moveq	#0,d0
		lea	(CRTC),a0
		move.l	d0,(~CRTC_R12,a0)
		move.l	d0,(~CRTC_R14,a0)
		moveq	#%100,d0		;512x512,16F
		move.b	d0,(~CRTC_R20h,a0)
		move	d0,(VC_R0-CRTC,a0)
		move	#T_ON+G_ON,(VC_R2-CRTC,a0)
		ToUser
saver_16:					* 16FFWݒ
		move	#4,(_screen_color,a5)
		tst.l	(_colum_Ssw,a5)
		bmi	saver_16_default

		move.w	_ecolum_Ssw(a5),d0
		bsr	dot8m
		move.w	d0,_ecolum(a5)
		move.w	d0,d2
		move.w	_scolum_Ssw(a5),d0
		bsr	dot8
		move.w	d0,_scolum(a5)
		sub.w	d0,d2
		addq.w	#1,d2
		move.w	d2,_colum(a5)
		move.w	_eline_Ssw(a5),d3
		move.w	d3,_eline(a5)
		move.w	_sline_Ssw(a5),d1
		move.w	d1,_sline(a5)
		sub.w	d1,d3
		addq.w	#1,d3
		move.w	d3,_line(a5)
		mulu.w	d2,d3
		move.l	d3,_buff_req(a5)
		bra	saver_cont
saver_16_default:
		move.w	#640,_colum(a5)
		move.w	#400,_line(a5)
		clr.l	(_scolum,a5)
		move.w	#639,_ecolum(a5)
		move.w	#399,_eline(a5)
		move.l	#640*400,_buff_req(a5)
*		bra	saver_cont

saver_cont:
		move.w	_screen_color(a5),_color(a5)

		bsr	saver_dst_check

		move.w	_s_clip(a5),d7
		beq	@f
		bsr	clip_and_set
@@:

		bsr	make_info_size
		lea.l	_disp(a5),a1
		IOCS	_B_PRINT
		bsr	icrlf

		bsr		gram_malloc
		moveq.l		#6,d6
		tst.l		d0
		bmi		ERROR_EXIT
		move.l		_buff_size(a5),d0
		move.l		_buff_req(a5),d1
		cmp.l		d0,d1
		bhi		ERROR_EXIT

		bsr		gram_to_buff_main
		bsr		trans_q4

		bsr		dstfile_disp		* dstfile\
		bsr		comment_form
		bsr		con_off

		IOCS		_OS_CUROF
		bsr		inline_save
		tst.l		d0
		bmi		work_gram_end

		move.l	#11<<16+2,-(sp)
		DOS	_CONCTRL
		addq.l	#4,sp
		IOCS		_OS_CURON

		lea.l		_pal_buf(a5),a0
		bsr		rgb_file_write

		tst.b		_visual_info(a5)
		beq		@f
		ToSuper
		bsr		tvram_clear
		ToUser
@@:

		rts

* (saver)
* 16FΉ

saver_dst_check:
		move	(_dst,a5),d0
		cmpi	#HG,d0
		beq	saver_dst_hg
		cmpi	#PIX,d0
		beq	saver_dst_pix
@@:
		moveq	#0,d0
		rts
saver_dst_hg:
saver_dst_pix:
		moveq	#36,d6			* 16FȊOΉ
		cmpi	#4,(_color,a5)
		beq	@b
*saver_dst_err:
		move	d6,d0
		bra	ERROR_DST_EXIT


mph_exp:
		lea	(_arg,a5),a0
@@:
		bsr	GetArgChar
		move.b	d0,(a0)+
		bne	@b

		bsr	chkext

		move	#%10101111,-(sp)
		pea	(_arg,a5)
		pea	(_files_buf,a5)
		DOS	_FILES
		addq.l	#10-4,sp
		move.l	d0,(sp)+
*		beq	file_search

		bsr	srcfile_get		* pXt̓t@C擾.
		clr.w	_200flag(a5)		* ꂾ́CŃNAȂ΂ȂD
		bsr	format_chk		* tH[}bg`FbN.
		tst.w	d0
		beq	mph_exp1_1
		cmp.l	#20,d6
		bhi	error_src
		tst.w	_verbose(a5)
		bne	error_src
		bra	error_nodisp
mph_exp1_1:
		bsr		malloc
		bsr		init			* ϐ
		bsr		inline_fileinit		* srcfileFileNO.TCY.t擾
		tst.l		d0
		bmi		work_end_
		bsr		inline_decode		* wb_`FbNǂݍ݁WJ
		tst.l		d0
		bmi		work_end_
		bsr		to_gram			* G\

		IOCS		_OS_CURON
		moveq.l		#0,d0
		rts

*-
*-
*
*  [hEC[`
*

mph_loader:
*		move	#3,(_gram_disp_mode,a5)
		bsr	con_restore
		bsr	key_flush

loader_loop:
		bsr	GetArgChar
		bsr	UngetArgChar
		tst.b	d0
		beq	loader_end

		bsr	decARG

		move	#%10101111,-(sp)
		pea	(_arg,a5)
		pea	(_files_buf,a5)
		DOS	_FILES
		addq.l	#10-4,sp
loader_file_search:
		move.l	d0,(sp)+
		bmi	loader_loop

		bsr	esckey_chk
		beq	loader_end
		bsr	key_flush

		btst	#DIRECTORY,(_files_buf+21,a5)
		bne	loader_loop

		bsr	loader
		cmpi.b	#$1b,d0
		beq	loader_end

		bsr	esckey_chk
		beq	loader_end
		bsr	key_flush

		pea	(_files_buf,a5)
		DOS	_NFILES
		bra	loader_file_search
loader_end:
		tst.b	_exit_tonedown_flag(a5)
		beq	@f
		ToSuper
		bsr	tonedown50
		ToUser
@@:
		bsr	con_restore		;ށ[
		DOS	_EXIT

loader:
		clr.w	_src(a5)
		bsr	srcfile_get		* pXt̓t@C擾.
		clr.w	_200flag(a5)		* ꂾ́CŃNAȂ΂ȂD

		bsr	format_chk		* tH[}bg`FbN.
		tst.w	d0
		bne	@f

		bsr	depend_chk		* fByh`FbN
		move.w	d0,_depend(a5)

		bsr	malloc
		moveq.l	#6,d6
		tst.l	d0
		bmi	error_src

		bsr	init			* ϐ
		bsr	inline_fileinit		* srcfileFileNO.TCY.t擾
		tst.l	d0
		bmi	@f
		bsr	inline_decode
		tst.l	d0
		bmi	@f

		IOCS	_OS_CUROF
		ToSuper
		bsr	HT_CLR
		clr.l	($974)			;!!!
		ToUser
		bsr	to_gram			* G\
		moveq.l	#0,d0
		tst.b	_mph_loader_key_flag(a5)
		beq	@f
		DOS	_INKEY
@@:
		rts


*-
*-
*
*  EC[`
*
*  -- dˍ --

mph_sabun:
		move	#3,(_gram_disp_mode,a5)
		bsr	con_restore
		bsr	key_flush

sabun_loop:
		bsr	GetArgChar
		bsr	UngetArgChar
		tst.b	d0
		beq	sabun_end

		bsr	decARG

		move	#%10101111,-(sp)
		pea	(_arg,a5)
		pea	(_files_buf,a5)
		DOS	_FILES
		addq.l	#10-4,sp
sabun_file_search:
		move.l	d0,(sp)+
		bmi	sabun_loop

		bsr	esckey_chk
		beq	sabun_end
		bsr	key_flush

		btst	#DIRECTORY,(_files_buf+21,a5)
		bne	sabun_loop

		bsr	sabun
		cmpi.b	#$1b,d0
		beq	sabun_end

		bsr	esckey_chk
		beq	sabun_end
		bsr	key_flush

		pea	(_files_buf,a5)
		DOS	_NFILES
		bra	sabun_file_search
sabun_end:
		DOS	_EXIT

sabun:
		clr.w	_src(a5)
		bsr	srcfile_get		* pXt̓t@C擾.
		clr.w	_200flag(a5)		* ꂾ́CŃNAȂ΂ȂD

		bsr	format_chk		* tH[}bg`FbN.
		tst.w	d0
		bne	@f

		bsr	depend_chk		* fByh`FbN
		move.w	d0,_depend(a5)

		bsr	malloc
		moveq.l	#6,d6
		tst.l	d0
		bmi	error_src

		bsr	init			* ϐ
		bsr	inline_fileinit		* srcfileFileNO.TCY.t擾
		tst.l	d0
		bmi	@f
		bsr	inline_decode
		tst.l	d0
		bmi	@f

		IOCS	_OS_CUROF
		ToSuper
		bsr	HT_CLR
		clr.l	($974)
		ToUser
		bsr	to_gram_sabun		* G\
		moveq.l	#0,d0
		rts


*-
*-
*
*  CtHEC[`
*

mph_info:
		bsr	con_restore
		bsr	key_flush

		tst.b	_redirect_flag(a5)
		beq	@f
		lea.l	infomakemes(pc),a1
		IOCS	_B_PRINT
		bsr	icrlf
@@:
		bsr	infopp_title	* 'Type Color XS ....'
		move.l	a1,-(sp)
		DOS	_PRINT
		addq.l	#4,sp
		bsr	crlf
		bsr	infopp_line	* '---+----------------'
		move.l	a1,-(sp)
		DOS	_PRINT
		addq.l	#4,sp
		bsr	crlf
info_loop:
		bsr	GetArgChar
		bsr	UngetArgChar
		tst.b	d0
		beq	info_end

		bsr	decARG

		move	#%10101111,-(sp)
		pea	(_arg,a5)
		pea	(_files_buf,a5)
		DOS	_FILES
		addq.l	#10-4,sp
info_file_search:
		move.l	d0,(sp)+
		bmi	info_loop

		bsr	esckey_chk
		beq	info_end
		bsr	key_flush

		btst	#DIRECTORY,(_files_buf+21,a5)
		bne	info_loop

		bsr	information

		bsr	esckey_chk
		beq	info_end
		bsr	key_flush

		pea	(_files_buf,a5)
		DOS	_NFILES
		bra	info_file_search
info_end:
		bsr	infopp_line	* '---+----------------'
		move.l	a1,-(sp)
		DOS	_PRINT
		addq.l	#4,sp
		bsr	crlf

		tst.b	_redirect_flag(a5)
		beq	@f
		lea.l	infomakemese(pc),a1
		IOCS	_B_PRINT
		bsr	icrlf
@@:
		rts

information:
		clr.w	_src(a5)
		bsr	srcfile_get		* pXt̓t@C擾.
		clr.w	_200flag(a5)		* ꂾ́CŃNAȂ΂ȂD
		bsr	format_chk		* tH[}bg`FbN.
		tst.w	d0
		bne	error_nodisp

		bsr	init			* ϐ
		bsr	inline_fileinit		* srcfileFileNO.TCY.t擾
		tst.l	d0
		bmi	error_nodisp

		bsr	header_read
		tst.w	d0
		bne	err_info
		bsr	comment_user_get	* comment_form̑łC[ÛݒoD
		move.w	_file(a5),-(sp)
		DOS	_CLOSE
		addq.l	#2,sp

		bsr	make_infox
		pea.l	_disp(a5)
		DOS	_PRINT
		addq.l	#4,sp
		bsr	crlf
		rts

err_info:
		move.w	_file(a5),-(sp)
		DOS	_CLOSE
		addq.l	#2,sp
		rts

infomakemes:
	.dc.b	'摜t@Co͒ł.',0
	.even
infomakemese:
	.dc.b	'I܂.',0
	.even

header_read:
		bsr	header_read__
		tst.l	d0
		bmi	error_src
		rts

* (loader)

header_read__:
		move.w	_src(a5),d0
		cmp.w	#MAG,d0
		beq	mag_header_read
		cmp.w	#PI,d0
		beq	pi_header_read
		cmp.w	#HG,d0
		beq	hg_header_read
		cmp.w	#GH,d0
		beq	gh_header_read
		cmp.w	#GIF,d0
		beq	gif_header_read
		cmp.w	#BMP,d0
		beq	bmp_header_read
		cmp.w	#PIX,d0
		beq	pix_header_read
		cmp.w	#PT4,d0
		beq	pt4_header_read
		moveq.l	#1,d0
		rts


*-
*-
*
*  o[`XN[iJPEGEDdlj
*

mph_vs:
	rts


*-
*-
*
*  Ro[gEC[`
*

mph_convert:
		bsr	con_off
		bsr	key_flush

mph_cnv_lop:
		bsr	GetArgChar
		bsr	UngetArgChar
		tst.b	d0
		beq	main_end

		bsr	decARG

		move	#%10101111,-(sp)
		pea	(_arg,a5)
		pea	(_files_buf,a5)
		DOS	_FILES
		addq.l	#10-4,sp
		move.l	d0,(sp)+
		bmi	mph_cnv_file_search_err
mph_cnv_file_search:
		bsr	esckey_chk
		beq	main_end
		bsr	key_flush

		btst	#DIRECTORY,(_files_buf+21,a5)
		bne	mph_cnv_lop

		bsr	convert
		tst.l	d0
		bmi	@f
		addq	#1,(_count_convert,a5)
@@:
		bsr	esckey_chk
		beq	main_end
		bsr	key_flush

		pea	(_files_buf,a5)
		DOS	_NFILES
		move.l	d0,(sp)+
		bmi	mph_cnv_lop
		bra	mph_cnv_file_search

main_end:
		tst.w	_disp_ofmt(a5)
		beq	main_end_cont1
		bsr	con_on

		bsr	info_line_disp	* '------ ---'

main_end_cont1:
		rts

mph_cnv_file_search_err:
		moveq.l	#41,d6		* fBNgł.
		tst.b	_isdir_flag(a5)
		beq	@f
		bsr	error
		bra	mph_cnv_lop
@@:		moveq.l	#1,d6
		bsr	error_arg
		bra	mph_cnv_lop


convert:
		clr.w	_src(a5)
		bsr	srcfile_get		* pXt̓t@C擾.
		clr.w	_200flag(a5)		* ꂾ́CŃNAȂ΂ȂD
		bsr	format_chk		* tH[}bg`FbN.
		tst.w	d0
		bne	convert_format_err
convert_save_chk
		move.w	_src(a5),d0
		move.w	_dst(a5),d1
		cmp.w	d0,d1
		bne	convert_cont02
		tst.b	_same_ofmt_flag(a5)
		bne	convert_cont02
		tst.w	_verbose(a5)
		beq	error_nodisp
		moveq.l	#37,d6
		bra	error_src
convert_cont02:
		bsr	depend_chk		* fByh`FbN
		move.w	d0,_depend(a5)

		tst.b	_ignore_depend_flag(a5)	* ɊOvZXɗ.
		bne	work_gram

		cmp.w	#1,d0
		beq	work_inline
		cmp.w	#2,d0
		beq	work_gram

		moveq.l	#255,d6			* VXeG[
		bra	ERROR_EXIT

convert_format_err:
		cmp.l	#20,d6
		bhi	error_src
		tst.w	_verbose(a5)
		bne	error_src
		bra	error_nodisp


*
*
*
*  摜
*
*
*
work_inline:
		tst.w	_disp_ofmt(a5)
		bne	work_inline_cont1
		bsr	con_on
		bsr	info_title		* ' OFMT ....'
		IOCS	_B_PRINT
		bsr	icrlf

		bsr	info_line_disp		* '------ ---'

		st.b	_disp_ofmt(a5)
work_inline_cont1:

		bsr		gram_malloc_free
		bsr		malloc

		bsr		init			* ϐ
		bsr		dstfile_get		* dstfile擾, rgbfile擾

		bsr		inline_fileinit		* srcfileFileNO.TCY.t擾
		tst.l		d0
		bmi		work_end_

		bsr		inline_decode		* wb_`FbNǂݍ݁摜WJ
		tst.l		d0
		bmi		work_end_

		bsr		srcfile_delete		* srcfilef[g

		bsr		to_gram			* G\

		bsr		comment_form		* Rg

*		movea.l	_buff_addr(a5),a0
*		move.w	_colum(a5),d0
*		move.w	_line(a5),d1
*		bsr	clipping_vs
*		movem.l	d0-d1,-(sp)
*		swap.w	d0
*		swap.w	d1
*		bsr	prtdec
*		move.w	d1,d0
*		bsr	prtdec
*		swap.w	d0
*		swap.w	d1
*		bsr	prtdec
*		move.w	d1,d0
*		bsr	prtdec
*		bsr	crlf
*		movem.l	(sp)+,d0-d1
*		move.w	_colum(a5),d2
*		movea.l	a0,a1
*		bsr	rectangle_cut		* `؂o

		tst.b		_inline_to_gram_flag(a5)
		bne		inline_to_gram_save

		IOCS		_OS_CUROF

		bsr		slide_chk		* W炵

		tst.b		_workmem_gram_flag(a5)	* Z[uobt@GRAMł
		bne		@f
		bsr		inline_save		* Z[u
		tst.l		d0
		bne		work_end_
		bra		1f
@@:
		ToSuper
		bsr		inline_save		* Z[u
		move.l		d0,d1
		ToUser
		tst.l		d1
		bne		work_end_
1:

		bsr		fdate_set

		bsr		make_info2
		bsr		inline_last_info

work_end:
		lea.l		_pal_buf(a5),a0
		bsr		rgb_file_write

		IOCS		_OS_CURON
		moveq.l		#0,d0
		rts

work_end_:
		IOCS		_OS_CURON
		moveq.l		#-1,d0
		rts

*-------------------------------------------------------------------------------

inline_to_gram_save:
		move.w	_color(a5),_screen_color(a5)
		moveq.l	#1,d7
		bsr	clip_and_set

		bsr		malloc_free

		bsr		gram_malloc
		moveq.l		#6,d6
		tst.l		d0
		bmi		error_src

		move.l		_buff_size(a5),d0
		move.l		_buff_req(a5),d1
		cmp.l		d0,d1
		bhi		error_src

		bsr		gram_to_buff_only_main

		IOCS		_OS_CUROF

		bsr		tonedown_nowait

		bsr		inline_save
		tst.l		d0
		bne		work_end_

		bsr		fdate_set

		tst.b		_visual_info(a5)
		beq		@f
		ToSuper
		bsr		tvram_clear
		ToUser
@@:

		bsr		make_info
		bsr		make_info2

		bsr		inline_last_info

		bra		work_end


*------------------------------------------------------------------------------*
*
*  [_ɂ摜WJ
*  (loader)
*
*    PCwb_̓ǂݍ(???_header_read)
*    QC[_ň摜TCYH
*    RCZbeBO摜t@Cf[^̓ǂݍ(read_adr_get)
*    SCZ[oł̏o͂\H(inline_dst_check)
*    TCWJ(???_decode)
*

inline_decode:
		move.w		_src(a5),d0
		cmp.w		#MAG,d0
		beq		inline_decode_mag
		cmp.w		#PI,d0
		beq		inline_decode_pi
		cmp.w		#HG,d0
		beq		inline_decode_hg
		cmp.w		#GH,d0
		beq		inline_decode_gh
		cmp.w		#BMP,d0
		beq		inline_decode_bmp
		cmp.w		#GIF,d0
		beq		inline_decode_gif
		cmp.w		#PIX,d0
		beq		inline_decode_pix
		cmp.w		#PT4,d0
		beq		inline_decode_pt4
		moveq.l	#-1,d0
inline_decode_error:
		rts

inline_decode_mag:
		bsr		mag_header_read
		tst.l		d0
		bmi		error_src

		bsr		read_adr_get
		tst.l		d0
		bmi		inline_decode_error

		bsr		inline_dst_check
		tst.l		d0
		bmi		inline_decode_error

		bsr		mag_decode
		moveq.l		#0,d0
		rts

inline_decode_pi:
		bsr		pi_header_read
		tst.l		d0
		bmi		error_src

		moveq.l	#33,d6			* E𒴂Ă
		move.w	_colum(a5),d1
		cmp.w	#FOR_PI*2,d1
		bhi	error_src

		bsr		read_adr_get		* out = a1 ( read head address )
		tst.l		d0
		bmi		inline_decode_error

		bsr		inline_dst_check
		tst.l		d0
		bmi		inline_decode_error

		bsr		pi_decode
		moveq.l		#0,d0
		rts

inline_decode_hg:
		bsr		hg_header_read
		tst.l		d0
		bmi		error_src

		moveq.l	#31,d6			* T|[gĂȂ`
		move.w	_scolum(a5),d0		* ȒPɃwb_`FbN
		move.w	_ecolum(a5),d1
		cmp.w	d1,d0
		bcc	error_src
		move.w	_sline(a5),d0
		move.w	_eline(a5),d1
		cmp.w	d1,d0
		bhi	error_src
		moveq.l	#33,d6			* E𒴂Ă
		move.w	_line(a5),d1
		cmp.w	#3200,d1
		bhi	error_src

		bsr		read_adr_get		* out = a1 ( read head address )
		tst.l		d0
		bmi		inline_decode_error

		bsr		inline_dst_check
		tst.l		d0
		bmi		inline_decode_error

		bsr		hg_decode
		moveq.l		#0,d0
		rts

inline_decode_gh:
		bsr		gh_header_read
		tst.l		d0
		bmi		error_src

		bsr		read_adr_get		* out = a1 ( read head address )
		tst.l		d0
		bmi		inline_decode_error

		bsr		inline_dst_check
		tst.l		d0
		bmi		inline_decode_error

		bsr		gh_decode
		moveq.l		#0,d0
		rts

inline_decode_bmp:
		bsr		bmp_header_read
		tst.l		d0
		bmi		error_src

		moveq.l	#43,d6			* 16,256ȊOɂ͑ΉĂȂ.
		move.w	_color(a5),d0
		cmp.w	#4,d0
		beq	@f
		cmp.w	#8,d0
		bne	error_src
@@:

		moveq.l	#45,d6			* kBMPɂ͑ΉĂȂ.
		tst.w	_bmp_compress(a5)
		bne	error_src

		bsr		read_adr_get		* out = a1 ( read head address )
		tst.l		d0
		bmi		inline_decode_error

		bsr		inline_dst_check
		tst.l		d0
		bmi		inline_decode_error

		bsr		bmp_decode
		moveq.l		#0,d0
		rts

inline_decode_gif:
		bsr		gif_header_read
		tst.l		d0
		bmi		error_src

		bsr		read_adr_get		* out = a1 ( read head address )
		tst.l		d0
		bmi		inline_decode_error

		bsr		inline_dst_check
		tst.l		d0
		bmi		inline_decode_error

		bsr		gif_decode
		moveq.l		#0,d0
		rts

inline_decode_pix:
		bsr		pix_header_read
		tst.l		d0
		bmi		error_src

*		moveq.l	#33,d6			* E𒴂Ă
*		move.w	_line(a5),d1
*		cmp.w	#PIX_YMAX,d1
*		bhi	error_src
*		move.w	_colum(a5),d1
*		cmp.w	#PIX_XMAX,d1
*		bhi	error_src

		bsr		read_adr_get		* out = a1 ( read head address )
		tst.l		d0
		bmi		inline_decode_error

		bsr		inline_dst_check
		tst.l		d0
		bmi		inline_decode_error

		bsr		pix_decode
		moveq.l		#0,d0
		rts

inline_decode_pt4:
		bsr		pt4_header_read
		tst.l		d0
		bmi		error_src

		moveq.l	#33,d6			* E𒴂Ă
		move.w	_line(a5),d1
		cmp.w	#PIX_YMAX,d1
		bhi	error_src
		move.w	_colum(a5),d1
		cmp.w	#PIX_XMAX,d1
		bhi	error_src

		bsr		read_adr_get		* out = a1 ( read head address )
		tst.l		d0
		bmi		inline_decode_error

		bsr		inline_dst_check
		tst.l		d0
		bmi		inline_decode_error

		bsr		pt4_decode
		moveq.l		#0,d0
		rts

*------------------------------------------------------------------------------*
*
*  Z[oɂo̓tH[}bg`FbNZbg
*  (saver)
* 
*    PC͑Ă邩H
*    QC摜TCÝCZ[o͈͓H
*    RCn[ttO̓ȏ͂ȂH
*
*    SC摜\
*    TCZ[op[ÑZbeBO
*

inline_dst_check:
		cmp.w	#MPH_LOADER,_mode(a5)
		beq	inline_dst_check_end
		move.w		_dst(a5),d0
		cmp.w		#MAG,d0
		beq		inline_dst_mag
		cmp.w		#PI,d0
		beq		inline_dst_pi
		cmp.w		#HG,d0
		beq		inline_dst_hg
		cmp.w		#GH,d0
		beq		inline_dst_gh
		cmp.w		#GIF,d0
		beq		inline_dst_gif
		cmp.w		#PIX,d0
		beq		inline_dst_pix
		cmp.w		#BMP,d0
		beq		inline_dst_bmp
		cmp.w		#Q0,d0
		beq		inline_dst_q0
		cmp.w		#RGB,d0
		beq		inline_dst_q0
		cmp.w		#GLM,d0
		beq		inline_dst_glm
		cmp.w		#GLX,d0
		beq		inline_dst_glm
		moveq.l	#-1,d0
		rts
inline_dst_check_end:
		moveq.l	#0,d0
		rts

inline_dst_mag:
		cmp.w	#8,_color(a5)
		beq	inline_dst_mag256

		tst.b	_inline_to_gram_flag(a5)
		bne	@f
		tst.b	_mag_force_save_flag(a5)
		beq	1f

			moveq.l	#34,d6				* 8dots
			move.w	_scolum(a5),d0
			and.w	#%111,d0
			tst.w	d0
			bne	error_src_info
			move.w	_colum(a5),d0
			and.w	#%111,d0
			tst.w	d0
			bne	error_src_info
			bra	@f
1:
			moveq.l	#34,d6				* 8dots
			move.w	_colum(a5),d0
			and.w	#%1,d0
			tst.w	d0
			bne	error_src_info
@@:
			bsr		info_disp		* t@C\

			bsr		mag_memchk
			tst.b		_locate_err(a5)
			beq		@f
			moveq.l		#21,d6			* SmۂɎs
			bsr		error_src
@@:			moveq.l	#0,d0
			rts

inline_dst_mag256:
		tst.b	_inline_to_gram_flag(a5)
		bne	@f
		tst.b	_mag_force_save_flag(a5)
		bne	1f

			moveq.l	#46,d6				* 4dots
			move.w	_scolum(a5),d0
			and.w	#%11,d0
			tst.w	d0
			bne	error_src_info
			move.w	_colum(a5),d0
			and.w	#%11,d0
			tst.w	d0
			bne	error_src_info
			bra	@f
1:
			moveq.l	#46,d6				* 4dots
			move.w	_colum(a5),d0
			and.w	#%1,d0
			tst.w	d0
			bne	error_src_info
@@:
			bsr		info_disp		* t@C\

			clr.w		_locate_err(a5)
			bsr		set_sub
			cmp.l		#768*1024,d1
			bhi		@f
			moveq.l		#21,d6			* SmۂɎs
			bsr		error_src
			st.b		_locate_err(a5)
@@:
			moveq.l		#0,d0
			rts

inline_dst_pi:
**		cmp.w	#8,_color(a5)
**		beq	inline_dst_pi256

			moveq.l	#33,d6				* E
			move.w	_colum(a5),d0
			cmp.w	#FOR_PI*2,d0
			bhi	error_src_info

			bsr		info_disp		* t@C\

			clr.w		_locate_err(a5)
			bsr		set_sub
			cmp.l		#128*1024+1024+2*FOR_PI256,d1	* 16F128*1024ł悢
			bhi		@f
			moveq.l		#21,d6			* SmۂɎs
			bsr		error_src
			st.b		_locate_err(a5)
@@:
			moveq.l		#0,d0
			rts

inline_dst_pix:
		moveq.l	#36,d6				* 16FȊOΉ
		cmp.w	#4,_color(a5)
		bne	error_src_info

*		moveq.l	#33,d6				* E
*		move.w	_line(a5),d0
*		cmp.w	#PIX_YMAX,d0
*		bhi	error_src_info
*		move.w	_colum(a5),d0
*		cmp.w	#PIX_XMAX,d0
*		bhi	error_src_info

		tst.b	_inline_to_gram_flag(a5)
		bne	@f
			moveq.l	#35,d6				* 200lineΉ
			tst.b	_200flag(a5)
			bne	error_src_info
@@:
			bsr		info_disp		* t@C\

			clr.w		_locate_err(a5)
			bsr		set_sub
			move.w		_colum(a5),d0
			mulu.w		_line(a5),d0
			add.l		#128,d0			* Ô
			cmp.l		d0,d1
			bhi		@f
			moveq.l		#21,d6			* SmۂɎs
			bsr		error_src
			st.b		_locate_err(a5)
@@:
			moveq.l		#0,d0
			rts


inline_dst_hg:
		moveq.l	#36,d6				* 16FȊOΉ
		cmp.w	#4,_color(a5)
		bne	error_src_info

		moveq.l	#33,d6				* E
		move.w	_line(a5),d0
		cmp.w	#3200,d0			* قƂ́C1024*4
		bhi	error_src_info

		tst.b	_inline_to_gram_flag(a5)
		bne	@f

			moveq.l	#35,d6				* 200lineΉ
			tst.b	_200flag(a5)
			bne	error_src_info
			moveq.l	#34,d6				* 8dots
			move.w	_scolum(a5),d0
			and.w	#%111,d0
			tst.w	d0
			bne	error_src_info
			move.w	_colum(a5),d0
			and.w	#%111,d0
			tst.w	d0
			bne	error_src_info

@@:
		move.l		#378*1024,d2
		bsr		set_sub

		cmp.l		d2,d1
		bhi		@f
		moveq.l		#20,d6
		bra		inline_dst_hg_err1
@@:
		clr.w		_locate_err(a5)
		sub.l		d2,d1
		add.l		d2,d0
		move.l		#128*1024,d2
		cmp.l		d2,d1
		bhi		@f
		moveq.l		#20,d6
		bra		error_src_info
@@:

		bsr		info_disp		* t@C\

		and.l		#$fffffffe,d0
		addq.l		#2,d0
		move.l		d0,_save_addr2(a5)
		clr.w		_locate_err(a5)
		moveq.l		#0,d0
		rts

inline_dst_hg_err1:
		tst.b		_workmem_gram_flag(a5)
		beq		error_src_info
		move.l		#$c00000,_save_addr(a5)
		move.l		#384*1024,_save_size(a5)
		bsr		info_disp		* t@C\
		move.l		#$c00000+384*1024,_save_addr2(a5)
		clr.w		_locate_err(a5)
		moveq.l		#0,d0
		rts

inline_dst_hg_err2:
		tst.b		_workmem_gram_flag(a5)
		beq		error_src_info
		bsr		info_disp		* t@C\
		move.l		#$c00000+384*1024,_save_addr2(a5)
		clr.w		_locate_err(a5)
		moveq.l		#0,d0
		rts


inline_dst_gh:
			cmp.w	#4,_color(a5)
			bne	@f

			clr.w	_locate_err(a5)
			moveq.l	#99,d6						* 2dots
			btst.b	#0,_scolum+1(a5)
			bne	error_src_info
			btst.b	#0,_colum+1(a5)
			bne	error_src_info
			bsr	info_disp		* t@C\
			moveq.l	#0,d0
			rts

@@:
			moveq.l	#43,d6				* 16/256FȊOΉ
			cmp.w	#8,_color(a5)
			bne	error_src_info

			clr.w		_locate_err(a5)
			bsr	info_disp		* t@C\
			moveq.l	#0,d0
			rts


inline_dst_bmp:
			clr.w		_locate_err(a5)

			cmp.w	#8,_color(a5)
			beq	inline_dst_bmp_256
inline_dst_bmp_16:
			cmp.w	#8,_to_color(a5)
			beq	inline_dst_bmp_256
			cmp.w	#24,_to_color(a5)
			beq	inline_dst_bmp_16M
			bra	1f
inline_dst_bmp_256:
			cmp.w	#24,_to_color(a5)
			beq	inline_dst_bmp_16M
			bsr		set_sub
			move.w		_colum(a5),d0
			ext.l		d0
			addq.w		#4,d0
			cmp.l		d0,d1
			bhi		1f
			moveq.l		#21,d6			* SmۂɎs
			st.b		_locate_err(a5)
		tst.b		_workmem_gram_flag(a5)
		beq		error_src
		move.l		#$c00000,_save_addr(a5)
		move.l		#512*1024,_save_size(a5)
			bra		1f
inline_dst_bmp_16M:
			bsr		set_sub
			move.w		_colum(a5),d0
			addq.w		#1,d0
			mulu.w		#3,d0
			cmp.l		d0,d1
			bhi		1f
			moveq.l		#21,d6			* SmۂɎs
			st.b		_locate_err(a5)
		tst.b		_workmem_gram_flag(a5)
		beq		error_src
		move.l		#$c00000,_save_addr(a5)
		move.l		#512*1024,_save_size(a5)
1:
			bsr	info_disp		* t@C\
			moveq.l	#0,d0
			rts

inline_dst_q0:
			clr.w		_locate_err(a5)

			bsr		set_sub
			move.w		_colum(a5),d0
			mulu.w		#3,d0
			cmp.l		d0,d1
			bhi		@f

			moveq.l		#21,d6			* SmۂɎs
			st.b		_locate_err(a5)
		tst.b		_workmem_gram_flag(a5)
		beq		error_src
		move.l		#$c00000,_save_addr(a5)
		move.l		#512*1024,_save_size(a5)
@@:
		bsr		info_disp		* t@C\
			moveq.l	#0,d0
			rts

inline_dst_gif:
			moveq.l	#33,d6				* E
			move.w	_colum(a5),d0
			cmp.w	#2048,d0
			bhi	error_src_info

			bsr		info_disp		* t@C\
			clr.w		_locate_err(a5)
			bsr		set_sub

			tst.b	_gif_ex_save_flag(a5)
			beq	@f
			bsr		set_sub2
@@:
			cmp.l		#384*1024,d1
			bhi		@f
			moveq.l		#21,d6			* SmۂɎs
			bsr		error_src
			st.b		_locate_err(a5)
@@:
			moveq.l		#0,d0
			rts

inline_dst_glm:
			clr.w		_locate_err(a5)

			bsr		set_sub
			move.w		_colum(a5),d0
			mulu.w		#2,d0
			cmp.l		d0,d1
			bhi		@f

			moveq.l		#21,d6			* SmۂɎs
			st.b		_locate_err(a5)
		tst.b		_workmem_gram_flag(a5)
		beq		error_src
		move.l		#$c00000,_save_addr(a5)
		move.l		#512*1024,_save_size(a5)
@@:
		bsr		info_disp		* t@C\
			moveq.l	#0,d0
			rts



* 1dot 1byte m.
set_sub:
		move.w		_colum(a5),d0
		mulu.w		_line(a5),d0
		move.l		_buff_size(a5),d1
		sub.l		d0,d1
		add.l		_buff_addr(a5),d0
		add.l		#1024,d0
		sub.l		#1024,d1
		and.l		#$fffffffe,d0
		addq.l		#2,d0
		move.l		d0,_save_addr(a5)
		move.l		d1,_save_size(a5)
		rts

* 1dot 2bytes m.
set_sub2:
		move.w		_colum(a5),d0
		mulu.w		_line(a5),d0
		add.l		d0,d0
		move.l		_buff_size(a5),d1
		sub.l		d0,d1
		bmi		@f
		add.l		_buff_addr(a5),d0
		add.l		#1024,d0
		sub.l		#1024,d1
		bmi		@f
		and.l		#$fffffffe,d0
		addq.l		#2,d0
		move.l		d0,_save_addr(a5)
		move.l		d1,_save_size(a5)
		rts
@@:
		moveq.l		#6,d6
		bra		ERROR_EXIT

info_disp:
		movem.l	d0-d1/a1,-(sp)
		bsr	make_info
		lea.l	_disp(a5),a1
*		tst.b	_redirect_flag(a5)
*		beq	@f
*		move.l	a1,-(sp)
*		DOS	_PRINT
*		addq.l	#4,sp
*		bsr	crlf
*@@:
		IOCS	_B_PRINT
		bsr	icrlf
		lea.l	_commentinfo(a5),a1
		IOCS	_B_PRINT
info_disp_end:
		movem.l	(sp)+,d0-d1/a1
*		bsr		info
		rts


*------------------------------------------------------------------------------*
*
*  [_̂߂̉摜t@Cf[^̓ǂݍ
* 
*    PC摜WJɕKvȃZbeBO
*    QC摜WJɕKvȃ[NZbeBO
*    RCcɁCt@CTCY̋󂫂邩H
*    SC摜f[^ǂݍ݁iwb_͓ǂݍ܂Ȃj
*

read_adr_get:
		move.w	_line(a5),d0
		mulu.w	_colum(a5),d0
		addq.l	#1,d0
		and.w	#$fffe,d0
		move.l	d0,_buff_req(a5)

		move.l	_buff_addr(a5),a1
		adda.l	d0,a1

		clr.b	_gif_hispeed(a5)
		cmp.w	#GIF,_src(a5)		* GIF
		bne	@f
			add.l	#FOR_PI256,d0
			adda.l	#FOR_PI256,a1

			tst.b	_gif_hispeed+1(a5)
			beq	read_adr_get_cont
			move.w	_line(a5),d6
			mulu.w	_colum(a5),d6
			addq.l	#1,d6
			and.w	#$fffe,d6
			addq.l	#2,d6
			add.l	d6,d0
			adda.l	d6,a1

			add.l	_src_fsize(a5),d0
			move.l	_buff_size(a5),d1

			st.b	_gif_hispeed(a5)

			cmp.l	d1,d0
			bls	read_adr_get_all

			clr.b	_gif_hispeed(a5)

			sub.l	_src_fsize(a5),d0
			sub.l	d6,d0
			suba.l	d6,a1

		bra	read_adr_get_cont
@@:

		cmp.w	#8,_color(a5)
		bne	@f
		cmp.w	#PI,_src(a5)
		bne	@f

		add.l	#FOR_PI256,d0
		adda.l	#FOR_PI256,a1
@@:
read_adr_get_cont:
		add.l	_src_fsize(a5),d0
		move.l	_buff_size(a5),d1

		moveq.l	#6,d6
		cmp.l	d1,d0
		bhi	error_src_info			킢.

read_adr_get_all:
		moveq.l	#3,d6
		move.l	_src_fsize(a5),-(sp)
		move.l	a1,-(sp)
		move.w	_file(a5),-(sp)
		DOS	_READ
		lea	10(sp),sp
		tst.l	d0
		bmi	error_src_info
		add.l	a1,d0
		move.l	d0,_enddata_addr(a5)

		move.w	_file(a5),-(sp)
		DOS	_CLOSE
		addq.l	#2,sp
		rts

*------------------------------------------------------------------------------*
*
*  Z[oɂo
*  (saver)
* 
*    PCZ[o֔
*    
*

inline_save:
		bsr	save_
		tst.l	d0
		bne	ERROR_DST_EXIT
		rts
save_:
		move.w		_dst(a5),d0
		cmp.w		#MAG,d0
		beq		_MAGSave
		cmp.w		#PI,d0
		beq		_PiSave
		cmp.w		#HG,d0
		beq		_HGSave
		cmp.w		#GH,d0
		beq		_GHSave
		cmp.w		#BMP,d0
		beq		_BMPSave
		cmp.w		#Q0,d0
		beq		_Q0Save
		cmp.w		#RGB,d0
		beq		_Q0Save
		cmp.w		#GIF,d0
		beq		_GIFSave
		cmp.w		#PIX,d0
		beq		_PIXSave
		cmp.w		#GLM,d0
		beq		_GLMSave
		cmp.w		#GLX,d0
		beq		_GLXSave
		moveq.l		#-1,d0
		rts


*------------------------------------------------------------------------------*

inline_fileinit:
		bsr	con_on
		moveq.l	#1,d6
		move.w	#0,-(sp)
		pea.l	_srcfile(a5)
		DOS	_OPEN
		addq.l	#6,sp
		bsr	con_off
		cmp.l	#-68,d0
		beq	error_escape
		move.w	d0,_file(a5)
		bmi	error
		move.w	_file(a5),d1
		bsr	fdate_get_sub
		move.l	d0,_src_fdate(a5)
		move.w	#2,-(sp)
		pea.l	0.w
		move.w	_file(a5),-(sp)
		DOS	_SEEK
		move.l	d0,d1
		move.w	#0,6(sp)
		DOS	_SEEK
		addq.l	#8,sp
		move.l	d1,_src_fsize(a5)
		moveq.l	#0,d0
		rts

inline_last_info:
		moveq.l		#1,d1
		tst.w		_locate_err(a5)
		beq		@f
		moveq.l		#2,d1
@@:		IOCS		_B_UP
		lea.l		$974.w,a1
		moveq.l		#0,d1
		IOCS		_B_WPOKE
*		bsr		make_info2
		bsr		con_on
		lea.l		_disp(a5),a1
		tst.b		_redirect_flag(a5)
		beq		@f
		move.l		a1,-(sp)
		DOS		_PRINT
		addq.l		#4,sp
		bsr		crlf
@@:
		IOCS		_B_PRINT
		bsr		icrlf
		lea.l		_commentinfo(a5),a1
		IOCS		_B_PRINT
		tst.w		_locate_err(a5)
		beq		@f
		moveq.l		#1,d1
		IOCS		_B_DOWN
@@:		bsr		con_off
		rts



*
*
*  fq`lWJZ[u
*
*

work_gram:
		tst.w		_disp_ofmt(a5)
		beq		work_gram_cont1
		bsr	con_on

		bsr	info_line_disp		* '------ ---'

		bsr	con_off
		clr.w		_disp_ofmt(a5)
work_gram_cont1:
		bsr		malloc_free
		moveq.l		#40,d6
		tst.l		d0
		bmi		ERROR_EXIT

		moveq.l		#26,d6

		bsr		inline_fileinit
*		bsr		fdate_get		* srcfile t擾.
		tst.l		d0
		bmi		work_gram_end
		bsr		dstfile_get		* dstfile擾

		move.w		#4,_color(a5)
		bsr		header_chk		* header擾
		tst.l		d0
		bmi		work_gram_end

		moveq.l	#36,d6				* 16FȊOΉ
		cmp.w	#4,_color(a5)
		bne	error_src

		bsr		init_work_gram

		ToSuper
		bsr		GCLR
		ToUser
		bsr		process			* WJ
		tst.l		d0
		bmi		work_gram_end

		moveq	#0,d1
		moveq	#26,d2
		IOCS	_B_LOCATE

		bsr		gram_malloc
		moveq.l		#6,d6
		tst.l		d0
		bmi		error_src

		tst.b	_workgram_clip_flag(a5)	* mPnNbsOsȂH
		beq	@f
		move.w	_color(a5),_screen_color(a5)
		moveq.l	#1,d7
		bsr	clip_and_set
		bsr	make_info_size
		lea.l	_disp(a5),a1
		IOCS	_B_PRINT
		bsr	icrlf
		bra	work_gram_cont2
@@:
		tst.b	_pics_center_flag(a5)	* mQnJnW𒆉(64,56)ɂ邩H
		beq	work_gram_cont2
		move.l	_hcolum(a5),d0
		move.w	d0,_sline(a5)
		add.w	d0,_eline(a5)
		swap.w	d0
		move.w	d0,_scolum(a5)
		add.w	d0,_ecolum(a5)
work_gram_cont2:

		move.l		_buff_size(a5),d0
		move.l		_buff_req(a5),d1
		cmp.l		d0,d1
		bhi		error_src

		bsr		gram_to_buff_main
		bsr		trans_q4

		bsr		mki_line_chk

		bsr		srcfile_delete		* srcfile폜
		bsr		dstfile_disp		* dstfile\

		bsr		comment_form

		bsr		tonedown_nowait

		bsr		slide_chk

		IOCS		_OS_CUROF

		bsr		inline_save
		tst.l		d0
		bmi		work_gram_end
		bsr		fdate_set

		tst.b		_visual_info(a5)
		beq		@f
		ToSuper
		bsr		tvram_clear
		ToUser
@@:

		bsr		gram_malloc_free
		moveq.l		#40,d6
		tst.l		d0
		bmi		ERROR_EXIT

		IOCS		_OS_CURON

		moveq.l		#12,d0
		bsr		IPRINT
		bsr		icrlf

		lea.l		_pal_buf(a5),a0
		bsr		rgb_file_write

work_gram_end
		DOS		_ALLCLOSE		* Ô
		rts


trans_q4:
		cmp.w	#Q4,_src(a5)
		bne	trans_q4_end
		tst.b	_trans_q4_flag(a5)
		beq	trans_q4_end
		cmp.w	#4,_color(a5)		* 256F͂肦Ȃ.
		bne	trans_q4_end

		lea.l	_pal_buf(a5),a0		* rbgϊ
		lea.l	_tmp(a5),a1
		lea.l	trans_dat_pal(pc),a2
		moveq.l	#16-1,d2
@@:		move.w	(a2)+,d0
		move.w	(a0,d0.w),(a1)+
		dbra	d2,@b
		lea.l	_pal_buf(a5),a0
		lea.l	_tmp(a5),a1
		move.w	#16-1,d0
@@:		move.w	(a1)+,(a0)+
		dbra	d0,@b

		lea.l	trans_dat_gram(pc),a2
		movea.l	_buff_addr(a5),a0
		movea.l	a0,a1
		move.w	_colum(a5),d2
		mulu.w	_line(a5),d2
		subq.l	#1,d2
@@:		moveq.l	#0,d0
		move.b	(a0)+,d0
		add.w	d0,d0
		move.w	(a2,d0.w),d0
		move.b	d0,(a1)+
		dbra	d2,@b
		clr.w	d2
		subq.l	#1,d2
		bcc	@b
trans_q4_end:
		rts

trans_dat_pal:
	.dc.w	2*(1-1)
	.dc.w	2*(5-1)
	.dc.w	2*(2-1)
	.dc.w	2*(6-1)
	.dc.w	2*(3-1)
	.dc.w	2*(7-1)
	.dc.w	2*(4-1)
	.dc.w	2*(8-1)
	.dc.w	2*(9-1)
	.dc.w	2*(13-1)
	.dc.w	2*(10-1)
	.dc.w	2*(14-1)
	.dc.w	2*(11-1)
	.dc.w	2*(15-1)
	.dc.w	2*(12-1)
	.dc.w	2*(16-1)

trans_dat_gram:
	.dc.w	%0000
	.dc.w	%0010
	.dc.w	%0100
	.dc.w	%0110
	.dc.w	%0001
	.dc.w	%0011
	.dc.w	%0101
	.dc.w	%0111
	.dc.w	%1000
	.dc.w	%1010
	.dc.w	%1100
	.dc.w	%1110
	.dc.w	%1001
	.dc.w	%1011
	.dc.w	%1101
	.dc.w	%1111





mki_line_chk:
		tst.b		_200flag(a5)
		beq		mki_line_chk_end
		tst.b	_workgram_clip_flag(a5)		* I[gNbsOgpĂ邩H
		bne		mki_line_chk_end
		move.w		#200,_line(a5)
		move.w		#199,_eline(a5)
		move.b		_MSXflag(a5),d0
		beq		msx_0
		cmp.b		#1,d0
		beq		msx_1
		cmp.b		#2,d0
		beq		msx_2
		cmp.b		#3,d0
		beq		msx_3
msx_1:
		rts
msx_2:
		move.w		#212,_line(a5)
		move.w		#211,_eline(a5)
		rts
msx_3:
		move.w		#400,_line(a5)
		move.w		#399,_eline(a5)
		rts
msx_0:
		lea.l		_mki_com(a5),a0
		cmp.w		#'MS',(a0)+
		bne		mki_line_chk_end
		cmp.b		#'X',(a0)+
		bne		mki_line_chk_end
		move.w		#212,_line(a5)
		move.w		#211,_eline(a5)
mki_line_chk_end:
		rts

*------------------------------------------------------------------------------*
*
*  OvZXpwb_`FbN
*

header_chk:
		bsr	header_chk__
		tst.l	d0
		bmi	error_src
		move.w	_file(a5),-(sp)
		DOS	_CLOSE
		addq.l	#2,sp
		rts

header_chk__:
		move.w		_src(a5),d0
		cmp.w		#MAG,d0
		beq		mag_header_read
		cmp.w		#PI,d0
		beq		pi_header_read
		cmp.w		#HG,d0
		beq		hg_header_read
		cmp.w		#GH,d0
		beq		gh_header_read
		cmp.w		#BMP,d0
		beq		bmp_header_read
		cmp.w		#GIF,d0
		beq		gif_header_read
		cmp.w		#PIX,d0
		beq		pix_header_read
		cmp.w		#PT4,d0
		beq		pt4_header_read
		moveq.l		#0,d0
		rts


*------------------------------------------------------------------------------*
*
*  摜OvZXNWJ
*

process:
		lea	(_srcfile,a5),a2
		move	(_src,a5),d0
		lea	(process_table,pc),a1
process_loop:
		cmp.b	(a1)+,d0
		beq	process_found
@@:
		tst.b	(a1)+
		bne	@b
		tst.b	(a1)
		bpl	process_loop

	.if	0
sps:
		lea	(sps_l,pc),a1
		lea	(spsdat,pc),a2
		bra	process_found
	.endif
process_error:
		moveq	#25,d6
		bra	ERROR_SRC_EXIT
process_found:
		bsr	child
		tst.l	d0
		bmi	process_error
		moveq	#1,d6
		rts

process_table:
		.dc.b	MAG,	'mag',0
		.dc.b	PI,	'pi',0
		.dc.b	HG,	'hg',0
		.dc.b	GH,	'ghh -r0',0
		.dc.b	Q4,	'hsx',0
		.dc.b	MKI,	'magh',0
		.dc.b	GRA,	'qld68k',0
		.dc.b	QPC,	'qpc -t',0
		.dc.b	PIC,	'apicg',0
		.dc.b	BMP,	'apicg',0
		.dc.b	GIF,	'gifh -r0',0
		.dc.b	-1			;end of table
		.even

	.if	0
spsdat:		.dc.b	'sps a',0
sps_l:		.dc.b	'command',0
		.even
	.endif

*-------------------------------------------------------------------------------
*
*  misc.
*
*

*
* ϐ
*
init:
		cmp.w		#1,_comm(a5)
		beq		init_work_gram
		move.w		#$1a,_comment(a5)
		clr.w		_200flag(a5)		* 200lineIt
init_work_gram:
		move.w		#0,_scolum(a5)
		move.w		#0,_sline(a5)
		move.w		#640,_colum(a5)
		move.w		#400,_line(a5)
		move.w		#639,_ecolum(a5)
		move.w		#399,_eline(a5)
		move.l		#640*400/2,_buff_req(a5)
		clr.w		_1dot(a5)		* 1hbgflag
		clr.w		_rgb_flag(a5)		* tJ[RGB pbg̗L
		move.w		#$2000,_PP_flag(a5)
		rts

*
*  RGBt@Co
*
rgb_file_write:
		tst.b		_makeRGBflag(a5)
		beq		@f
		cmp.w		#4,_color(a5)
		bne		@f
		cmp.w		#RGB,_dst(a5)
		beq		@f
		lea.l		_pal_rgb(a5),a1
		bsr		get_rgb
		move.w		#$20,-(sp)
		pea.l		_rgbfile(a5)
		DOS		_CREATE
		addq.l		#6,sp
		move.w		d0,d1
		move.l		#48,-(sp)
		move.l		a1,-(sp)
		move.w		d1,-(sp)
		DOS		_WRITE
		lea.l		10(sp),sp
		bsr		fdate_set_sub
		move.w		d1,-(sp)
		DOS		_CLOSE
		addq.l		#2,sp
@@:		rts

*
*  RGBt@CpbgƂăZbg
*
palet_set:
		bsr		con_on
		moveq.l		#1,d6
		move.w		#0,-(sp)
		pea.l		_arg(a5)
		DOS		_OPEN
		addq.l		#6,sp
		bsr		con_off
		cmp.l	#-68,d0
		beq	error_escape
		move.w		d0,d1
		bmi		ERROR_ARG_EXIT
		move.l		#48,-(sp)
		pea.l		_pal_rgb(a5)
		move.w		d1,-(sp)
		DOS		_READ
		lea.l		10(sp),sp
		move.w		d1,-(sp)
		DOS		_CLOSE
		addq.l		#2,sp
		lea.l		_pal_rgb(a5),a1
		lea.l		_pal_buf(a5),a0
		bsr		set_rgb
		moveq.l		#0,d0
		rts

* d1  0 ŋgp.

*
*  GRAM`FbNi蔲Łj
*
chk_gram:
		move.b	d1,d3
		moveq.l	#26,d6			* G-VRAMgpł.
		moveq.l	#0,d1
		moveq.l	#$ff,d2
		IOCS	_TGUSEMD
		tst.l	d0		* gpĂȂ
		beq	chk_gram_end
		cmp.w	#3,d0		* ꂽ܂
		beq	chk_gram_end
		tst.b	d3
		beq	ERROR_EXIT
		moveq.l	#0,d1
		moveq.l	#3,d2
		IOCS	_TGUSEMD
chk_gram_end:
		rts

*
*  I[gNbsOčWCTCYZbg
*
clip_and_set:
		cmp.w	#8,_screen_color(a5)
		beq	clip_and_set256
		ToSuper
		moveq.l	#0,d1
		move.b	_visual_info(a5),d1
		bsr	clipping
		bsr	dot8m
			cmp.w	#2,d7
			bne	@f
			cmp.w	#639-1,d0
			bhi	@f
			move.w	#639,d0
@@:		move.w	d0,_ecolum(a5)
		move.w	d0,d2
		swap.w	d0
		bsr	dot8
			cmp.w	#2,d7
			bne	@f
			move.w	#0,d0
@@:		move.w	d0,_scolum(a5)
		sub.w	d0,d2
		addq.w	#1,d2
		move.w	d2,_colum(a5)

			cmp.w	#2,d7
			bne	@f
			cmp.w	#399-1,d1
			bhi	@f
			move.w	#399,d1
@@:		move.w	d1,_eline(a5)
		move.w	d1,d3
		swap.w	d1
			cmp.w	#2,d7
			bne	@f
			move.w	#0,d1
@@:		move.w	d1,_sline(a5)
		sub.w	d1,d3
		addq.w	#1,d3
		move.w	d3,_line(a5)
		mulu.w	d2,d3
		move.l	d3,_buff_req(a5)
		ToUser
		rts

dot8:	* 8̔{
		move.w	d1,-(sp)
		move.w	d0,d1
		and.w	#%111,d1
		beq	@f
		and.w	#$fff8,d0
*		subq.w	#8,d0
@@:		move.w	(sp)+,d1
		rts

dot8m:	* 8̔{-1,  0  7 ɕ␳
		move.w	d1,-(sp)
		move.w	d0,d1
		bne	@f
		move.w	#7,d0
		bra	@@f
@@:		addq.w	#1,d1
		and.w	#%111,d1
		beq	@f
		and.w	#$fff8,d0
		addq.w	#7,d0
@@:		move.w	(sp)+,d1
		rts

clip_and_set256:
		ToSuper
		moveq.l	#0,d1
		move.b	_visual_info(a5),d1
		bsr	clipping256
		bsr	dot4m
		move.w	d0,_ecolum(a5)
		move.w	d0,d2
		swap.w	d0
		bsr	dot4
		move.w	d0,_scolum(a5)
		sub.w	d0,d2
		addq.w	#1,d2
		move.w	d2,_colum(a5)

		move.w	d1,_eline(a5)
		move.w	d1,d3
		swap.w	d1
		move.w	d1,_sline(a5)
		sub.w	d1,d3
		addq.w	#1,d3
		move.w	d3,_line(a5)
		mulu.w	d2,d3
		move.l	d3,_buff_req(a5)
		ToUser
		rts

dot4:	* 4̔{
		move.w	d1,-(sp)
		move.w	d0,d1
		and.w	#%11,d1
		beq	@f
		and.b	#%1111_1100,d0
*		subq.w	#4,d0
@@:		move.w	(sp)+,d1
		rts

dot4m:	* 4̔{-1,  0  3 ɕ␳
		move.w	d1,-(sp)
		move.w	d0,d1
		bne	@f
		move.w	#3,d0
		bra	@@f
@@:		addq.w	#1,d1
		and.w	#%11,d1
		beq	@f
		and.b	#%1111_1100,d0
		addq.w	#3,d0
@@:		move.w	(sp)+,d1
		rts

chk_prg_ext:
		move.l	a0,-(sp)
		moveq.l	#1,d0
		lea.l	$b0(a0),a0
		adda.l	#$14,a0
@@:		tst.b	(a0)+
		bne	@b
		subq.l	#3,a0
		cmp.b	#'.',(a0)+
		bne	@f
		move.b	(a0),d0
		or.b	#$20,d0
		sub.b	#$60,d0
@@:		move.b	d0,_chk_prg_flag(a5)
chk_prg_ext_end:
		move.l	(sp)+,a0
		rts

*
*  
*
decARG:
		lea	(_arg,a5),a0
@@:
		bsr	GetArgChar
		move.b	d0,(a0)+
		bne	@b
		bra	chkext
*		rts


esckey_chk:
		move.w	#$ff,-(sp)
		DOS	_INPOUT
		addq.l	#2,sp
		cmp.b	#$1b,d0
		rts

info_line_disp:
		bsr	info_line
		IOCS	_B_PRINT
*		moveq.l	#29,d0		* '------ ---'
*		bsr	IPRINT
		bsr	icrlf
		tst.b	_redirect_flag(a5)
		beq	@f
		bsr	info_line
		move.l	a1,-(sp)
		DOS	_PRINT
		addq.l	#4,sp
*		moveq.l	#29,d0		* '------ ---'
*		bsr	DPRINT
		bsr	crlf
@@:		rts

slide_chk:
		tst.b	_6456_slide_flag(a5)
		beq	@f
		move.l	_hcolum(a5),d0
		move.w	_scolum(a5),d1
		move.w	_sline(a5),d2
		sub.w	d0,d2
		bmi	@f
		swap.w	d0
		sub.w	d0,d1
		bmi	@f
		sub.w	d0,_scolum(a5)
		sub.w	d0,_ecolum(a5)
		swap.w	d0
		sub.w	d0,_sline(a5)
		sub.w	d0,_eline(a5)
@@:
		rts

gram_to_buff_main:
		cmp.w	#8,_color(a5)
		beq	@f
		bsr	gram_to_buff
		rts
@@:		bsr	gram_to_buff256
		rts

gram_to_buff_only_main:
		cmp.w	#8,_color(a5)
		beq	@f
		bsr	gram_to_buff_only
		rts
@@:		bsr	gram_to_buff256_only
		rts

*------------------------------------------------------------------------------
*
*  CONDRV䃋[`
*

MOVEM_CODE:	.equ	$48e7
RTS_CODE:	.equ	$4e75

con_init:
	clr.l	(_condrv_addr,a5)
	clr	(_condrv_flag,a5)
	tst.b	(_no68_flag,a5)		* 68p̈ւ̃ANZX
	bne	1f
	movem.l	d0/a0,-(sp)
	ToSuper
	movea.l	(_KEY_INIT*4+$400),a0
	cmp.l	#'hmk*',(-4,a0)
	bne	@f
	movea.l	(-16,a0),a0
	move.l	a0,(_condrv_addr,a5)
	move	(a0),(_condrv_flag,a5)
@@:	ToUser
	movem.l	(sp)+,d0/a0
1:	rts

con_restore:
	movem.l	d0-d1/a0,-(sp)
	move	(_condrv_flag,a5),d1
	bra	con_main
con_on:
	movem.l	d0-d1/a0,-(sp)
	move	#MOVEM_CODE,d1
	bra	con_main
con_off:
	movem.l	d0-d1/a0,-(sp)
	move	#RTS_CODE,d1
con_main:
	tst.l	(_condrv_addr,a5)
	beq	con_main_end

	ToSuper
	movea.l	(_condrv_addr,a5),a0
	move	d1,(a0)

	cmpi.b	#1,(MPU_TYPE)
	bls	@f
	moveq	#3,d1
	IOCS	_SYS_STAT
@@:
	ToUser
con_main_end:
	movem.l	(sp)+,d0-d1/a0
	rts


*-------------------------------------------------------------------------------
*
*  Error routines.
*
*

error_escape:
		moveq.l	#-1,d0
		rts

error:
**		bsr	C_ON
		bsr	con_on
		move.l	a1,-(sp)
		move.l	d6,d0
		suba.l	a1,a1
		bsr	ERROR
		move.l	(sp)+,a1
**		bsr	C_OFF
		bsr	con_off
		moveq.l	#-1,d0
		rts

error_arg:
**		bsr	C_ON
		bsr	con_on
		move.l	a1,-(sp)
		move.l	d6,d0
		lea.l	_arg(a5),a1
		bsr	ERROR
		move.l	(sp)+,a1
**		bsr	C_OFF
		bsr	con_off
		moveq.l	#-1,d0
		rts

error_src_info:
		move.l	#192837465,d5
		bra	error_src

		cmp.l	#6,d6
		bne	error_src
		bsr	con_on
		moveq.l	#22,d0
		bsr	IPRINT
		move.l	_buff_size(a5),d0
		divu.w	#1024,d0
		bsr	prtdec
		moveq.l	#18,d0
		bsr	IPRINT
		bsr	icrlf
		moveq.l	#23,d0
		bsr	IPRINT
		move.l	_buff_req(a5),d0
		add.l	_src_fsize(a5),d0
		divu.w	#1024,d0
		tst.w	d0
		bne	@f
		moveq.l	#1,d0
@@:		bsr	prtdec
		moveq.l	#18,d0
		bsr	IPRINT
		bsr	con_off
		bsr	icrlf

		movem.l	d0-d1/a1,-(sp)
		bsr	make_info
**		bsr	C_ON
		bsr	con_on
		lea.l	_disp(a5),a1
*		tst.b	_redirect_flag(a5)
*		beq	@f
*		move.l	a1,-(sp)
*		DOS	_PRINT
*		addq.l	#4,sp
*		bsr	crlf
*@@:
		IOCS	_B_PRINT
		bsr	icrlf
**		bsr	C_OFF
		bsr	con_off
		movem.l	(sp)+,d0-d1/a1
		bra	error_src

error_src:
**		bsr	C_ON
		bsr	con_on
		move.l	a1,-(sp)
		move.l	d6,d0
		lea.l	_srcfile(a5),a1
		bsr	ERROR
		move.l	(sp)+,a1
**		bsr	C_OFF
		bsr	con_off
		cmp.l	#192837465,d5
		bne	error_src_end
		cmp.l	#6,d6
		bne	error_src_end
		bsr	con_on
		moveq.l	#22,d0
		bsr	IPRINT
		move.l	_buff_size(a5),d0
		divu.w	#1024,d0
		bsr	prtdec
		moveq.l	#18,d0
		bsr	IPRINT
		bsr	icrlf
		moveq.l	#23,d0
		bsr	IPRINT
		move.l	_buff_req(a5),d0
		add.l	_src_fsize(a5),d0
		divu.w	#1024,d0
		tst.w	d0
		bne	@f
		moveq.l	#1,d0
@@:		bsr	prtdec
		moveq.l	#18,d0
		bsr	IPRINT
		bsr	icrlf
		bsr	con_off
error_src_end:
		moveq.l	#-1,d0
		rts

error_nodisp:
		moveq.l	#-1,d0
		rts

error_dst:
**		bsr	C_ON
		bsr	con_on
		move.l	a1,-(sp)
		move.l	d6,d0
		lea.l	_dstfile(a5),a1
		bsr	ERROR
		move.l	(sp)+,a1
**		bsr	C_OFF
		bsr	con_off
		moveq.l	#-1,d0
		rts

ERROR_EXIT:
		bsr	error
		bra	ERROR_GROBAL_EXIT

ERROR_SRC_EXIT:
		bsr	error_src
		bra	ERROR_GROBAL_EXIT

ERROR_ARG_EXIT:
		bsr	error_arg
		bra	ERROR_GROBAL_EXIT

ERROR_DST_EXIT:
		move.l	d0,d6
		bsr	icrlf
		bsr	icrlf
		lea.l	_dstfile(a5),a1
		bsr	error_dst
		DOS	_ALLCLOSE
		lea.l	_dstfile(a5),a1
		move.l	a1,-(sp)
		DOS	_DELETE
		addq.l	#4,sp
		bra	ERROR_GROBAL_EXIT

ERROR_GROBAL_EXIT:
		bsr	con_restore
**		bsr	C_ON
		bsr	trans_clr
*		bsr	text_on
		IOCS	_OS_CURON
		move.w	d6,-(sp)
		DOS	_EXIT2


usage_long:
		move.w	#1234,d2
usage:
		sub.w	#1234,d2
		moveq.l	#$e,d1
		IOCS	_BITSNS
		btst.l	#0,d0
		beq	@f
		moveq.l	#0,d2
@@:		lea.l	usgmes(pc),a1
		IOCS	_B_PRINT
**		lea.l	usgmes2(pc),a1
**		tst.w	d2
**		bne	@f
**		lea.l	usgmes3(pc),a1
**@@:
**		IOCS	_B_PRINT
		move.w	#1,-(sp)
		DOS	_EXIT2

title:
		move.l	a1,-(sp)
		lea	(titlemes,pc),a1

		move	#STDOUT,-(sp)
		clr	-(sp)
		DOS	_IOCTRL
		addq.l	#4,sp
		tst.b	d0
		bmi	@f

		st	(_redirect_flag,a5)	;_CNg...
		pea	(a1)
		DOS	_PRINT
		addq.l	#4,sp
		bsr	crlf
@@:
		IOCS	_B_PRINT
		bsr	icrlf
		move.l	(sp)+,a1
		rts


* Data Section -------------------------------- *

*		.data
		.even

titlemes:
	.dc.b	'X68k 摜Ro[^EZ[o < MPH3 > v',version,localversion,' programmed 1994,95,96,97 by Herzen',CRLF
	.dc.b	' patchlevel ',patchlevel,' ,97/03/28 Ԃq.',0
usgmes:
	.dc.b	CRLF
	.dc.b	'gp@: mph [option] [.OFMT] file ...',CRLF
	.dc.b	'	-a		TCYĔ',CRLF
	.dc.b	'	-b path		o͐fBNg̎w',CRLF
	.dc.b	'	-d		t@CȂRo[g',CRLF
	.dc.b	'	-n		.OFMTƓtH[}bg̃Ro[g̋',CRLF
	.dc.b	'	-cc		Rg폜',CRLF
	.dc.b	'	-cq(-qc)	[.Q4͎] .Q4Dt@CRg擾',CRLF
**	.dc.b	'	-cqa(-cqq)	.Q4Ro[gȊOłC-cq Kp',CRLF
	.dc.b	'	-cf file	Rg̈file̓eɕύX',CRLF
	.dc.b	'	-cg file	Rg̈摜filẽRgɕύX',CRLF
**	.dc.b	'	-c6		[Pi,HG͎] UڂɃ[UĂt@CɑΏ',CRLF
**	.dc.b	'	-cm		[Pi,HG͎] RgMAG擾Ƃ݂Ȃ',CRLF
**	.dc.b	'	-cu"username"	Userw莞ɂ镶widefault:"><")',CRLF
	.dc.b	'	-rs		.RGBpbgt@C쐬',CRLF
	.dc.b	'	-rl rgbfile	.RGBpbgt@CpbgɎw',CRLF
	.dc.b	'	-pi		[.Pio͎] Z[uʒu񖳎',CRLF
**	.dc.b	'	-ps		[.Pio͎] 64,56dots炵Z[u',CRLF
	.dc.b	'	-qt		[.Q4͎] rbgϊsȂ',CRLF
	.dc.b	'	-fi		[.GIFo͎] C^[XZ[usȂ',CRLF
	.dc.b	'	-to8 / -to24	[.BMPo͎] 256F(8bit)/tJ[(24bit)ŏo',CRLF
**	.dc.b	'	-ml[n]		[.MKI͎] chbg摜̂xTCY@(n=0`3)',CRLF
;	.dc.b	'	-w?		MPH3֘A',CRLF
**	.dc.b	'	-wp		ׂĊOvZXɗ',CRLF
**	.dc.b	'	-wc		OWJTCY聨Z[u',CRLF
**	.dc.b	'	-wf		WJ\TCY聨Z[u',CRLF
**	.dc.b	'	-we		w肳ꂽ.OFMTo̓t@Cɔf',CRLF
**	.dc.b	'	-ws		64,56dotsジ炵Z[u',CRLF
**	.dc.b	'	-wx		OWJɂāCʒ(64,56)-(703,455)ŃZ[u',CRLF
**	.dc.b	'	-wz(-z)		gq⊮sȂȂ',CRLF
;	.dc.b	'	-g?? ` \ȂRo[g `',CRLF
	.dc.b	'	-g[n]		摜\Ro[g(n=1`2)',CRLF
**	.dc.b	'	-gw<nn>		nn~0.01b҂ĂRo[gJniftHgF0.20bj',CRLF
**	.dc.b	'	-gp<nn>		pbgnnɗƂiftHgF50j',CRLF
**	.dc.b	'	-gt		Ro[g̓eLXgʂ\Ȃ',CRLF
**	.dc.b	'	-gc		Ro[gICOtBbNʂNAȂ',CRLF
	.dc.b	'@` ϊIvV `',CRLF
	.dc.b	'	-pp		摜\',CRLF
	.dc.b	'	-l		[h',CRLF
**	.dc.b	'	-le		\C50g[_E',CRLF
**	.dc.b	'	-lk		L[҂',CRLF
	.dc.b	'	-lm[n1,,,nn]	ݕ\̉摜ɏd˂ĕ\iftHgF(0,0)̐F𔲂j',CRLF
;	.dc.b	'	-s?? ` Z[oƂĎgp `',CRLF
	.dc.b	'	-s[sx,sy,ex,ey]	Z[uiftHgF16F:0,0,639,399  256F:0,0,511,511j',CRLF
	.dc.b	'	-sc		TCYZ[u',CRLF
**	.dc.b	'	-scm		TCYZ[u(Œ:0,0,639,399)',CRLF
**	.dc.b	'	-sm		ʃ[h16F1024x1024ɐݒ',CRLF
**	.dc.b	'	-st[size] file	file\CRgێ size ŃZ[u(ŌɎw肷)',CRLF
**	.dc.b	'	-su		ϐUSERQƂȂ',CRLF
	.dc.b	CRLF
*	.dc.b	'ELȊÕXCb`܂D}jAD',CRLF
*	.dc.b	CRLF
	.dc.b	'input:  .MAG .PI .HG .GIF .BMP .PIX .PT4 (.MKI .GRA .QPC .PIC .Q4)',CRLF
	.dc.b	'output: .MAG .PI .HG .GIF .BMP .PIX .GLM .GLX .Q0',CRLF
	.dc.b	0
*usgmes2:
*usgmes3:
*	.dc.b	'|Owv|',CRLF
*	.dc.b	0
	.even

mph_header:
	.dc.b	'MPH3',0,0


		.end	ent

* End of File --------------------------------- *
