.comment comments *-------------------------------------------------------------*
|										|
|	Pi(16/256) Graphic Saver for over1024/512				|
|										|
|					original program by Ȃ		|
|					rewrited program by Herzen		|
|										|
|			   xpi_save.s Copyright (c) 1990,91 Ȃ		|
|										|
|				--       based on xpi_save.s v1.08  --		|
|				--  modified for pi_save.has v2.00  --		|
comments *----------------------------------------------------------------------*

		.include	doscall.mac
		.include	config.h
		.include	mph.h
		.include	mph_lib.h

		.xdef	_PiSave__


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*
* Pi(16/256)摜k
*
* in  Ȃ
*
* out d0.w =        0 : I
*            ȊO : G[R[h
*
* (l) 16/256Fɂ炸CPsNZPoCgD
*        zGRAMpłCGRAMk͂ȂD
*
*----------------------------------------------------------------------------*

_PiSave__:
		movem.l	d3-d7/a3-a6,-(sp)
		movea.l	_save_addr(a5),a6	* a6 = [NZbg
		bsr	PiSave
		movem.l	(sp)+,d3-d7/a3-a6
		rts

PiSave:
		clr.w	file(a6)
		bsr	PiSaveX
		rts

PiSaveX:
		move.l	sp,stk(a6)

		lea.l	_dstfile(a5),a0
		move.l	a0,file_name(a6)
		moveq.l	#0,d0
		move.w	_colum(a5),d0		* Xwid
		tst.w	_1dot(a5)
		beq	@f
		moveq.l	#1,d0
@@:		move.l	d0,x_width(a6)
		move.w	_line(a5),y_width(a6)	* Ywid
		move.w	y_width(a6),y_buff(a6)

		move.l	x_width(a6),d0
		move.l	d0,dif(a6)
		add.l	d0,d0
		move.l	d0,dif2(a6)
		move.l	d0,dif3(a6)

		move.l	_buff_addr(a5),addr(a6)	zGRAMAhX
		move.w	_color(a5),plane(a6)

		bsr	pi_head_write		* wb_o
		move.w	d5,file(a6)

		bsr	save_color_initialize	color table init.

		move.l	_save_addr(a5),a0
		move.l	_save_size(a5),d0	size
		adda.l	#1024+2*FOR_PI256,a0
		sub.l	#1024+2*FOR_PI256,d0
		move.l	a0,gbuff(a6)		graph buff
		lea	8192(a0),a0		file buff
		sub.l	#8192,d0
		and.l	#$ffff_fffe,d0
		move.l	d0,buff_size(a6)
		move.l	d0,buff_lest(a6)
		move.l	a0,buff_addr(a6)
		moveq.l	#15,d7

** ȌCa5 ͎gȂ.
		move.l	a0,a5

		bsr	press			k
		bsr	flush			t@Cobt@tbV

		move.w	file(a6),-(sp)
		DOS	_CLOSE
		addq.l	#2,sp
		moveq.l	#0,d0
		rts


*----------------------------------------------------------------------------*
*
* Piwb_o
*
* in  Ȃ
*
* out d0.w =        0 : 
*            ȊO : G[R[h
*     d5.w = t@Cnh
*
* (l) Epbg܂łoD
*        E_comment(a5) 𐴏Ă邱ƁD
*
*----------------------------------------------------------------------------*

pi_head_write:
		lea.l	_commentx(a5),a0
		move.w	#$20,-(sp)
		pea.l	_dstfile(a5)
		DOS	_CREATE
		addq.l	#6,sp
		moveq.l	#2,d6
		move.w	d0,d5
		bmi	file_error

		move.w	#'Pi',(a0)+		* Piwb_F
		lea.l	_comment(a5),a1
		bsr	strcpy
		move.b	#26,(a0)+
		clr.b	(a0)+			*eof zero
		clr.b	(a0)+			*mode

		tst.w	_200flag(a5)
		bne	pisave4
		clr.b	(a0)+			䗦
		clr.b	(a0)+
		bra	pisave5
pisave4
		move.b	#2,(a0)+		䗦
		move.b	#1,(a0)+
pisave5
		move.b	_color+1(a5),(a0)+	*v[
	.if	0
		lea	(_mph_head,a5),a1
		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+
	.else
		.irpc	char,'X68K'
			move.b	#'&char',(a0)+
		.endm
	.endif

		tst.l	_scolum(a5)
		beq	_save_0
		tst.w	_O(a5)
		bne	_save_0			* Z[uʒu񖳎

		clr.b	(a0)+			* Z[uʒuL^.
		move.b	#5,(a0)+
		move.b	#1,(a0)+
		move.w	_scolum(a5),d1
		move.w	_sline(a5),d2
		ror.w	#8,d1
		move.b	d1,(a0)+
		ror.w	#8,d1
		move.b	d1,(a0)+
		ror.w	#8,d2
		move.b	d2,(a0)+
		ror.w	#8,d2
		move.b	d2,(a0)+
		bra	pisavecont
_save_0:
		clr.b	(a0)+			* ̗\@TCY(2bytes)
		clr.b	(a0)+			* ł́Cf[^Ȃ̂ 0 
pisavecont:
		move.b	_colum(a5),(a0)+
		move.b	_colum+1(a5),(a0)+
		move.b	_line(a5),(a0)+
		move.b	_line+1(a5),(a0)+

pi_palet:
		lea.l	_pal_buf(a5),a1		* pbgL^
		moveq.l	#1,d0
		move.w	_color(a5),d1
		lsl.l	d1,d0
		subq.w	#1,d0
pisave0
		move.w	(a1)+,d1
		move.w	d1,d2
		and.w	#$7c0,d2
		btst.l	#0,d1
		beq	pisave1
		or.w	#$20,d2
pisave1
		lsr.w	#3,d2
		move.b	d2,(a0)+
		move.w	d1,d2
		and.w	#$f800,d2
		btst.l	#0,d1
		beq	pisave2
		or.w	#$400,d2
pisave2
		lsr.w	#8,d2
		move.b	d2,(a0)+
		and.w	#$3f,d1
		lsl.w	#2,d1
		move.b	d1,(a0)+
		dbra	d0,pisave0

		move.l	a0,d0
		lea.l	_commentx(a5),a0
		sub.l	a0,d0
		move.l	d0,-(sp)
		pea.l	_commentx(a5)
		move.w	d5,-(sp)
		DOS	_WRITE			܂ł̃wb_o
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error
		lea	10(sp),sp
		moveq.l	#0,d0
		rts


*----------------------------------------------------------------------------*
*
* 16/256摜kC
*
*----------------------------------------------------------------------------*

press
		move.l	dif(a6),d0			* ̒idef=2048,=GRAMj
		mulu	y_width(a6),d0			* c̒
		add.l	addr(a6),d0
		move.l	d0,end_addr(a6)

		move.l	x_width(a6),d0
		cmp.l	#2,d0
		ble	press_one

		subq.l	#1,d0
		move.l	d0,x_width_1(a6)		* ̒|P
		move.l	x_width(a6),d0
**		add.l	d0,d0
		move.w	d0,x_width2(a6)			* ̒~Q
		move.l	dif(a6),d0
		addq.l	#1,d0
		move.l	d0,dif_l(a6)			* 2048+2
		subq.l	#2,d0
		move.l	d0,dif_r(a6)			* 2048-4

		move.l	gbuff(a6),a2
		move.l	addr(a6),now_addr(a6)
		move.l	now_addr(a6),a1
		clr.w	d0
		move.b	(a1),d0				* GRAM
		clr.w	d1
		move.b	1(a1),d1			* GRAM

		move.w	#4096-1,d2
press3
		move.b	d0,(a2)+			* obt@
		move.b	d1,(a2)+			* obt@
		dbra	d2,press3

		clr.w	d0
		clr.w	d1
		move.b	(a1),d1				* GRAM
		bsr	write_color

		clr.w	d0
		move.b	(a1),d0				* GRAM
		clr.w	d1
		move.b	1(a1),d1			* GRAM
		bsr	write_color

		move.l	x_width(a6),d2		*d2 as x_width
		subq.l	#1,d2

		move.l	addr(a6),a2		* fix 3-16		* GRAM

		clr.w	d4			*d4 as pos
		clr.w	d5
		move.b	(a1),d5						* GRAM
**		ext.w	d5
		clr.w	d3
		move.b	1(a1),d3		*d3 as before		* GRAM
**		ext.w	d3
press0
		bsr	calc
		tst.l	d0
		bne	press1			* Z[u
	*************************************************************
	*	bsr	wrt_pos

		cmp.w	#3,d4
		bgt.b	Awrt_pos0
		move.w	d4,d0
		sub.w	#1,d0
		move.w	#2,d1
		bsr	save_bit		* ʒuL^
		bra.b	press2
Awrt_pos0	move.w	d4,d0
		add.w	#2,d0
		move.w	#3,d1
		bsr	save_bit
		bra.b	press2
	*************************************************************
press4
		dbra	d7,press4X
		moveq.l	#1,d1
		moveq.l	#-1,d0
		pea	press4XX(pc)
		bra	save_bit_a
press4X
		move.w	#$8000,d6
		add.l	d6,d6
press4XX

press2
		move.w	d3,d0
		clr.w	d1
		move.b	(a1)+,d1		* GRAM
**		ext.w	d1
		bsr	write_color
		dbra	d2,pressA
		subq.w	#1,y_width(a6)
		bne	pressA0
		move.w	d1,d0
		clr.w	d1
		bsr	write_color
		bra	press_end
pressA0
		move.l	x_width(a6),d2
		subq.l	#1,d2
		move.l	dif(a6),d0		* GRAM ̃C
		add.l	d0,now_addr(a6)		*
		move.l	now_addr(a6),a1		*
pressA
		move.w	d1,d5
		move.w	d1,d0
		clr.w	d1
		move.b	(a1)+,d1		* GRAM
**		ext.w	d1
		bsr	write_color
		dbra	d2,pressB
		subq.w	#1,y_width(a6)
		beq	press_end
		bsr	ldisp
		move.l	x_width(a6),d2
		subq.l	#1,d2
		move.l	dif(a6),d0		* GRAM ̃C
		add.l	d0,now_addr(a6)		*
		move.l	now_addr(a6),a1		*
pressB
		move.w	d1,d3
		clr.w	d4
		bsr	calc
		tst.l	d0
		beq	press4

		movem.l	d0/d1,-(sp)
pressX
		dbra	d7,pressXX
		moveq.l	#1,d1
		moveq.l	#0,d0
		pea	pressXXX(pc)
		bra	save_bit_a
pressXX
		clr.w	d6
		add.l	d6,d6
pressXXX
		movem.l	(sp)+,d0/d1
press1
		move.w	d1,d4
	*************************************************************
	*	bsr	wrt_pos
		move.l	d0,d3
		cmp.w	#3,d4
		bgt.b	Bwrt_pos0
		move.w	d4,d0
		sub.w	#1,d0
		move.w	#2,d1
		bra.b	Bwrt_pos1
Bwrt_pos0	move.w	d4,d0
		add.w	#2,d0
		move.w	#3,d1
Bwrt_pos1	bsr	save_bit
		move.l	d3,d0
	*************************************************************
	*	bsr	save_length
	*	Z[u
	*
save_length	* in d0
		cmp.l	#7,d0
		ble	save_l

		movem.l	d0-d5,-(sp)
		move.l	d0,d3
		moveq.l	#0,d1
		moveq.l	#2,d2
save_len0
		cmp.l	d2,d0
		blt	save_len1
		addq.l	#1,d1
		add.l	d2,d2
		bra	save_len0
save_len1
		addq.l	#1,d1
		cmp.w	#8,d1
		bgt	save_len2
		move.w	#$ffe,d0
		move.l	d1,-(sp)
		bsr	save_bit
		move.l	(sp)+,d1
		subq.w	#1,d1
		beq	save_len_end
		lsr.l	#1,d2
		sub.l	d2,d3
		move.l	d3,d0
		bsr	save_bit
		bra	save_len_end
save_len2
		move.w	d1,-(sp)

	* save_bit
		moveq.l	#8,d1
		moveq.l	#-1,d0
		sub.w	d1,d7
		bge	save_len2x
		pea	save_len2xx(pc)
		bra	save_bit_a
save_len2x
		move.w	d0,d6
		lsl.l	d1,d6
save_len2xx
		move.w	(sp),d1
		subq.l	#8,d1
		move.w	#$fffe,d0
		bsr	save_bit

		move.w	(sp)+,d1
		sub.w	#1,d1
		move.l	d1,d4

		lsr.l	#1,d2
		sub.l	d2,d3
		move.l	d3,d0
*
*		sub.w	#8,d1
*		lsr.l	d1,d0
*		move.l	#8,d1
*		bsr	save_bit

*		sub.w	#8,d1
*		lsr.l	d1-8+8,d0
*		ror.w	#8,d0

		ror.w	d1,d0
		moveq.l	#8,d1
		sub.w	d1,d7
		bge	save_len3x
		pea	save_len3xx(pc)
		bra	save_bit_a
save_len3x
		move.w	d0,d6
		lsl.l	d1,d6
save_len3xx

		move.l	d3,d0
		move.l	d4,d1
		sub.w	#8,d1
		beq	save_len_end
		bsr	save_bit
save_len_end
		movem.l	(sp)+,d0-d5
		bra	save_fin

len_data
		.dc.w	0	*damy
		.dc.w	0
		.dc.w	%100
		.dc.w	%101
		.dc.w	%11000
		.dc.w	%11001
		.dc.w	%11010
		.dc.w	%11011
len_len
		.dc.w	1
		.dc.w	1
		.dc.w	3
		.dc.w	3
		.dc.w	5
		.dc.w	5
		.dc.w	5
		.dc.w	5


save_l
		movem.l	d0/d1,-(sp)
		add.l	d0,d0
		move.w	len_len(pc,d0.w),d1		* d0̓[hŎQƂ̂.
		move.w	len_data(pc,d0.w),d0

		ror.w	d1,d0
		sub.w	d1,d7
		bge	save_l0
		bsr	save_bit_a
		movem.l	(sp)+,d0/d1
		bra	save_fin
save_l0
		move.w	d0,d6
		lsl.l	d1,d6
		movem.l	(sp)+,d0/d1
save_fin


	*************************************************************
		subq.l	#1,d0
		add.l	d0,d0
		move.l	d2,d1
		add.l	#1,d1
pressD0
		sub.l	d1,d0
		blt	pressD

		subq.w	#1,y_width(a6)
		beq	press_end
		bsr	ldisp
		move.l	x_width(a6),d2
		move.l	d2,d1
		subq.l	#1,d2
		move.l	dif(a6),d3		* GRAM ̃C
		add.l	d3,now_addr(a6)		*
		move.l	now_addr(a6),a1		*
		bra	pressD0
pressD
		add.l	d1,d0
********		add.l	d0,a1
		add.l	d0,a1
		sub.l	d0,d2

		clr.w	d5
		move.b	(a1)+,d5		* GRAM
**		ext.w	d5

		dbra	d2,pressE
		subq.w	#1,y_width(a6)
		beq	press_end
		bsr	ldisp
		move.l	x_width(a6),d2
		subq.l	#1,d2
		move.l	dif(a6),d0		* GRAM ̃C
		add.l	d0,now_addr(a6)		*
		move.l	now_addr(a6),a1		*
pressE
		clr.w	d3
		move.b	(a1)+,d3		* GRAM
**		ext.w	d3

		dbra	d2,press0
		subq.w	#1,y_width(a6)
		beq	press_end
		bsr	ldisp
		move.l	x_width(a6),d2
		subq.l	#1,d2
		move.l	dif(a6),d0		* GRAM ̃C
		add.l	d0,now_addr(a6)		*
		move.l	now_addr(a6),a1		*
		bra	press0
press_end
		bsr	ldisp2
		moveq.l	#0,d0
		moveq.l	#8,d1
		bsr	save_bit
		moveq.l	#0,d0
		moveq.l	#8,d1
		bsr	save_bit
		moveq.l	#0,d0
		moveq.l	#8,d1
		bsr	save_bit
		moveq.l	#0,d0
		moveq.l	#8,d1
		bsr	save_bit
		rts


*----------------------------------------------------------------------------*
* ő_vZ
*
*	a1	now_address
*	a0	now_address

calc
		movem.l	d3-d7,-(sp)

		moveq.l	#0,d0
		cmp.w	#1,d4
		beq	calc1

	******	bsr	calc_posL *****************************************
calc_posL
		move.w	d3,d4

		move.l	now_addr(a6),a0
		move.l	d2,d0
		move.l	d2,d3

		cmp.w	d5,d4
		beq	calc_posL4

		lea	-3(a1),a3			* GRAM
		cmp.l	a0,a3
		bge.b	calc_posL2		* a3a0Ccalc_posL2 
		sub.l	dif(a6),a3			* GRAM P̃C
		add.w	x_width2(a6),a3			* ̃C̏I
							* [͑OC̉EƌqĂ
		cmp.l	a2,a3			* a3a2(GRAM擪)Ccalc_posL2
		bge	calc_posL2
		add.l	dif3(a6),a3		* GRAM zΏۉʂ
		sub.l	a0,a3
		add.l	gbuff(a6),a3
calc_posL2
		clr.w	d6
		move.b	(a3),d6				* GRAM

		lea	-4(a1),a3			* GRAM
		cmp.l	a0,a3
		bge.b	calc_posL3

		sub.l	dif(a6),a3			* 
		add.w	x_width2(a6),a3			* GRAM ̒~Q{a3

		move.l	a0,d7			* fix '92-11-24
		sub.l	dif(a6),d7
		cmp.l	d7,a3
		bge.b	calc_posL3x

		sub.l	dif(a6),a3
		add.w	x_width2(a6),a3			* GRAM
		cmp.l	a2,a3
		bge	calc_posL3
		add.l	dif2(a6),a3
		sub.l	d7,a3
		add.l	gbuff(a6),a3
		bra	calc_posL3
calc_posL3x
						*
		cmp.l	a2,a3
		bge	calc_posL3
		add.l	dif3(a6),a3
		sub.l	a0,a3
		add.l	gbuff(a6),a3
calc_posL3
		clr.w	d7
		move.b	(a3),d7				* GRAM
		move.l	a1,a3
calc_posLL5
		cmp.b	(a3)+,d7			* GRAM
		dbne	d3,calc_posLL6
		bne	calc_posLend0
		ext.l	d3
		sub.l	d3,d0
		move.l	x_width_1(a6),d3
		add.l	d3,d0
		add.l	dif(a6),a0
		move.l	a0,a3
		cmpa.l	end_addr(a6),a0
		bge	calc_posLend0
calc_posLL6
		cmp.b	(a3)+,d6			* GRAM
		dbne	d3,calc_posLL7
		bne	calc_posLend0
		ext.l	d3
		sub.l	d3,d0
		move.l	x_width_1(a6),d3
		add.l	d3,d0
		add.l	dif(a6),a0
		move.l	a0,a3
		cmpa.l	end_addr(a6),a0
		bge	calc_posLend0
calc_posLL7
		cmp.b	(a3)+,d5			* GRAM
		dbne	d3,calc_posLL8
		bne	calc_posLend0
		ext.l	d3
		sub.l	d3,d0
		move.l	x_width_1(a6),d3
		add.l	d3,d0
		add.l	dif(a6),a0
		move.l	a0,a3
		cmpa.l	end_addr(a6),a0
		bge	calc_posLend0
calc_posLL8						* GRAM
		cmp.b	(a3)+,d4
		dbne	d3,calc_posLL5
		bne	calc_posLend0
		ext.l	d3
		sub.l	d3,d0
		move.l	x_width_1(a6),d3
		add.l	d3,d0
		add.l	dif(a6),a0
		move.l	a0,a3
		cmpa.l	end_addr(a6),a0
		bge	calc_posLend0
		bra	calc_posLL5
**
calc_posL4
		move.l	a1,a3
calc_posL5
		cmp.b	(a3)+,d5			* GRAM
		dbne	d3,calc_posL6
		bne	calc_posLend0
		ext.l	d3
		sub.l	d3,d0
		move.l	x_width_1(a6),d3
		add.l	d3,d0
		add.l	dif(a6),a0
		move.l	a0,a3
		cmpa.l	end_addr(a6),a0
		bge	calc_posLend0
calc_posL6
		cmp.b	(a3)+,d4			* GRAM
		dbne	d3,calc_posL5
		bne	calc_posLend0
		ext.l	d3
		sub.l	d3,d0
		move.l	x_width_1(a6),d3
		add.l	d3,d0
		add.l	dif(a6),a0
		move.l	a0,a3
		cmpa.l	end_addr(a6),a0
		bge	calc_posLend0
		bra	calc_posL5
calc_posLend0
		ext.l	d3
		sub.l	d3,d0
calc_posLend
		lsr.l	d0
	*****************************************
		moveq.l	#1,d1
calc1
	*******************************************************************
	*	bsr	calc_posU
calc_posU
		move.l	now_addr(a6),a0
		move.l	d2,d3
		move.l	d2,d4
		move.l	a1,a3
		move.l	a1,a4
		sub.l	dif(a6),a4
		cmp.l	a2,a4
		bge	calc_posU0
		add.l	dif3(a6),a4
		add.l	gbuff(a6),a4
		sub.l	a0,a4
calc_posU0
		cmp.b	(a4)+,(a3)+		* GRAM
		dbne	d4,calc_posU0
		bne	calc_posUend0
		ext.l	d4
		sub.l	d4,d3
		move.l	x_width_1(a6),d4
		add.l	d4,d3
		move.l	a0,a4
		add.l	dif(a6),a0
		move.l	a0,a3
		cmpa.l	end_addr(a6),a0
		blt	calc_posU0
*		bra	calc_posUend
calc_posUend0
		ext.l	d4
		sub.l	d4,d3
calc_posUend
		lsr.l	d3
	*	rts
	*******************************************************************
		cmp.l	d3,d0
		bge	calc2
		move.l	d3,d0
		moveq.l	#2,d1
calc2
	*******************************************************************
	*	bsr	calc_posUU
calc_posUU
		move.l	now_addr(a6),a0
		move.l	d2,d3
		move.l	d2,d4
		move.l	a1,a3
		move.l	a1,a4
		sub.l	dif2(a6),a4
		cmp.l	a2,a4
		bge	calc_posUU0

		add.l	dif(a6),a4
		cmp.l	a2,a4
		bge	calc_posUU00

		add.l	dif(a6),a4
		add.l	gbuff(a6),a4
		sub.l	a0,a4
		bra	calc_posUU0
calc_posUU00
		add.l	dif2(a6),a4
		add.l	gbuff(a6),a4
		sub.l	a0,a4
calc_posUU0
		cmp.b	(a4)+,(a3)+		* GRAM
		dbne	d4,calc_posUU0
		bne	calc_posUUend0
		ext.l	d4
		sub.l	d4,d3
		move.l	x_width_1(a6),d4
		add.l	d4,d3
		add.l	dif(a6),a0
		move.l	a0,a3
		cmpa.l	end_addr(a6),a0
		bge	calc_posUUend0
		move.l	a0,a4
		sub.l	dif2(a6),a4
		cmp.l	a2,a4
		bge	calc_posUU0

		add.l	dif(a6),a4
		cmp.l	a2,a4
		bge	calc_posUU000

		add.l	dif(a6),a4
		add.l	gbuff(a6),a4
		sub.l	a0,a4
		bra	calc_posUU0
calc_posUU000
		add.l	dif2(a6),a4
		add.l	gbuff(a6),a4
		sub.l	a0,a4
		bra	calc_posUU0
calc_posUUend0
		ext.l	d4
		sub.l	d4,d3
calc_posUUend
		lsr.l	d3
	*	rts
	*******************************************************************
		cmp.l	d3,d0
		bge	calc3
		move.l	d3,d0
		moveq.l	#3,d1
calc3
	*******************************************************************
	*	bsr	calc_posUR
		.xdef	calc_pos_UR
calc_pos_UR
		move.l	now_addr(a6),a0
		move.l	d2,d4
		moveq.l	#0,d3
		move.l	a1,a3
		move.l	a1,a4

		sub.l	dif_r(a6),a4
		cmp.l	a2,a4
		bge	calc_posUR1
		add.l	dif3(a6),a4
		add.l	gbuff(a6),a4
		sub.l	a0,a4
		bra	calc_posUR1
calc_posUR2
		addq.l	#1,d3
		move.l	x_width(a6),d4
		subq.w	#2,d4
		add.l	dif(a6),a0
		cmpa.l	end_addr(a6),a0
		bge	calc_posURend
		move.l	a0,a3
calc_posUR0
		cmp.b	(a4)+,(a3)+		* GRAM
		bne	calc_posURend
		addq.l	#1,d3
calc_posUR1
		dbra	d4,calc_posUR0
		move.l	a0,a4
		cmp.b	(a4)+,(a3)+		* GRAM
		beq	calc_posUR2
calc_posURend
		lsr.l	d3
	*	rts
	***********************************************************************
		cmp.l	d3,d0
		bge	calc4
		move.l	d3,d0
		moveq.l	#4,d1
calc4
	***********************************************************************
	*	bsr	calc_posUL
calc_posUL
		move.l	now_addr(a6),a0
		move.l	d2,d4
		moveq.l	#0,d3
		move.l	a1,a3

		cmp.l	a0,a3
		bne	calc_posUL1

		lea	-1(a1),a4		* GRAM Phbg炵
		sub.l	dif2(a6),a4
		add.w	x_width2(a6),a4
		cmp.l	a2,a4
		bge	calc_posUL2
		add.l	dif2(a6),a4
		add.l	gbuff(a6),a4
		sub.l	a0,a4
		bra	calc_posUL2
calc_posUL1
		move.l	a3,a4
		sub.l	dif_l(a6),a4
		cmp.l	a2,a4
		bge	calc_posUL0
		add.l	dif3(a6),a4
		add.l	gbuff(a6),a4
		sub.l	a0,a4
calc_posUL0
		cmp.b	(a4)+,(a3)+			* GRAM
		bne	calc_posULend
		addq.l	#1,d3
		dbra	d4,calc_posUL0
		move.l	x_width_1(a6),d4
		add.l	dif(a6),a0
		move.l	a0,a3
		cmpa.l	end_addr(a6),a0
		bge	calc_posULend
calc_posUL2
		cmp.b	(a4)+,(a3)+			* GRAM
		bne	calc_posULend
		subq.l	#1,d4
		addq.l	#1,d3
		bra	calc_posUL1
calc_posULend
		lsr.l	d3
	*	rts
	***********************************************************************
		cmp.l	d3,d0
		bge	calc5
		move.l	d3,d0
		moveq.l	#5,d1
calc5
		movem.l	(sp)+,d3-d7
		rts


*----------------------------------------------------------------------------*
* FL^
*
*	d0 : before
*	d1 : color
*
write_color
		movem.l	d0-d3/a0,-(sp)
		cmp.w	#8,plane(a6)
		beq	write_color_256

		and.w	#15,d0
		and.w	#15,d1
		clr.w	d2
		lsl.w	#5,d0		* x32
		lea	color_tab(a6,d0.w),a0
		move.w	(a0)+,d3
		move.w	d1,-2(a0)
		bra	write_col_lop
write_col0
		addq.w	#2,d2
		move.w	(a0),d0
		move.w	d3,(a0)+
		move.w	d0,d3
write_col_lop
		cmp.w	d1,d3
		bne	write_col0

		move.w	col_data(pc,d2.w),d0		* [h
		move.w	col_len(pc,d2.w),d1		*

		ror.w	d1,d0
		sub.w	d1,d7
		bge	write_col1
		bsr	save_bit_a
		movem.l	(sp)+,d0-d3/a0
		rts
write_col1
		move.w	d0,d6
		lsl.l	d1,d6
		movem.l	(sp)+,d0-d3/a0
		rts

col_data
		.dc.w	%10
		.dc.w	%11
		.dc.w	%000
		.dc.w	%001

		.dc.w	%01000
		.dc.w	%01001
		.dc.w	%01010
		.dc.w	%01011

		.dc.w	%011000
		.dc.w	%011001
		.dc.w	%011010
		.dc.w	%011011

		.dc.w	%011100
		.dc.w	%011101
		.dc.w	%011110
		.dc.w	%011111
col_len
		.dc.w	2
		.dc.w	2
		.dc.w	3
		.dc.w	3

		.dc.w	5
		.dc.w	5
		.dc.w	5
		.dc.w	5

		.dc.w	6
		.dc.w	6
		.dc.w	6
		.dc.w	6

		.dc.w	6
		.dc.w	6
		.dc.w	6
		.dc.w	6

*---------------------------------*
* 256Fp

* ܂GKgł͂Ȃ :-)

write_color_256:
		and.l	#$ff,d0
		and.w	#$ff,d1
		moveq.l	#9,d2
		lsl.l	d2,d0		* x512
		clr.w	d2
		lea	color_tab(a6,d0.l),a0
		move.w	(a0)+,d3
		move.w	d1,-2(a0)
		bra	write_col_lop_256
write_col0_256
		addq.w	#1,d2
		move.w	(a0),d0
		move.w	d3,(a0)+
		move.w	d0,d3
write_col_lop_256
		cmp.w	d1,d3
		bne	write_col0_256

		bsr	col_data_set
**		move.w	col_data(pc,d2.w),d0		* f[^
**		move.w	col_len(pc,d2.w),d1		* rbg

		ror.w	d1,d0
		sub.w	d1,d7
		bge	write_col1_256
		bsr	save_bit_a
		movem.l	(sp)+,d0-d3/a0
		rts
write_col1_256
		move.w	d0,d6
		lsl.l	d1,d6
		movem.l	(sp)+,d0-d3/a0
		rts

col_data_set:
		cmp.w	#1,d2		* 0`1
		bhi	@f
		moveq.l	#2,d1
		moveq.l	#%10,d0
		or.w	d2,d0
		rts
@@:		cmp.w	#3,d2		* 2`3
		bhi	@f
		moveq.l	#3,d1
		and.w	#%1,d2
		move.w	d2,d0
		rts
@@:		cmp.w	#7,d2		* 4`7
		bhi	@f
		moveq.l	#5,d1
		moveq.l	#%01000,d0
		and.w	#%11,d2
		or.w	d2,d0
		rts
@@:		cmp.w	#15,d2		* 8`15
		bhi	@f
		moveq.l	#7,d1
		moveq.l	#%0110000,d0
		and.w	#%111,d2
		or.w	d2,d0
		rts
@@:		cmp.w	#31,d2		* 16`31
		bhi	@f
		moveq.l	#9,d1
		move.w	#%011100000,d0
		and.w	#%1111,d2
		or.w	d2,d0
		rts
@@:		cmp.w	#63,d2		* 32`63
		bhi	@f
		moveq.l	#11,d1
		move.w	#%01111000000,d0
		and.w	#%11111,d2
		or.w	d2,d0
		rts
@@:		cmp.w	#127,d2		* 64`127
		bhi	@f
		moveq.l	#13,d1
		move.w	#%0111110000000,d0
		and.w	#%111111,d2
		or.w	d2,d0
		rts
@@:		moveq.l	#14,d1
		move.w	#%01111110000000,d0
		and.w	#%1111111,d2
		or.w	d2,d0
		rts

*----------------------------------------------------------------------------*
* J[e[ȕ

save_color_initialize
		lea	color_tab(a6),a0
		moveq.l	#0,d1

		cmp.w	#8,_color(a5)
		beq	save_color_init256
col_ini0
		move.w	d1,d0
		moveq.l	#16-1,d2
col_ini1
		and.w	#15,d0
		move.w	d0,(a0)+
		subq.w	#1,d0
		dbra	d2,col_ini1
		addq.w	#1,d1
		cmp.w	#16,d1
		blt	col_ini0
		rts

*---------------------------------*
* 256Fp

save_color_init256:
@@:		move.w	d1,d0
		move.w	#256-1,d2
1:		and.w	#255,d0
		move.w	d0,(a0)+
		subq.w	#1,d0
		dbra	d2,1b
		addq.w	#1,d1
		cmp.w	#256,d1
		blt	@b
		rts

*----------------------------------------------------------------------------*
* rbgZ[u
*
*	d0 : data
*	d1 : bit (1~16)
*
save_bit
	*	movem.l	d0/d1,-(sp)

		ror.w	d1,d0
		sub.w	d1,d7
		blt.b	save_bit_a
		move.w	d0,d6
		lsl.l	d1,d6
	*	movem.l	(sp)+,d0/d1
		rts
save_bit_a
		add.w	d1,d7
		addq.w	#1,d7

		move.w	d0,d6
		lsl.l	d7,d6
		swap	d6
		move.w	d6,(a5)+
		subq.l	#2,buff_lest(a6)
		bgt	save_bit_b

		move.l	d6,-(sp)
		move.l	buff_size(a6),buff_lest(a6)
		move.l	buff_addr(a6),a5
		move.l	buff_size(a6),-(sp)
		move.l	buff_addr(a6),-(sp)
		move.w	file(a6),-(sp)
		DOS	_WRITE
		lea	6(sp),sp
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error
		moveq.l	#7,d6
		cmp.l	(sp)+,d0
		bne	save_error
		move.l	(sp)+,d6
save_bit_b
		sub.w	d7,d1
		moveq.l	#15,d7
		sub.w	d1,d7
		rol.l	d1,d6
		swap	d6
		rts

*----------------------------------------------------------------------------*
* ݃obt@̃tbV

flush
		movem.l	d0-d1/d6/a0,-(sp)
		cmp.w	#15,d7
		beq	flush0

		addq.w	#1,d7
		lsl.w	d7,d6
		move.w	d6,(a5)

		subq.l	#2,buff_lest(a6)
		bne	flush0

		move.l	buff_size(a6),buff_lest(a6)
		move.l	buff_addr(a6),a5
		move.l	buff_size(a6),-(sp)
		move.l	buff_addr(a6),-(sp)
		move.w	file(a6),-(sp)
		DOS	_WRITE
		lea	6(sp),sp
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error
		moveq.l	#7,d6
		cmp.l	(sp)+,d0
		bne	save_error
flush0
		move.l	buff_size(a6),d0
		sub.l	buff_lest(a6),d0
		move.l	d0,-(sp)
		move.l	buff_addr(a6),-(sp)
		move.w	file(a6),-(sp)
		DOS	_WRITE
		lea	6(sp),sp
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error
		moveq.l	#7,d6
		cmp.l	(sp)+,d0
		bne	save_error
		movem.l	(sp)+,d0-d1/d6/a0
		rts

*----------------------------------------------------------------------------*
* w̃TCYQȉ̎p

press_one
		moveq.l	#0,d1
		move.l	addr(a6),a2
press_one_lop
		move.l	a2,a3
		move.l	x_width(a6),d2
		subq.l	#1,d2
press_one_l
		move.w	d1,d0
		move.b	(a3)+,d1
		bsr	write_color
		dbra	d2,press_one_l
		add.l	dif(a6),a2
		cmp.l	end_addr(a6),a2
		blt	press_one_lop
		moveq.l	#0,d0
		moveq.l	#8,d1
		bsr	save_bit
		moveq.l	#0,d0
		moveq.l	#8,d1
		bsr	save_bit
		moveq.l	#0,d0
		moveq.l	#8,d1
		bsr	save_bit
		moveq.l	#0,d0
		moveq.l	#8,d1
		bsr	save_bit
		rts


*----------------------------------------------------------------------------*
* Z[uoߕ
*----------------------------------------------------------------------------*

ldisp:
		movem.l	d0-d1,-(sp)
		move.w	y_buff(a6),d0
		move.w	y_width(a6),d1
		bsr	line_disp
		movem.l	(sp)+,d0-d1
		rts

ldisp2:
		movem.l	d0-d1,-(sp)
		bsr	line_disp_x
		movem.l	(sp)+,d0-d1
		rts


*----------------------------------------------------------------------------*
* G[
*----------------------------------------------------------------------------*

save_error			* fBXNς
file_error			* t@CG[
Eo
		move.l	d6,d0
		clr.w	file(a6)
		move.l	stk(a6),sp
		rts


*----------------------------------------------------------------------------*
* ItZbg
*----------------------------------------------------------------------------*

	.offset 0
addr:		.ds.l	1
y_width:	.ds.w	1
end_addr:	.ds.l	1
x_width:	.ds.l	1
x_width_1:	.ds.l	1	* x_width - 1
x_width2:	.ds.w	1	* x_width * 2
scolum:		.ds.w	1
sline:		.ds.w	1
y_buff:		.ds.w	1
plane:		.ds.w	1	* = _color(a5)
dif:		.ds.l	1
dif_r:		.ds.l	1
dif_l:		.ds.l	1
dif2:		.ds.l	1
dif3:		.ds.l	1
now_addr:	.ds.l	1
stk:		.ds.l	1
file:		.ds.l	1
file_name:	.ds.l	1
buff_size:	.ds.l	1
buff_lest:	.ds.l	1
buff_addr:	.ds.l	1
gbuff:		.ds.l	1
color_tab:	.ds.w	16*16
size_of_data:
	.text


		.end

* End of File --------------------------------- *
