.comment comments *-------------------------------------------------------------*
|										|
|	GH Graphic Saver							|
|										|
|					original program v1.01 by Herzen	|
|										|
comments *----------------------------------------------------------------------*

		.include	doscall.mac
		.include	mph.h
		.include	mph_lib.h

		.xdef	_GHSave__

* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*
* GH摜Z[u
*
* in  Ȃ
*
* out d0.w =        0 : I
*            ȊO : G[R[h
*
* (l) 16/256F́CPsNZPoCgD
*        zGRAMpłCGRAMZ[u͂ȂD
*
*----------------------------------------------------------------------------*

_GHSave__
		movem.l	d3-d7/a3-a6,-(sp)
		bsr	GHSave
		movem.l	(sp)+,d3-d7/a3-a6
		rts

GHSave
		bsr	gh_head_write
		bsr	data_save
		moveq.l	#0,d0
		rts

*----------------------------------------------------------------------------*
*
* GHwb_o
*
* in  Ȃ
*
* out d0.w =        0 : 
*            ȊO : G[R[h
*     d5.w = t@Cnh
*
* (l) ƂɂȂ
*
*----------------------------------------------------------------------------*

gh_head_write:
		lea.l	_commentx(a5),a0
		move.w	#$20,-(sp)
		pea.l	_dstfile(a5)
		DOS	_CREATE
		addq.l	#6,sp
		moveq.l	#2,d6
		move.w	d0,d5
		bmi	file_error_

		move.w	#'GH',(a0)+
		lea.l	_comment(a5),a1
		bsr	strcpy
		move.b	#26,(a0)+
		clr.b	(a0)+

		lea.l	_mph_head(a5),a1
		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+

		move.b	_scolum(a5),(a0)+
		move.b	_scolum+1(a5),(a0)+
		move.b	_sline(a5),(a0)+
		move.b	_sline+1(a5),(a0)+

		move.b	_colum(a5),(a0)+
		move.b	_colum+1(a5),(a0)+
		move.b	_line(a5),(a0)+
		move.b	_line+1(a5),(a0)+

		move.b	_color(a5),(a0)+
		move.b	_color+1(a5),(a0)+

		move.b	#13,(a0)+
		move.b	#10,(a0)+

		move.b	#'X',(a0)+
		move.b	#'S',(a0)+
		move.b	#':',(a0)+
		move.w	_scolum(a5),d0
		bsr	_prtdec
		move.b	#13,(a0)+
		move.b	#10,(a0)+

		move.b	#'Y',(a0)+
		move.b	#'S',(a0)+
		move.b	#':',(a0)+
		move.w	_sline(a5),d0
		bsr	_prtdec
		move.b	#13,(a0)+
		move.b	#10,(a0)+

		move.b	#'X',(a0)+
		move.b	#'E',(a0)+
		move.b	#':',(a0)+
		move.w	_ecolum(a5),d0
		bsr	_prtdec
		move.b	#13,(a0)+
		move.b	#10,(a0)+

		move.b	#'Y',(a0)+
		move.b	#'E',(a0)+
		move.b	#':',(a0)+
		move.w	_eline(a5),d0
		bsr	_prtdec
		move.b	#13,(a0)+
		move.b	#10,(a0)+

		move.b	#'X',(a0)+
		move.b	#'L',(a0)+
		move.b	#':',(a0)+
		move.w	_colum(a5),d0
		bsr	_prtdec
		move.b	#13,(a0)+
		move.b	#10,(a0)+

		move.b	#'Y',(a0)+
		move.b	#'L',(a0)+
		move.b	#':',(a0)+
		move.w	_line(a5),d0
		bsr	_prtdec
		move.b	#13,(a0)+
		move.b	#10,(a0)+

		move.b	#'C',(a0)+
		move.b	#'C',(a0)+
		move.b	#':',(a0)+
		move.w	_color(a5),d0
		bsr	_prtdec
		move.b	#13,(a0)+
		move.b	#10,(a0)+

		move.b	#'p',(a0)+
		move.b	#'a',(a0)+
		move.b	#'l',(a0)+
		move.b	#'e',(a0)+
		move.b	#'t',(a0)+
		move.b	#':',(a0)+

		lea.l	_pal_buf(a5),a1
		move.w	_color(a5),d0
		cmp.w	#8,d0
		bhi	gh_cont01
		moveq.l	#1,d2
		lsl.w	d0,d2
		subq.w	#1,d2
@@:
		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+
		dbra	d2,@b
gh_cont01
		move.b	#13,(a0)+
		move.b	#10,(a0)+

		move.b	#'d',(a0)+
		move.b	#'a',(a0)+
		move.b	#'t',(a0)+
		move.b	#'a',(a0)+
		move.b	#':',(a0)+

		move.l	a0,d1
		lea.l	_commentx(a5),a0
		sub.l	a0,d1
		move.l	d1,-(sp)
		pea.l	_commentx(a5)
		move.w	d5,-(sp)
		DOS	_WRITE		܂ł̃wb_o
		lea	10(sp),sp
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error_
		moveq.l	#7,d6
		cmp.l	d0,d1
		bne	file_error_
		moveq.l	#0,d0
		rts

_prtdec:
		link	a3,#-8
		movem.l	d0-d1/a1-a3,-(sp)

		and.l	#$0000ffff,d0
		lea.l	-8(a3),a1
		move.w	#0,6(a1)
		addq.l	#6,a1
		moveq.l	#5-1,d1
prtdec0:
		divu.w	#10,d0
		swap.w	d0
		addi.w	#'0',d0
		move.b	d0,-(a1)
		clr.w	d0
		swap.w	d0
		dbeq	d1,prtdec0
@@:
		move.b	#' ',-(a1)
		dbra	d1,@b
pdis:
		addq.l	#1,a1
		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+
		movem.l	(sp)+,d0-d1/a1-a3
		unlk	a3
		rts


*----------------------------------------------------------------------------*
*
* 摜f[^oC
*
*----------------------------------------------------------------------------*

data_save:
		moveq.l	#32,d0		* 0%\
		moveq.l	#32,d1
		bsr	line_disp

		move.w	_colum(a5),d2
		mulu.w	_line(a5),d2

		move.w	_color(a5),d0
		cmp.w	#15,d0
		bcs	data_save_main

		move.l	d2,d1
		add.l	d2,d2

		cmp.w	#24,d0
		bne	data_save_main
		add.l	d1,d2
data_save_main:
		move.l	d2,-(sp)
		move.l	_buff_addr(a5),-(sp)
		move.w	d5,-(sp)
		DOS	_WRITE
		lea	10(sp),sp
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error_
		moveq.l	#7,d6
		cmp.l	d0,d2
		bne	file_error_
		move.w	d5,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp

		bsr	line_disp_x	* 100%\
		moveq.l	#0,d0
		rts


*----------------------------------------------------------------------------*
* G[
*----------------------------------------------------------------------------*

file_error_:
		move.l	d6,d0
		rts

	.end
