.comment comments *-------------------------------------------------------------*
|										|
|	GIF(16/256) Graphic Saver for over1024/512				|
|										|
|					original program v1.00 by Herzen	|
|					    Ql program gifed.c by XEVI	|
|										|
comments *----------------------------------------------------------------------*

		.include	doscall.mac
		.include	mph.h
		.include	mph_lib.h
		.include	gif_save.h

		.xdef	_GIFSave__

* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*
* GIF(16/256)摜k
*
* in  Ȃ
*
* out d0.w =        0 : I
*            ȊO : G[R[h
*
* (l) E16/256F́CPsNZPoCgD
*        EzGRAMpłCGRAMk͂ȂD
*        E2`16F  16FC32`256F  256F ƂĈD
*
*----------------------------------------------------------------------------*

_GIFSave__
		movem.l	d3-d7/a3-a6,-(sp)
		movea.l	_gif_savework_addr(a5),a6

		bsr	GIFSave
		movem.l	(sp)+,d3-d7/a3-a6
		rts

GIFSave
		clr.w	wfile(a6)
		bsr	GIFSaveX
		rts

GIFSaveX:
		move.l	sp,stk(a6)		Eo

	clr	(hash_ptr_bak,a6)

	move.w	_color(a5),d0
	move.w	#16,col_tbl_n(a6)
	cmp.w	#8,d0
	bne	@f
	move.w	#256,col_tbl_n(a6)
@@:	move.w	d0,pixel_bit(a6)

	bsr	gif_head_write			* wb_o

	bsr	press

	move.w	wfile(a6),-(sp)
	DOS	_CLOSE
	addq.l	#2,sp
	moveq.l	#0,d0
	rts


*----------------------------------------------------------------------------*
*
* GIFwb_o
*
* in  Ȃ
*
* out d0.w =        0 : 
*            ȊO : G[R[h
*     d5.w = t@Cnh
*
* (l) Epbg܂łoD
*
*----------------------------------------------------------------------------*

gif_head_write:
		move.w	#$20,-(sp)
		pea.l	_dstfile(a5)
		DOS	_CREATE
		addq.l	#6,sp
		moveq.l	#2,d6
		move.w	d0,wfile(a6)
		bmi	file_error

	lea.l	_commentx(a5),a0
	move.l	#'GIF8',(a0)+
	move.w	#'9a',(a0)+
	move.w	_colum(a5),d0
	add.w	_scolum(a5),d0
	ror.w	#8,d0
	move.w	d0,(a0)+
	move.w	_line(a5),d0
	add.w	_sline(a5),d0
	ror.w	#8,d0
	move.w	d0,(a0)+
	move.w	pixel_bit(a6),d0
	subq.w	#1,d0
	or.b	#$f0,d0
	move.b	d0,(a0)+
	clr.b	(a0)+		* bg_col
	clr.b	(a0)+

	bsr	gif_palet_save

		move.b	#'!',(a0)+	* gtB[h
		move.b	#$fe,(a0)+	* @\FRg
		move.b	#gif_comment_end-gif_comment,(a0)+	;RgoCg
		lea	(gif_comment,pc),a1
		move.l	(_mph_head,a5),(gif_comment_saver-gif_comment,a1)
@@:		move.b	(a1)+,(a0)+
		bne	@b

	move.b	#$2c,(a0)+		* C[WL
	move.w	_scolum(a5),d0
	move.b	d0,(a0)+
	ror.w	#8,d0
	move.b	d0,(a0)+
	move.w	_sline(a5),d0
	move.b	d0,(a0)+
	ror.w	#8,d0
	move.b	d0,(a0)+
	move.w	_colum(a5),d0
	move.b	d0,(a0)+
	ror.w	#8,d0
	move.b	d0,(a0)+
	move.w	_line(a5),d0
	move.b	d0,(a0)+
	ror.w	#8,d0
	move.b	d0,(a0)+
	moveq.l	#0,d0
	cmp.b	#1,_gif_ex_save_flag(a5)
	bne	@f
	bset.l	#6,d0
@@:
	move.b	d0,(a0)+	* misc
	move.w	_color(a5),d0
	move.b	d0,(a0)+
	moveq.l	#1,d1
	lsl.w	d0,d1		* 16 / 256 ɂȂ
	move.w	d1,cs_n(a6)
	move.w	d0,cs_bit(a6)

		move.l	a0,d0
		lea.l	_commentx(a5),a0
		sub.l	a0,d0
		move.l	d0,-(sp)
		pea.l	_commentx(a5)
		move.w	wfile(a6),-(sp)
		DOS	_WRITE		܂ł̃wb_o
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error
		lea	10(sp),sp

	moveq.l	#0,d0
	rts


*----------------------------------------------------------------------------*
*
* 16/256摜kC
*
*----------------------------------------------------------------------------*

press:
	move.l	_buff_addr(a5),a4		* a4 = p

		cmp.b	#1,_gif_ex_save_flag(a5)
		bne	@f
		bsr	to_interlace
@@:

	lea.l	lzw_hash_flg(a6),a3		* a3 = lzw_hash_flg
	movea.l	_save_addr(a5),a2
*	lea.l	lzw_hash_lnk(a6),a2		* a2 = lzw_hash_lnk

	moveq.l	#1,d2			* d2 wt_buf_ptr(a6)
	clr	(a2)
	clr	(wt_buf_bit,a6)

	bsr	lzw_tbl_clr
	move.w	cs_n(a6),tbl_n(a6)
	addq.w	#2,tbl_n(a6)
	move.w	cs_bit(a6),cbl(a6)
	addq.b	#1,cbl+1(a6)
	move.w	cs_n(a6),d0
	bsr	wt_n_bit

	move.w	#-1,s_pos(a6)
	clr	(s_hash,a6)

	move.w	_line(a5),d7				* d7 = y
	subq.w	#1,d7
y_lop:
		move.w	_colum(a5),d6			* d6 = x
		subq.w	#1,d6
x_lop:
			moveq.l	#0,d5
			move.b	(a4)+,d5	* d5 = c
			move.w	s_hash(a6),d4
			add.b	#LZW_HASH_N,d4
			add.b	d5,d4
*			and.w	#$ff,d4		* d4 = hash
			move.w	d4,d0
			add.w	d0,d0
			move.w	(a3,d0.w),d3	* d3 = hash_ptr
			bra	while_lop_chk
while_lop:
				move.w	d3,d0
				add.w	d0,d0
				lea.l	lzw_s(a6),a0
				move.w	(a0,d0.w),d0
				cmp.w	s_pos(a6),d0
				bne	@f
				lea.l	lzw_c(a6),a0
				move.b	(a0,d3.w),d0
				cmp.b	d0,d5
				bne	@f
*******					/ exist /
					move.w	d3,s_pos(a6)
					move.w	d4,s_hash(a6)
					bra	while_lop_end
@@:
				move.w	d3,hash_ptr_bak(a6)
				move.w	d3,d0
				add.w	d0,d0
				move.w	lzw_hash_lnk(a6,d0.w),d3
while_lop_chk:
			tst.w	d3
			bge	while_lop
while_lop_end:
			tst.w	d3
			bge	x_lop_end
*******			/* not exist */
			move.w	s_pos(a6),d0
			bsr	wt_n_bit
			cmp.w	#LZW_TBL_SIZE,tbl_n(a6)
			beq	else_tbl
				move.w	tbl_n(a6),d0
				lea.l	lzw_c(a6),a0
				move.b	d5,(a0,d0.w)
				add.w	d0,d0
				lea.l	lzw_s(a6),a0
				move.w	s_pos(a6),(a0,d0.w)

				move.w	d4,d0
				add.w	d0,d0
				tst.w	(a3,d0.w)
				bge	else_lzw
					move.w	tbl_n(a6),(a3,d0.w)
				bra	@f
else_lzw:
					move.w	hash_ptr_bak(a6),d0
					add.w	d0,d0
					move.w	tbl_n(a6),lzw_hash_lnk(a6,d0.w)
@@:
				move.w	tbl_n(a6),d0
				add.w	d0,d0
				move.w	#-1,lzw_hash_lnk(a6,d0.w)

				move.w	cbl(a6),d1
				moveq.l	#1,d0
				lsl.w	d1,d0
				cmp.w	tbl_n(a6),d0
				bne	@f
				addq.b	#1,cbl+1(a6)
@@:				addq.w	#1,tbl_n(a6)
				bra	cont_1
else_tbl:
				move.w	cs_n(a6),d0
				bsr	wt_n_bit
				bsr	lzw_tbl_clr
				move.w	cs_n(a6),tbl_n(a6)
				addq.w	#2,tbl_n(a6)
				move.w	cs_bit(a6),cbl(a6)
				addq.b	#1,cbl+1(a6)
cont_1:
			move.w	d5,s_pos(a6)
			move.w	d5,s_hash(a6)
			add.b	#LZW_HASH_N,s_hash+1(a6)
*			and.w	#$ff,s_hash(a6)
x_lop_end:
		dbra	d6,x_lop
	bsr	ldisp
	dbra	d7,y_lop

	move.w	s_pos(a6),d0
	bsr	wt_n_bit

	move.w	cs_n(a6),d0
	addq.w	#1,d0
	bsr	wt_n_bit

	tst.w	wt_buf_bit(a6)
	beq	@f
	addq.w	#1,d2
@@:

	move.w	d2,d0
	subq.w	#1,d0
	move.b	d0,(a2)
	adda.l	d2,a2

	clr.b	(a2)+
	move.b	#$3b,(a2)+	* IL

		move.l	a2,d0
		movea.l	_save_addr(a5),a0
		sub.l	a0,d0
		move.l	d0,-(sp)
		move.l	a0,-(sp)
		move.w	wfile(a6),-(sp)
		DOS	_WRITE			kf[^o
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error
		lea	10(sp),sp
		moveq.l	#0,d0

	bsr	ldisp2

	moveq.l	#0,d0
	rts


*----------------------------------------------------------------------------*
* C^[X
*----------------------------------------------------------------------------*

to_interlace:
	movea.l	a4,a3
	move.w	_colum(a5),d2
	mulu.w	_line(a5),d2
	add.l	d2,a4
	move.l	a4,-(sp)
	link	a6,#-12
	exg.l	a3,a4
	move.l	a4,interlace_trans_addr(a6)
	bsr	to_interlace_main
	unlk	a6
	move.l	(sp)+,a4
	rts

colum8	=	-4
colum4	=	-8
interlace_trans_addr	=	-12

to_interlace_main:
	moveq.l	#0,d3
	moveq.l	#0,d2
	move.w	_line(a5),d2
	swap.w	d2

	moveq.l	#0,d0
	move.l	d0,d1
	move.w	_colum(a5),d0
	move.w	d0,d1
	lsl.l	#3,d0		* 8{
	sub.l	d1,d0
	move.l	d0,colum8(a6)

	moveq.l	#0,d0
	move.w	d1,d0
	lsl.l	#2,d0		* 4{
	sub.l	d1,d0
	move.l	d0,colum4(a6)

	move.w	_line(a5),d1
	subq.w	#1,d1
@@:
	bsr	timatima
	bsr	address_chg

	dbra	d1,@b

	moveq.l	#0,d0
	rts


address_chg:
	move.w	d2,d0
	add.w	d0,d0
	jmp	pass_tbl_(pc,d0.w)
	rts

pass_tbl_:
	bra.s	pass0_
	bra.s	pass1_
	bra.s	pass2_
	bra.s	pass3_

pass0_:
	swap.w	d2
	addq.w	#8,d3
	cmp.w	d3,d2
	bhi.b	@f
	swap.w	d2
	addq.w	#1,d2
	move.w	#4,d3
		moveq.l	#0,d0
		move.w	_colum(a5),d0
		lsl.l	#2,d0		* S{
*		move.w	d3,d0
*		mulu.w	_colum(a5),d0
		movea.l	interlace_trans_addr(a6),a4
		adda.l	d0,a4

	rts
@@:
	swap.w	d2
	adda.l	colum8(a6),a4
	rts

pass1_:
	swap.w	d2
	addq.w	#8,d3
	cmp.w	d3,d2
	bhi.b	@f
	swap.w	d2
	addq.w	#1,d2
	move.w	#2,d3
		moveq.l	#0,d0
		move.w	_colum(a5),d0
		lsl.l	#1,d0		* Q{
*		move.w	d3,d0
*		mulu.w	_colum(a5),d0
		movea.l	interlace_trans_addr(a6),a4
		adda.l	d0,a4
	rts
@@:
	swap.w	d2
	adda.l	colum8(a6),a4
	rts

pass3_:
	addq.w	#2,d3
	adda.w	_colum(a5),a4
	rts

pass2_:
	swap.w	d2
	addq.w	#4,d3
	cmp.w	d3,d2
	bhi.b	@f
	swap.w	d2
	addq.w	#1,d2
	move.w	#1,d3
		movea.l	interlace_trans_addr(a6),a4
		adda.w	_colum(a5),a4
	rts
@@:
	swap.w	d2
	adda.l	colum4(a6),a4
	rts

timatima:
	move.w	_colum(a5),d0
@@:
	sub.w	#256,d0
	bmi	@f
	bsr	tima
	bra	@b
@@:
	add.w	#256,d0
	move.w	#256,d4
	sub.w	d0,d4
	add.w	d4,d4
	jmp	tima(pc,d4.w)
	nop

tima:
	.rept 256
	move.b	(a4)+,(a3)+
	.endm
	rts


*----------------------------------------------------------------------------*
* LZW e[u

lzw_tbl_clr:
	movem.l	d2-d3/a2-a3,-(sp)
	moveq.l	#-1,d3

	lea.l	lzw_hash_flg(a6),a0
	move.w	#256-1,d0
@@:	move.w	d3,(a0)+
	dbra	d0,@b

	lea.l	lzw_hash_flg(a6),a0
	lea.l	lzw_hash_lnk(a6),a1
	lea.l	lzw_s(a6),a2
	lea.l	lzw_c(a6),a3

	move.w	cs_n(a6),d2
	subq.w	#1,d2
	moveq.l	#0,d1
lzw_tbl_clr_lop:
		move.w	d3,(a2)+
		move.b	d1,(a3)+
		move.w	d1,d0
		add.b	#LZW_HASH_N,d0
*		and.w	#$ff,d0
		add.w	d0,d0
		tst.w	(a0,d0.w)	* }CiXCd1
		bge	@f
		move.w	d1,(a0,d0.w)
@@:		move.w	d3,(a1)+
		addq.w	#1,d1
	dbra	d2,lzw_tbl_clr_lop
	movem.l	(sp)+,d2-d3/a2-a3
	rts


*----------------------------------------------------------------------------*
* pbgZ[u

gif_palet_save:
		lea.l	_pal_buf(a5),a1
		moveq.l	#1,d0
		move.w	_color(a5),d1
		lsl.w	d1,d0
		subq.w	#1,d0
		tst.b	_rgb_flag(a5)
		bne	true_color
pal_save:
		move.w	(a1)+,d1

		move.w	d1,d2
		and.w	#$7c0,d2	* R
					* %      111_1100_0000
		ror.w	#3,d2
		move.b	d2,(a0)+

		move.w	d1,d2
		and.w	#$f800,d2	* G
					* %1111_1000_0000_0000
		rol.w	#8,d2
		move.b	d2,(a0)+

		move.w	d1,d2
		and.w	#$3f,d2		* B
					* %            11_1110
		rol.w	#2,d2		* 
		move.b	d2,(a0)+
		dbra	d0,pal_save
		rts

true_color:
		lea.l	_rgb(a5),a1
@@:			move.b	(a1)+,(a0)+	* R
			move.b	(a1)+,(a0)+	* G
			move.b	(a1)+,(a0)+	* B
		dbra	d0,@b

		rts


*----------------------------------------------------------------------------*
* rbgZ[u

	*  d0.w ... dat
wt_n_bit:
*	movem.l	d3,-(sp)
	lea.l	wt_buf_bit+1(a6),a0
	moveq.l	#0,d3
	move.w	d0,d3
	moveq.l	#0,d0
	move.b	(a0),d0
	lsl.l	d0,d3
	moveq.l	#0,d1
	move.b	(a2,d2.l),d1
	or.l	d1,d3
	add.b	cbl+1(a6),d0
	move.b	d0,(a0)
	moveq.l	#0,d0
	bra	wt_n_chk
wt_n_lop:
	move.b	d3,(a2,d2.l)
	addq.w	#1,d2

	cmp.w	#255,d2
	bne	@f
	move.b	#255-1,(a2)
	lea.l	255(a2),a2
	moveq.l	#1,d2
@@:
	lsr.l	#8,d3
	subq.b	#8,(a0)
wt_n_chk:
	cmpi.b	#7,(a0)
	bhi	wt_n_lop
	move.b	d3,(a2,d2.l)
*	movem.l	(sp)+,d3
	rts


*----------------------------------------------------------------------------*
* Z[uoߕ
*----------------------------------------------------------------------------*

ldisp:
		movem.l	d0-d1,-(sp)
		move.w	_line(a5),d0
		move.w	d7,d1
		bsr	line_disp
		movem.l	(sp)+,d0-d1
		rts

ldisp2:
		movem.l	d0-d1,-(sp)
		bsr	line_disp_x
		movem.l	(sp)+,d0-d1
		rts


*----------------------------------------------------------------------------*
* G[
*----------------------------------------------------------------------------*

save_error			* fBXNς
file_error			* t@CG[
Eo
		moveq.l	#3,d0
*		move.l	d6,d0
		clr.w	wfile(a6)
		move.l	stk(a6),sp
		rts


* Data Section -------------------------------- *

*		.data
		.even

gif_comment:
		.dc.b	'-X680x0 '
gif_comment_saver:
		.dc.l	'MPH3'
		.dc.b	' by Herzen(K.T.)-'
gif_comment_end:
		.dc.b	0
		.even


		.end

* End of File --------------------------------- *
