
	.include	doscall.mac
	.include	iocscall.mac
	.include	mph.h
	.include	mph_lib.h
	.include	config.h

	.xdef	to_gram
	.xdef	to_gram_sabun
	.xdef	tonedown
	.xdef	tonedown50
	.xdef	tonedown_nowait
	.xdef	trans_clr
	.xdef	trans_clrx
	.xdef	text_on
	.xdef	text_off
	.xdef	GCLR
	.xdef	gram_to_buff
	.xdef	gram_to_buff_only
	.xdef	gram_to_buff256
	.xdef	gram_to_buff256_only

	.comment title

	MPH3 zGRAM  GRAM ][`

					written by Herzen

title

SCREEN_MODE:	.equ	3
CRTMODWORK:	.equ	$093C

DOT16:		.macro
		moveq.l	#0,d4
			.rept 16
			move.b	(a2)+,d4
			move.w	d4,(a3)+
			.endm
		.endm


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

to_gram:
		move.w	_gram_disp_mode(a5),d0
		beq	to_gram_end
		cmp.w	#8,_color(a5)
		beq	to_gram256
		tst.w	_count_pic(a5)
		bne	@f
		bsr	SCREEN
@@:
		addq.w	#1,_count_pic(a5)
		subq.w	#1,d0
		add.w	d0,d0
		jmp	to_gram_table(pc,d0.w)
to_gram_end:	rts

to_gram_table:
		bra.b	mode1_	* ̂P
		bra.b	mode2_	* ̂Q
		bra.b	mode3_	* -wfC-ap
		bra.b	mode4_	* -t1piexp modej
		bra.b	mode5_	* E\
mode1_:
		bra	mode1
mode2_:
		bra	mode2
mode3_:
		bra	mode3
mode4_:
		bra	mode4
mode5_:
		bra	mode5

to_gram256:
		cmp.w	#3,d0
		beq	@f
		cmp.w	#1,d0
		bne	to_gram_end
@@:		bsr	SCREEN256
		move.w	#0,_count_pic(a5)
		subq.w	#1,d0
		add.w	d0,d0
		jmp	to_gram_table256(pc,d0.w)

to_gram_table256:
		bra.b	mode1__	* ̂P
		bra.b	mode2__	* ̂Q
		bra.b	mode3__	* -wfC-ap
		bra.b	mode4__	* -t1piexp modej
		bra.b	mode5_	* E\
mode1__:
		bra	mode1_256
mode2__:
		rts
mode3__:
		bra	mode3_256
mode4__:
		rts
mode5__:
		bra	mode5_256


*-------------------------------------------------------------------------------
*
* 256F^CvRiʂɕ\g[_E@F1024x1024j

mode3_256:
		movem.l	d0-d7/a0-a6,-(sp)
		bsr	to_super

		bsr	GCLR
		bsr	scrnset256

		move.w	#$003f,$e82600		* POO
		bsr	palet_set
		moveq.l	#0,d2

*		lea.l	$c00000,a0
		movem.l	d0-d2,-(sp)
		move.w	_sline(a5),d1
		move.w	_scolum(a5),d2
		move.l	#$c00000,d0		* d2=X, d1=Y
		mulu	#1024,d1
		add.l	d2,d1
		add.l	d2,d1
		add.l	d1,d0
		movea.l	d0,a0
		movem.l	(sp)+,d0-d2

		move.w	#512-1,_ymax(a5)
		move.w	#512,_xmax(a5)
		bsr	to_gram_main

		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts

* ^CvPiʏ\g[_E@F768x512j

mode1_256:
		movem.l	d0-d7/a0-a6,-(sp)
		bsr	to_super

		bsr	GCLR
		bsr	scrnset256

		move.w	#$003f,$e82600		* POO
		bsr	palet_set
		tst.w	_gram_disp_wait(a5)
		bne	@f
		bsr	palet_tonedown_set
@@:
		moveq.l	#0,d2
		tst.w	_200flag(a5)
		sne	d2
*		lea.l	$c00000,a0

		movem.l	d0-d2,-(sp)
		move.w	_sline(a5),d1
		move.w	_scolum(a5),d2
		move.l	#$c00000,d0		* d2=X, d1=Y
		mulu	#1024,d1
		add.l	d2,d1
		add.l	d2,d1
		add.l	d1,d0
		movea.l	d0,a0
		movem.l	(sp)+,d0-d2

		move.w	#512-1,_ymax(a5)
		move.w	#512,_xmax(a5)
		bsr	to_gram_main

		tst.w	_gram_disp_wait(a5)
		beq	@f
		bsr	tonedown
@@:
		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts


* ^CvPiʏ\g[_E@F768x512j

mode5_256:
		movem.l	d0-d7/a0-a6,-(sp)
		bsr	to_super

		bsr	GCLR
		bsr	scrnset256

		move.w	#$003f,$e82600		* POO
		bsr	palet_set

		moveq.l	#0,d2
		tst.w	_200flag(a5)
		sne	d2
*		lea.l	$c00000,a0

		movem.l	d0-d2,-(sp)
		move.w	_line(a5),d0
		move.w	#512-16,d1
		sub.w	d0,d1
		bge	@f
		moveq.l	#0,d1
@@:
		move.w	_colum(a5),d0
		move.w	#768-16,d2
		sub.w	d0,d2
		bge	@f
		moveq.l	#0,d2
@@:
		move.l	#$c00000,d0		* d2=X, d1=Y
		mulu	#1024,d1
		add.l	d2,d1
		add.l	d2,d1
		add.l	d1,d0
		movea.l	d0,a0
		movem.l	(sp)+,d0-d2

		move.w	#512-1,_ymax(a5)
		move.w	#512,_xmax(a5)
		bsr	to_gram_main

		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts



*-------------------------------------------------------------------------------
*
* 16F^CvSig[_EȂF1024x1024j

mode4:
		movem.l	d0-d7/a0-a6,-(sp)
		addq.w	#1,_count_pic(a5)
		bsr	to_super
		bsr	scrnset
		bsr	GCLR
		bsr	scrnset2
		move.w	#$003f,$e82600		* POO
		bsr	palet_set
		moveq.l	#0,d2
		tst.w	_200flag(a5)
		sne	d2
*		lea.l	$c00000,a0

		movem.l	d0-d2,-(sp)
		move.w	_sline(a5),d1
		move.w	_scolum(a5),d2
		move.l	#$c00000,d0		* d2=X, d1=Y
		mulu	#2048,d1
		add.l	d2,d1
		add.l	d2,d1
		add.l	d1,d0
		movea.l	d0,a0
		movem.l	(sp)+,d0-d2

		move.w	#1024-1,_ymax(a5)
		move.w	#1024,_xmax(a5)
		bsr	to_gram_main

		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts

* 16F^CvRiʂɕ\g[_E@F1024x1024j

mode3:
		movem.l	d0-d7/a0-a6,-(sp)
		addq.w	#1,_count_pic(a5)
		bsr	to_super
mode3x:
		bsr	scrnset
		bsr	GCLR
		bsr	scrnset2
		move.w	#$003f,$e82600		* POO
		bsr	palet_set
		moveq.l	#0,d2
		tst.w	_200flag(a5)
		sne	d2
*		lea.l	$c00000,a0

		movem.l	d0-d2,-(sp)
		move.w	_sline(a5),d1
		move.w	_scolum(a5),d2
		move.l	#$c00000,d0		* d2=X, d1=Y
		mulu	#2048,d1
		add.l	d2,d1
		add.l	d2,d1
		add.l	d1,d0
		movea.l	d0,a0
		movem.l	(sp)+,d0-d2

		move.w	#1024-1,_ymax(a5)
		move.w	#1024,_xmax(a5)
		bsr	to_gram_main

**		bsr	tonedown
		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts

* ^CvPiʏ\g[_E@F768x512j

mode1:
		movem.l	d0-d7/a0-a6,-(sp)
		addq.w	#1,_count_pic(a5)
		bsr	to_super
		bsr	scrnset
		bsr	GCLR
		bsr	scrnset2
		move.w	#$003f,$e82600		* POO
		bsr	palet_set
		tst.w	_gram_disp_wait(a5)
		bne	@f
		bsr	palet_tonedown_set
@@:
		moveq.l	#0,d2
		tst.w	_200flag(a5)
		sne	d2
*		lea.l	$c00000,a0

		movem.l	d0-d2,-(sp)
		move.w	_sline(a5),d1
		move.w	_scolum(a5),d2
		move.l	#$c00000,d0		* d2=X, d1=Y
		mulu	#2048,d1
		add.l	d2,d1
		add.l	d2,d1
		add.l	d1,d0
		movea.l	d0,a0
		movem.l	(sp)+,d0-d2

		move.w	#512-1,_ymax(a5)
		move.w	#768,_xmax(a5)
		bsr	to_gram_main

		tst.w	_gram_disp_wait(a5)
		beq	@f
		bsr	tonedown
@@:
		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts

* ^CvQi摜uԝz֕\@F768x512j

mode2:
		movem.l	d0-d7/a0-a6,-(sp)
		bsr	to_super
		tst.w	_count_pic(a5)
		bne	@f
		bsr	scrnset
		bsr	GCLR
		bsr	scrnset2
		move.w	#$003f,$e82600		* POO
@@:
		moveq.l	#0,d2
		tst.w	_200flag(a5)
		sne	d2

		lea.l	$c00000,a0		* 
		addq.w	#1,_count_pic(a5)
		btst.b	#0,_count_pic+1(a5)
		beq	
		lea.l	$d00000,a0		* 
:
		bsr	gclr_a
		move.w	#512-1,_ymax(a5)
		move.w	#768,_xmax(a5)
		bsr	to_gram_main

		move.b	#$20,$e82601
*		bsr	palet_set
*		bsr	tonedown_2
		bsr	palet_tonedown_set

		btst.b	#0,_count_pic+1(a5)
		bne	2
2
		moveq.l	#0,d3
		bra	@f
2:
		move.l	#512,d3
@@:

		lea.l	$e80000,a0	* CRTC
		moveq.l	#0,d0
		move.w	d0,$18(a0)
		move.w	d3,$1a(a0)
		move.w	d0,$1c(a0)
		move.w	d3,$1e(a0)
		move.b	#%100,$28(a0)
		move.b	#%100,$2401(a0)
		moveq.l	#0,d0
		move.b	#%0011_1111,d0
		tst.b	_text_mask_flag(a5)
		beq	@f
		bclr.l	#5,d0
@@:		move.b	d0,$2601(a0)

		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts


* ^CvTiE\g[_E@F768x512j

mode5:
		movem.l	d0-d7/a0-a6,-(sp)
		addq.w	#1,_count_pic(a5)
		bsr	to_super

		bsr	scrnset
		bsr	GCLR
		bsr	scrnset2
		move.w	#$003f,$e82600		* POO
		bsr	palet_set
		moveq.l	#0,d2
		tst.w	_200flag(a5)
		sne	d2
*		lea.l	$c00000,a0

		movem.l	d0-d2,-(sp)
		move.w	_line(a5),d0
		move.w	#512-16,d1
		sub.w	d0,d1
		bge	@f
		moveq.l	#0,d1
@@:
		move.w	_colum(a5),d0
		move.w	#768-16,d2
		sub.w	d0,d2
		bge	@f
		moveq.l	#0,d2
@@:
		move.l	#$c00000,d0		* d2=X, d1=Y
		mulu	#2048,d1
		add.l	d2,d1
		add.l	d2,d1
		add.l	d1,d0
		movea.l	d0,a0
		movem.l	(sp)+,d0-d2

*		move.w	#1024-1,_ymax(a5)
*		move.w	#1024,_xmax(a5)
		move.w	#512-1,_ymax(a5)
		move.w	#768,_xmax(a5)
		bsr	to_gram_main

**		bsr	tonedown
		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts



*-------------------------------------------------------------------------------

gclr_a:
	movem.l	d1-d7/a0-a5,-(sp)
	moveq.l	#0,d1
	move.l	d1,d2
	move.l	d1,d3
	move.l	d1,d4
	move.l	d1,d5
	move.l	d1,d6
	move.l	d1,d7
	movea.l	d1,a1
	movea.l	d1,a2
	movea.l	d1,a3
	movea.l	d1,a4
	movea.l	d1,a5
	move.w	#512-1,d0
	adda.l	#$100000,a0
@@:
	lea.l	-(2048-768*2)(a0),a0
	.rept 32
	movem.l	d1-d7/a1-a5,-(a0)
	.endm
	dbra	d0,@b
	movem.l	(sp)+,d1-d7/a0-a5
	rts


to_gram_main:
		movea.l	_buff_addr(a5),a1
		move.w	_line(a5),d0
		subq.w	#1,d0
		cmp.w	_ymax(a5),d0
		bls	XY_lop
		move.w	_ymax(a5),d0
XY_lop:						* I[gXN[Ȃ
		bsr	trans_line
		tst.w	d2
		beq	xy_cont
		swap.w	d2
		tst.w	d2
		bne	@f
		eor.b	#$ff,d2
		swap.w	d2
		bra	XY_lop
@@:		eor.b	#$ff,d2
		swap.w	d2
xy_cont:	add.w	_colum(a5),a1
		dbra	d0,XY_lop
		rts

*-------------------------------------------------------------------------------
*
* pbg֌W
*

* PAL  TPALET
palet_set:
		lea.l	_pal_buf(a5),a0
		lea.l	$e82000,a1
		moveq.l	#1,d0
		move.w	_color(a5),d1
		lsl.l	d1,d0
		subq.w	#1,d0
@@:		move.w	(a0)+,(a1)+
		dbra	d0,@b
		rts

* PAL  tonedown  TPALET
palet_tonedown_set:
		link	a6,#-768
		lea.l	-768(a6),a0
		lea	_pal_buf(a5),a1
		bsr	pal_to_rgb

		move.w	_gram_disp_palet(a5),d5
		lea.l	-768(a6),a0
		bsr	set_pal
		unlk	a6
		rts


* TPALET  tonedown  TPALET
tonedown:
		link	a6,#-768
		lea.l	-768(a6),a0
		lea	$e82000,a1		* pbgL^
		bsr	pal_to_rgb

		moveq.l	#0,d1
		move.w	_gram_disp_wait(a5),d1
		bsr	time_wait

		cmp.w	#100,_gram_disp_palet(a5)
		beq	tonedown_end

		moveq.l	#4,d1
		lea.l	-768(a6),a0
		moveq.l	#95,d5
@@:		bsr	set_pal
		bsr	time_wait
		subq.l	#5,d5
		cmp.w	_gram_disp_palet(a5),d5
		bhi	@b
		unlk	a6
tonedown_end:
		rts

* TPALET  fadeout  TPALET
palet_fadeout:
		link	a6,#-48
		lea.l	-48(a6),a0
		lea	_pal_buf(a5),a1
		bsr	pal_to_rgb

		tst.w	_gram_disp_palet(a5)
		beq	fadeout_end

		lea.l	-48(a6),a0
		moveq.l	#12,d1
		move.w	_gram_disp_palet(a5),d5
@@:
		bsr	set_pal
		bsr	time_wait
		subq.l	#5,d5
		bpl	@b
		unlk	a6
fadeout_end:
		rts

* TPALET  fadein  TPALET
palet_fadein:
		link	a6,#-48
		lea.l	-48(a6),a0
		lea	_pal_buf(a5),a1
		bsr	pal_to_rgb

		lea.l	-48(a6),a0
		moveq.l	#12,d1
		moveq.l	#0,d5
@@:
		bsr	set_pal
		bsr	time_wait
		addq.w	#5,d5
		cmp.w	_gram_disp_palet(a5),d5
		bcs	@b

		unlk	a6
		rts

pal_to_rgb:
		moveq.l	#1,d0
		move.w	_color(a5),d1
		lsl.w	d1,d0
		subq.w	#1,d0
@@:		move.w	(a1)+,d1
		move.w	d1,d2
		and.w	#$7c0,d2
		btst.l	#0,d1
		beq	@f
		or.w	#$20,d2
@@:		lsr.w	#3,d2
		move.b	d2,(a0)+
		move.w	d1,d2
		and.w	#$f800,d2
		btst.l	#0,d1
		beq	@f
		or.w	#$400,d2
@@:		lsr.w	#8,d2
		move.b	d2,(a0)+
		and.w	#$3f,d1
		lsl.w	#2,d1
		move.b	d1,(a0)+
		dbra	d0,@@@b
		rts


* TPALET  tonedown  TPALET
* OĂяop
tonedown_nowait:
		cmp.w	#100,_gram_disp_palet(a5)
		beq	tonedown_nw_end
		bsr	to_super
		link	a6,#-768
		lea.l	-768(a6),a0
		lea	$e82000,a1		*@pbgL^
		moveq.l	#1,d0
		move.w	_color(a5),d1
		lsl.l	d1,d0
		subq.w	#1,d0
@@:		move.w	(a1)+,d1
		move.w	d1,d2
		and.w	#$7c0,d2
		btst.l	#0,d1
		beq	@f
		or.w	#$20,d2
@@:		lsr.w	#3,d2
		move.b	d2,(a0)+
		move.w	d1,d2
		and.w	#$f800,d2
		btst.l	#0,d1
		beq	@f
		or.w	#$400,d2
@@:		lsr.w	#8,d2
		move.b	d2,(a0)+
		and.w	#$3f,d1
		lsl.w	#2,d1
		move.b	d1,(a0)+
		dbra	d0,@@@b

		moveq.l	#0,d1
		lea.l	-768(a6),a0
		moveq.l	#4,d1
		moveq.l	#95,d5
@@:		bsr	set_pal
		bsr	time_wait
		subq.l	#5,d5
		cmp.w	_gram_disp_palet(a5),d5
		bhi	@b
		unlk	a6
		bsr	to_user
tonedown_nw_end:
		rts


* RGB  TPALET
set_pal:
		movem.l	d0-d4/a0-a1,-(sp)
		lea	$e82000,a1
		moveq.l	#1,d4
		move.w	_color(a5),d1
		lsl.l	d1,d4
		subq.w	#1,d4
set_pal_lop
		moveq.l	#0,d1
		move.b	(a0)+,d1
		mulu	d5,d1
		divu	#100,d1
		moveq.l	#0,d0
		move.b	(a0)+,d0
		mulu	d5,d0
		divu	#100,d0
		moveq.l	#0,d2
		move.b	(a0)+,d2
		mulu	d5,d2
		divu	#100,d2
		lsl.w	#8,d0
		and.w	#$f800,d0
		lsl.w	#3,d1
		and.w	#$7c0,d1
		lsr.w	#2,d2
		and.w	#$3f,d2
		or.w	d1,d0
		or.w	d2,d0
		move.w	d0,(a1)+
		dbra	d4,set_pal_lop
		movem.l	(sp)+,d0-d4/a0-a1
		rts

tonedown50:
		movem.l	d0-d1/a0,-(sp)
		moveq.l	#15,d0
		cmp.w	#8,_color(a5)
		bne	@f
		move.w	#255,d0
@@:
		lea.l	$e82000,a0
@@:		move.w	(a0),d1
		lsr.w	#1,d1
		and.w	#%0111101111011110,d1
		move.w	d1,(a0)+
		dbra	d0,@b
		movem.l	(sp)+,d0-d1/a0
		rts

*-------------------------------------------------------------------------------

scrnset:
	lea.l	$e80000,a0	* CRTC
	moveq.l	#0,d0
	move.w	d0,$18(a0)
	move.w	d0,$1a(a0)
	move.w	d0,$1c(a0)
	move.w	d0,$1e(a0)
scrnset2:
	lea.l	$e80000,a0	* CRTC
	move.b	#%100,$28(a0)
	move.b	#%100,$2401(a0)
	moveq.l	#0,d0
	move.b	#%0011_1111,d0
	tst.b	_text_mask_flag(a5)
	beq	@f
	bclr.l	#5,d0
@@:	move.b	d0,$2601(a0)
	rts

scrnset256:
	lea.l	$e80000,a0	* CRTC
	moveq.l	#0,d0
	move.w	d0,$18(a0)
	move.w	d0,$1a(a0)
	move.w	d0,$1c(a0)
	move.w	d0,$1e(a0)
scrnset256_2:
	lea.l	$e80000,a0	* CRTC
	move.b	#%001,$28(a0)
	move.b	#%001,$2401(a0)
	moveq.l	#0,d0
	move.b	#%0011_1111,d0
	tst.b	_text_mask_flag(a5)
	beq	@f
	bclr.l	#5,d0
@@:	move.b	d0,$2601(a0)
	rts

* trans_line routine
*	programmed by AKIRA.Y
*	  modified by Herzen

trans_line:
		move.l	a0,a3			* a0 , a3 = CURRENT GRAM LINE
		lea	1024(a0),a0		* a0 = NEXT GRAM LINE
		cmp.w	#8,_color(a5)
		beq	@f
		lea.l	1024(a0),a0
@@:		move.l	a1,a2
		moveq.l	#0,d5
		move.w	_colum(a5),d3
		cmp.w	_xmax(a5),d3
		bls	@f
		move.w	_xmax(a5),d3
@@:		move.l	a2,d4
		and.w	#1,d4
		bne	trans_line_eq02
		lsr.w	#4,d3
		beq	trans_line_eq0
		subq.l	#1,d3
trans_line_eql
		DOT16
		dbra	d3,trans_line_eql
trans_line_eq0
		moveq.l	#0,d5
		move.w	_colum(a5),d3
		cmp.w	_xmax(a5),d3
		bls	@f
		move.w	_xmax(a5),d3
@@:		and.w	#15,d3
		beq	trans_line_eqe
trans_line_eq02
		subq.l	#1,d3
trans_line_eq0l
		move.b	(a2)+,d5
		move.w	d5,(a3)+
		dbra	d3,trans_line_eq0l
trans_line_eqe
		rts

*-------------------------------------------------------------------------------
trans_clrx:
		tst.b	_no68_flag(a5)		* 68p̈ɃANZXȂH
		bne	trans_clr_end

		move.w	_gram_disp_mode(a5),d0		* GRAM_DISP type2 ͋NA
		cmp.w	#2,d0
		beq	trans_clr
		tst.b	_gclr_off_flag(a5)
		beq	trans_clr
		bra	trans_clr_texton
trans_clr:
		tst.w	_gram_disp_mode(a5)
		beq	trans_clr_end
		tst.w	_count_pic(a5)
		beq	trans_clr_end
		movem.l	d0-d7/a0-a6,-(sp)
		bsr	to_super

		bsr	scrnset
		bsr	GCLR
		bsr	scrnset2

		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
trans_clr_texton:
		bsr	to_super
		move.b	#%0011_1111,$e82601
		bsr	to_user
trans_clr_end:
		rts

*-------------------------------------------------------------------------------
* Hispeed GRAM CLEAR
*	programmed by H.ATA
*

GCLR:
		lea.l	$00e80000,a1
		move.b	#$04,$00e80028
		move.b	$00e8002b,-(sp)
		move.b	#$0f,$00e8002b
		move.b	#$04,$00e82401
		move.w	$0018(a1),-(sp)
		move.w	$001a(a1),-(sp)
		move.w	#$0000,$0018(a1)
		move.w	#$0000,$001a(a1)
		bset.b	#$01,$0481(a1)
@@:		btst.b	#$01,$0481(a1)
		beq	@b
@@:		btst.b	#$01,$0481(a1)
		bne	@b
		move.w	#$0200,$001a(a1)
		bset.b	#$01,$0481(a1)
@@:		btst.b	#$01,$0481(a1)
		beq	@b
@@:		btst.b	#$01,$0481(a1)
		bne	@b
		move.w	#$0000,$001a(a1)
		move.w	(sp)+,$001a(a1)
		move.w	(sp)+,$0018(a1)
		move.b	(sp)+,$00e8002b
		rts

*-------------------------------------------------------------------------------

time_wait:
		movem.l	d1-d3,-(sp)
		move.l	d1,d2
		beq	time_wait_end
		IOCS	_ONTIME
		move.l	d0,d3
ti_lop:
		IOCS	_ONTIME
		cmp.l	d3,d0
		bcc	@f
		sub.l	#8640000,d3
@@:		sub.l	d3,d0
		cmp.l	d2,d0
		bcs	ti_lop
time_wait_end:
		movem.l	(sp)+,d1-d3
		rts

*-------------------------------------------------------------------------------

text_off:
	tst.b	_text_mask_flag(a5)
	beq	@f
	bsr	to_super
	bclr.b	#5,$e82601
	bsr	to_user
@@:	rts

text_on:
	tst.b	_text_mask_flag(a5)
	beq	@f
	bsr	to_super
	bset.b	#5,$e82601
	bsr	to_user
@@:	rts

*-------------------------------------------------------------------------------
* GRAM to zGRAM Rs[

gram_to_buff:
		bsr		to_super

		lea.l		$e82000,a1
		lea.l		_pal_buf(a5),a0
		move.w		#16-1,d0
@@:
		move.w		(a1)+,(a0)+
		dbra		d0,@b

		bra		@f

gram_to_buff_only:
		bsr		to_super

@@:
		lea.l		$c00000,a2
		movea.l		_buff_addr(a5),a1

		moveq.l		#0,d0
		move.w		_scolum(a5),d0
		add.w		d0,d0
		moveq.l		#0,d1
		move.w		_sline(a5),d1
		mulu.w		#2048,d1
		adda.l		d0,a2
		adda.l		d1,a2

		move.w		_colum(a5),d3
		subq.w		#1,d3
		move.w		_line(a5),d2
		subq.w		#1,d2
outlop:
		move.w		d3,d1
		lea.l		(a2),a0
inlop:		move.w		(a0)+,d0
		move.b		d0,(a1)+
		dbra		d1,inlop
		lea.l		2048(a2),a2
		dbra		d2,outlop

		bsr		to_user

		rts

gram_to_buff256:
		bsr		to_super

		lea.l		$e82000,a1
		lea.l		_pal_buf(a5),a0
		move.w		#256-1,d0
@@:
		move.w		(a1)+,(a0)+
		dbra		d0,@b

		bra		@f

gram_to_buff256_only:
		bsr		to_super

@@:
		lea.l		$c00000,a2
		movea.l		_buff_addr(a5),a1

		moveq.l		#0,d0
		move.w		_scolum(a5),d0
		add.w		d0,d0
		moveq.l		#0,d1
		move.w		_sline(a5),d1
		mulu.w		#1024,d1
		adda.l		d0,a2
		adda.l		d1,a2

		move.w		_colum(a5),d3
		subq.w		#1,d3
		move.w		_line(a5),d2
		subq.w		#1,d2
outlop_:
		move.w		d3,d1
		lea.l		(a2),a0
inlop_:		move.w		(a0)+,d0
		move.b		d0,(a1)+
		dbra		d1,inlop_
		lea.l		1024(a2),a2
		dbra		d2,outlop_

		bsr		to_user

		rts


*----------------------------------------------------------------------------*
* (Ɉ)XN[Zbg :-)

SCREEN:
		movem.l	d0/a0-a1,-(sp)
		bsr	to_super
		move.w	#0,$e82200
		lea.l	para16(pc),a0
		lea.l	$e80000,a1
		moveq.l	#8-1,d0
@@:		move.w	(a0)+,(a1)+	* CRTC R0`R7
		dbra	d0,@b

		lea.l	$e80000,a1
		move.w	(a0)+,d0	* CRTC R20
		move.b	d0,$29(a1)

		bsr	to_user
		movem.l	(sp)+,d0/a0-a1
		rts

* p[^QlCMAG.S
* 16FW(31KHz)[h
para16:
	.dc.w	137,014,028,124,567,005,040,552,$416,095,30	* 31k 768x512


SCREEN256:
		movem.l	d0-d3/a0-a1,-(sp)
		bsr	to_super

		move.w	#0,$e82200

		lea.l	para256s(pc),a0
		lea.l	$e80000,a1
		moveq.l	#8-1,d0
@@:		move.w	(a0)+,(a1)+	* CRTC R0`R7
		dbra	d0,@b
*		move.w	(a0)+,d0
*		move.b	d0,$e80029	* CRTC R20

		bsr	to_user

		movem.l	(sp)+,d0-d3/a0-a1
		rts

* p[^QlCBIOS ROM (XVI v1.10 '91.01.11)
* 256FXNGA[h
para256s:
	.dc.w	$0089,$000e,$002c,$006c,$0237,$0005,$0028,$0228,$0315
* 256FW[h
para256:
	.dc.w	$005B,$0009,$0011,$0051,$0237,$0005,$0028,$0228,$0315


*-
* 摜dˍ
*

to_gram_sabun:
		movem.l	d0-d7/a0-a6,-(sp)
		addq.w	#1,_count_pic(a5)
		bsr	to_super
*		bsr	scrnset
*		bsr	GCLR
*		bsr	scrnset2
		move.w	#$003f,$e82600		* POO
*		bsr	palet_set
		moveq.l	#0,d2

		movem.l	d0-d2,-(sp)
		move.w	_sline(a5),d1
		move.w	_scolum(a5),d2
		move.l	#$c00000,d0		* d2=X, d1=Y
		mulu	#2048,d1
		add.l	d2,d1
		add.l	d2,d1
		add.l	d1,d0
		movea.l	d0,a0
		movem.l	(sp)+,d0-d2

*---* ߂̎Ȑ

		move.w	_mixer(a5),d0
		cmp.w	#2,d0
**		cmp.w	#MPH_LOAD_MIX_DEF,d0
		bne	@f
		movea.l	_buff_addr(a5),a1
		lea.l	_mixer+2(a5),a4		* ftHg
		moveq.l	#0,d0
		move.b	(a1),d0
		move.b	#-1,(a4,d0.w)
@@:						* ߂̎Ȑ
		moveq.l	#16-1,d1
		lea.l	_mixer+2(a5),a4		* ftHg
		lea.l	_mixer_(a5),a1
make_lop:
		tst.b	(a4)+
		bne	@f
		move.l	#$36C44E75,(a1)+		* move.w d4,(a3)+ 36C4
							* rts             4E75
		dbra	d1,make_lop
		bra	make_end
@@:		move.l	#$544B4E75,(a1)+		* addq.w #2,a3    544B
							* rts             4E75
		dbra	d1,make_lop
make_end:

*---

		bsr	palet_set_mix

		move.w	#1024-1,_ymax(a5)
		move.w	#1024,_xmax(a5)
		bsr	to_gram_sabun_main

		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts

to_gram_sabun_main:
		lea.l	_mixer_(a5),a4		* (0~15)
		movea.l	_buff_addr(a5),a1
		move.w	_line(a5),d0
		subq.w	#1,d0
		cmp.w	_ymax(a5),d0
		bls	XYs_lop
		move.w	_ymax(a5),d0
XYs_lop:	bsr	trans_line_sabun
		add.w	_colum(a5),a1
		dbra	d0,XYs_lop
		rts


trans_line_sabun:
		move.l	a0,a3			* a0 , a3 = CURRENT GRAM LINE
		lea	1024(a0),a0		* a0 = NEXT GRAM LINE
		cmp.w	#8,_color(a5)
		beq	@f
		lea.l	1024(a0),a0
@@:		move.l	a1,a2			* a1, a2 zGRAM
		moveq.l	#0,d5
		move.w	_colum(a5),d3
		cmp.w	_xmax(a5),d3
		bls	@f
		move.w	_xmax(a5),d3
@@:

		moveq.l	#0,d7
		move.l	d7,d4
		move.l	d7,d5
		lsr.w	#3,d3
		subq.w	#1,d3

tls_lop
			.rept 8
				move.b	(a2)+,d4
				move.w	d4,d5
				add.w	d5,d5		* d5 * 4
				add.w	d5,d5
				jsr	(a4,d5.w)
*				move.w	d5,(a3)+
			.endm
		dbra	d3,tls_lop
		rts

* d5,d6,d7,a4

palet_set_mix:
		movem.l	d0-d7/a0-a6,-(sp)
		moveq.l	#16-1,d1
		lea.l	_pal_buf(a5),a0
		lea.l	$e82000,a1
		lea.l	_mixer+2(a5),a4		* ftHg
palet_mix_lop:
		move.w	(a0)+,d0
		tst.b	(a4)+
		bne	@f
		move.w	d0,(a1)+
		bra	1f
@@:
		addq.w	#2,a1
*		or.w	d0,(a1)+
1:
		dbra	d1,palet_mix_lop
palet_mix_end:
		movem.l	(sp)+,d0-d7/a0-a6
		rts


	.end
