		.title	mph3 - mph_switch.s

	.include	doscall.mac

	.include	config.h
	.include	mph.h
	.include	mph_lib.h

	.xref	ERROR_EXIT
	.xref	usage
	.xref	title
	.xref	chk_gram
	.xref	comment_file_get

	.xref	palet_set


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

* HUPAIRΉ̈fR[h[` ------------ *


ArgPtr::	.dc.l	0
ArgData::	.dc.l	0
ArgFlag::	.dc.b	$ff
		.even

GetArgCharInit::
		movem.l	a0-a1,-(sp)
		movea.l	(12,sp),a1
GetArgCharInit_skip:
		cmpi.b	#' ',(a1)+
		beq	GetArgCharInit_skip
		subq.l	#1,a1
		lea	(ArgPtr,pc),a0
		move.l	a1,(a0)+		;ArgPtr
		clr.l	(a0)+			;ArgData
		st	(a0)+			;ArgFlag
		movem.l	(sp)+,a0-a1
		rts

GetArgChar::
		movem.l	d1/a0-a1,-(sp)
		lea	(ArgData,pc),a0
		move.l	(a0)+,d0
		tas	(a0)			;ArgFlag
		beq	GetArgChar_abort

		subq.l	#ArgFlag-ArgPtr,a0
		moveq	#0,d0
		move.b	(a0),d0
***		clr.b	(a0)
		movea.l	(a0),a1
GetArgChar_quate:
		move.b	d0,d1
GetArgChar_next:
		move.b	(a1)+,d0
		beq	GetArgChar_abort
		tst.b	d1
		bne	GetArgChar_inquate
		cmpi.b	#' ',d0
		beq	GetArgChar_separate
		cmpi.b	#"'",d0
		beq	GetArgChar_quate
		cmpi.b	#'"',d0
		beq	GetArgChar_quate
GetArgChar_end:
		move.l	a1,(a0)
		move.b	d1,(a0)
GetArgChar_abort:
		movem.l	(sp)+,d1/a0-a1
		rts
GetArgChar_inquate:
		cmp.b	d0,d1
		bne	GetArgChar_end
		clr.b	d1
		bra	GetArgChar_next
GetArgChar_separate:
		cmp.b	(a1)+,d0
		beq	GetArgChar_separate
		subq.l	#1,a1
		moveq	#1,d0
		ror.l	#1,d0
		bra	GetArgChar_end

UngetArgChar::
		move.l	a0,-(sp)
		lea	(ArgFlag,pc),a0
		clr.b	(a0)			;ArgFlag
		move.l	d0,-(a0)		;ArgData
		movea.l	(sp)+,a0
switch_end:
		rts


* IvV ------------------------------ *
* in	a2.l	̃AhX

switch_init:
		move.l	a2,-(sp)
		bsr	GetArgCharInit
		addq.l	#4,sp
		moveq	#5,d6
		rts

switch_arg::
		bsr	switch_init
		bsr	GetArgChar
		tst.l	d0
		bne	@f
Hsw:
		bra	usage
switch_env::
		bsr	switch_init
switch:
		bsr	GetArgChar
		tst.l	d0
		beq.s	switch_end
@@:
		cmpi.b	#'-',d0
		bne	UngetArgChar		;t@CȂI

		bsr	GetArgChar
		tst.l	d0
		beq	ERROR_EXIT
swich1:
		cmpi.b	#'?',d0
		beq	Hsw

		ori.b	#$20,d0
		subi.b	#'a',d0
		cmpi.b	#'z'-'a',d0
		bhi	ERROR_EXIT

		add	d0,d0
		move	(switch_table,pc,d0.w),d0
		jmp	(switch_table,pc,d0.w)
switch_table:
@@:
		.dc	Asw-@b
		.dc	Bsw-@b
		.dc	Csw-@b			;Comment < Group >
		.dc	Dsw-@b
		.dc	usage-@b
		.dc	Fsw-@b			;GIF < Group >
		.dc	Gsw-@b			;G-VIEW < Group >
		.dc	usage-@b
		.dc	Isw-@b
		.dc	usage-@b
		.dc	usage-@b
		.dc	Lsw-@b
		.dc	Msw-@b			;MKI, MAG < Group >
		.dc	Nsw-@b
		.dc	usage-@b
		.dc	Psw-@b			;Pi < Group >
		.dc	Qsw-@b			;Q4 < Group >
		.dc	Rsw-@b			;RGB < Group >
		.dc	Ssw-@b
		.dc	Tsw-@b			;TYPE < Group >
		.dc	usage-@b
		.dc	Vsw-@b			;verbose < Group >
		.dc	Wsw-@b			;Work < Group >
		.dc	usage-@b
		.dc	usage-@b
		.dc	Zsw-@b


switch_skipsp:
		bsr	GetArgChar
		tst.l	d0
		bmi	switch_skipsp
		rts

ARG_STR_MAX:	.equ	98

switch_getarg:
		move.l	d1,-(sp)
		moveq	#ARG_STR_MAX-1,d1	;-b /tmp
		bsr	switch_skipsp		;  ^΂
		bra	@f
switch_getarg_loop:
		bsr	GetArgChar
@@:		move.b	d0,(a0)+
		dbeq	d1,switch_getarg_loop
		clr.b	-(a0)
		move.l	(sp)+,d1
		rts

switch_isnum:
		bsr	GetArgChar
		bsr	UngetArgChar
		subi.b	#'0',d0
		cmpi.b	#9,d0
		bhi	@f
		moveq	#1,d0
		rts
@@:		moveq	#0,d0
		rts


*   lϊ ---------------------- *
* out	d0.l	l
* lƔFłȂȂUngetArgCharďI.

*  (l) 10iC16iC02iɂw肪\D
*         Cӂ̈ʒuɃA_[o[̑}\D
*
*  (\L@)
*         10iF256C2_56
*         16iF0xf5_abC$f5ab
*          2iF0b10101C%1010_0001

switch_num_read:
		movem.l	d1-d2,-(sp)
		moveq	#0,d2
		bsr	GetArgChar
		move.l	d0,d1
		cmpi.b	#'$',d1
		beq	switch_num_read_16
		cmpi.b	#'%',d1
		beq	switch_num_read_2
		subi.b	#'0',d1
		beq	switch_num_read_0
		cmpi.b	#9,d1
		bls	switch_num_read_10_loop
switch_num_read_end:
		bsr	UngetArgChar
		move.l	d2,d0
		movem.l	(sp)+,d1-d2
		rts

switch_num_read_0:
		bsr	GetArgChar
		move.l	d0,d1
		cmpi.b	#'x',d1
		beq	switch_num_read_16		;0x
		cmpi.b	#'b',d1
		beq	switch_num_read_2		;0b
		bra	switch_num_read_10_

switch_num_read_10_loop:
		mulu	#10,d2
		add.l	d1,d2
@@:
		bsr	GetArgChar
		move.l	d0,d1
switch_num_read_10_:
		cmpi.b	#'_',d1
		beq	@b
		subi.b	#'0',d1
		cmpi.b	#9,d1
		bls	switch_num_read_10_loop
		bra	switch_num_read_end

switch_num_read_2_loop:
		addx.l	d2,d2
switch_num_read_2:
		bsr	GetArgChar
		move.l	d0,d1
		cmpi.b	#'_',d1
		beq	switch_num_read_2
		subi.b	#'0',d1
		lsr.b	#1,d1
		beq	switch_num_read_2_loop
		bra	switch_num_read_end

switch_num_read_16_loopx:
		subq.b	#'A'-('9'+1),d1
switch_num_read_16_loop:
		andi.b	#$0f,d1
		lsl.l	#4,d2
		or.b	d1,d2
switch_num_read_16:
		bsr	GetArgChar
		move.l	d0,d1
		cmpi.b	#'_',d1
		beq	switch_num_read_16
		cmpi.b	#'0',d1
		bcs	switch_num_read_end
		cmpi.b	#'9',d1
		bls	switch_num_read_16_loop
		andi.b	#$df,d1
		cmpi.b	#'A',d1
		bcs	switch_num_read_end
		cmpi.b	#'F',d1
		bls	switch_num_read_16_loopx
		bra	switch_num_read_end


* @@-?FMPH2֘A ---------------------------------------

Asw:
		move	#3,(_gram_disp_mode,a5)
		st	(_inline_to_gram_flag,a5)
		st	(_workgram_clip_flag,a5)	* OvZXŃI[gNbsOgp
**		st	(_FORCEflag,a5)		* \.
		bra	switch_x

Bsw:
		lea	(_dstpath,a5),a0	* o͐w
		bsr	switch_getarg
		move.b	#'/',(a0)+
		clr.b	(a0)
		bra	switch

Nsw:		st	(_same_ofmt_flag,a5)
		bra	switch_x

Dsw:
		st	(_DELflag,a5)		* srcfile 폜
		bra	switch_x

Isw:
@@:		bsr	switch_num_read
		tst	d0
		bne	@f
		moveq	#1,d0
@@:		move	d0,(_info_level,a5)
		bra	switch_x

Vsw:						* o[{[Y
		bsr	switch_second_char_branch
*Vsw_table:
		.dc	't',Vsw_Tsw-$
		.dc	0			;ȊOȂVsw_num
*Vsw_num:
		bsr	switch_num_read
		tst	d0
		bne	@f
		moveq	#1,d0
@@:		move	d0,(_verbose,a5)
		bra	switch_x
Vsw_Tsw:
		st	(_time_flag,a5)
		bra	switch_x

Zsw:
		st	(_no68_flag,a5)
		bra	switch_x

Lsw:
		bsr	switch_second_char_branch
*Lsw_table:
		.dc	'k',Lsw_Ksw-$
		.dc	'e',Lsw_Esw-$
		.dc	's',Lsw_Ssw-$
		.dc	'r',Lsw_Rsw-$
		.dc	'm',Lsw_Msw-$
		.dc	0			;ȊOȂLsw_only
*Lsw_only:
		move	#MPH_LOADER,(_mode,a5)
		move	#3,(_gram_disp_mode,a5)
		bra	switch_x

Lsw_Ksw:
		move	#MPH_LOADER,(_mode,a5)
		move	#3,(_gram_disp_mode,a5)
		st	(_mph_loader_key_flag,a5)
		bra	switch_x

Lsw_Esw:
		move	#MPH_LOADER,(_mode,a5)
		st	(_exit_tonedown_flag,a5)
		tst	(_gram_disp_mode,a5)
		bne	switch_x
		move	#3,(_gram_disp_mode,a5)
		bra	switch_x

Lsw_Rsw:
		move	#MPH_LOADER,(_mode,a5)
		move	#5,(_gram_disp_mode,a5)
		bra	switch_x

Lsw_Ssw:
		move	#MPH_SABUN,(_mode,a5)
		bra	switch_x

Lsw_Msw:
		move	#MPH_SABUN,(_mode,a5)
		move	#MPH_LOAD_MIX_DEF,(_mixer,a5)
		bsr	switch_isnum
		beq	switch_x
;-lm<n>
		lea	(_mixer,a5),a1
		move	#MPH_LOAD_MIX,(a1)+
@@:
		bsr	switch_num_read
		st	(a1,d0.w)		;wF𓧖ɂ
		bsr	GetArgChar		;(𒲂ׂĂȂ댯...)
		cmpi.b	#',',d0
		beq	@b

		bsr	UngetArgChar
		bra	switch_x


* @@-t?FMPH2^Cvw --------------------------------

Tsw:
		bsr	switch_second_char_branch
*Tsw_table:
		.dc	'1',Tsw_1sw-$
		.dc	'o',Tsw_Osw-$
		.dc	-1			;ȊOȂG[

Tsw_1sw:
		move	#MPH_EXP,(_mode,a5)
		move	#4,(_gram_disp_mode,a5)
		bra	switch_x

Tsw_Osw:
		bsr	switch_second_char_branch
*Tsw_Osw_table:
		.dc	'2',Tsw_Osw_to24-$
		.dc	'8',Tsw_Osw_to8-$
		.dc	-1			;ȊOȂG[
Tsw_Osw_to24:
		bsr	GetArgChar
		cmpi.b	#'4',d0
		bne	ERROR_EXIT
		moveq	#24,d0			;-to24
		bra	@f
Tsw_Osw_to8:
		moveq	#8,d0			;-to8
@@:		move	d1,(_to_color,a5)
		bra	switch_x


* @@-w?FMPH2Ro[g֘A ----------------------------

Wsw:
		bsr	switch_second_char_branch
*Wsw_table:
		.dc	'p',Wsw_Psw-$
		.dc	'a',Wsw_Asw-$
		.dc	'c',Wsw_Csw-$
		.dc	'g',Wsw_Gsw-$
		.dc	'f',Wsw_Fsw-$
		.dc	'e',Wsw_Esw-$
		.dc	'z',Wsw_Zsw-$
		.dc	's',Wsw_Ssw-$
		.dc	'x',Wsw_Xsw-$
		.dc	'v',Wsw_Vsw-$
		.dc	-1			;ȊOȂG[

Wsw_Zsw:
		st	(_ext_complete_flag,a5)		* gq⊮sȂH
		bra	switch_x
Wsw_Asw:
		st	(_human_ver_ignore,a5)		* Human o[W
		bra	switch_x
Wsw_Vsw:
		st	(_visual_info,a5)
		bra	switch_x
Wsw_Csw:
		st	(_workgram_clip_flag,a5)	* OvZXŃI[gNbsOgp
		bra	switch_x
Wsw_Psw:
		st	(_ignore_depend_flag,a5)	* ɁCOvZXɗD
		bra	switch_x
Wsw_Ssw:
		st	(_6456_slide_flag,a5)		* 64,56hbg炵Z[u
		bra	switch_x
Wsw_Xsw:
		st	(_pics_center_flag,a5)		* ʒ(64,56)-(703,455)ŃZ[u
		bra	switch_x
Wsw_Gsw:
		moveq	#0,d1
		bsr	chk_gram
		bsr	title
		move.l	#16<<16+0,-(sp)
		DOS	_CONCTRL
		addq.l	#4,sp
		st	(_workmem_gram_flag,a5)		* Z[uobt@GRAMgp.
		bra	switch_x
Wsw_Fsw:
		move	#3,(_gram_disp_mode,a5)
		st	(_inline_to_gram_flag,a5)
		bra	switch_x
Wsw_Esw:
		st	(_ext_ofmt_flag,a5)		* .OFMTo̓t@Cɔf.
		bra	switch_x


* -wpA-c6AIvV̓񕶎ڂŕ򂷂.
* in	(sp).l	e[ũAhX(Ăяoւ͋AȂ)
* ̃AhXɃe[uԂbsrŌĂяoAe[u
* AhXX^bNɐςłbraŌĂяo.

switch_second_char_branch:
		movea.l	(sp)+,a0
		subq	#2,a0
		bsr	GetArgChar
		move.l	d0,d1
		cmpi.b	#'A',d1
		bcs	@f
		cmpi.b	#'Z',d1
		bhi	@f
		ori.b	#$20,d1
@@:
		addq	#2,a0
		tst	(a0)
		ble	@f
		cmp	(a0)+,d1
		bne	@b
		adda	(a0),a0
		jmp	(a0)
@@:
		bmi	ERROR_EXIT
		bsr	UngetArgChar
		addq	#2,a0
		jmp	(a0)


* @@-c?FRg֘A --------------------------------------

Csw:
		bsr	switch_second_char_branch
*Csw_table:
		.dc	'6',Csw_6sw-$
		.dc	'f',Csw_Fsw-$
		.dc	'c',Csw_Csw-$
		.dc	'm',Csw_Msw-$
		.dc	'q',Csw_Qsw-$
		.dc	'u',Csw_Usw-$
		.dc	'g',Csw_Gsw-$
		.dc	'n',Csw_Nsw-$
		.dc	-1			;ȊOȂG[

Csw_Gsw
		st	(_from_cg_flag,a5)	* -cgŎw肳t@C͉摜f[^擾
Csw_Fsw:
		lea	(_arg,a5),a0
		bsr	switch_getarg
		lea	(_arg,a5),a0
		bsr	comment_file_get
		move	#1,(_comm,a5)		* Rgt@Cw
		bra	switch

Csw_Csw
		st	(_comm,a5)		* RgJbg
		bra	switch_x
Csw_6sw:
		st	(_6USER,a5)		* Uڃ[URgɑΏD
		bra	switch_x
Csw_Msw:
		st	(_fromMAGflag,a5)	* MAGRg擾Ƃ݂Ȃ
		bra	switch_x

Csw_Qsw:
		st	(_Qflag,a5)		* Q4D Rg擾
		bsr	switch_second_char_branch
*Csw_Qsw_table:
		.dc	'a',Csw_Qsw_Asw-$
		.dc	'q',Csw_Qsw_Asw-$
		.dc	0			;ȊOȂCsw_Qsw_only
*Csw_Qsw_only:
		bra	switch_x
Csw_Qsw_Asw:
		st	(_QQflag,a5)		* Q4ȊOł -q Ev.
		bra	switch_x

Csw_Nsw
		bsr	GetArgChar
		ori.b	#$20,d0
		cmpi.b	#'n',d0
		bne	ERROR_EXIT
		st	(_not_comment_flag,a5)	* RgȂ
		bra	switch_x

Csw_Usw:
		st	(cu_flag,a5)
		lea	(_mph_user,a5),a0
		bsr	switch_skipsp
		beq	ERROR_EXIT		;-cǔɈȂ

		moveq	#19-1,d1
		bra	@f
Usw_loop:
		bsr	GetArgChar
@@:		move.b	d0,(a0)+
		dbeq	d1,Usw_loop
		beq	switch			;19oCgڂ'\0'ȂZ[t
		bra	ERROR_EXIT


* @@-r?FRGBpbgt@C֘A ---------------------------

Rsw:
		bsr	switch_second_char_branch
*Rsw_table:
		.dc	'l',Rsw_Lsw-$
		.dc	's',Rsw_Ssw-$
		.dc	-1			;ȊOȂG[
Rsw_Lsw:
		lea	(_arg,a5),a0
		bsr	switch_getarg
		lea	(_arg,a5),a0
		bsr	palet_set
		move	#1,(_palet,a5)		* pbgt@Cw
		bra	switch
Rsw_Ssw:
		st	(_makeRGBflag,a5)	* RGBt@C쐬
		bra	switch_x

* @@-s?:Z[o -------------------------------------------------

Ssw:
		bsr	switch_second_char_branch
*Ssw_table:
		.dc	'c',Ssw_Csw-$
		.dc	'm',Ssw_Msw-$
		.dc	't',Ssw_Tsw-$
		.dc	'u',Ssw_Usw-$
		.dc	0			;ȊOȂSsw_main
Ssw_main:
		bsr	switch_isnum
		beq	Ssw_end

		bsr	switch_num_read		;x start
		move	d0,(_scolum_Ssw,a5)
		bsr	switch_is_comma
		bne	Ssw_error

		bsr	switch_num_read		;y start
		move	d0,(_sline_Ssw,a5)
		bsr	switch_is_comma
		bne	Ssw_error

		bsr	switch_num_read		;x end
		move	d0,(_ecolum_Ssw,a5)
		move	d0,d2
		bsr	switch_is_comma
		bne	Ssw_error

		bsr	switch_num_read		;y end
		move	d0,(_eline_Ssw,a5)
		move	d0,d3

		cmpi	#1023,d2
		bhi	Ssw_error
		cmpi	#1023,d3
		bhi	Ssw_error
		addq	#1,d2
		sub	(_scolum_Ssw,a5),d2
		ble	Ssw_error
		move	d2,(_colum_Ssw,a5)
		addq	#1,d3
		sub	(_sline_Ssw,a5),d3
		ble	Ssw_error
		move	d3,(_line_Ssw,a5)

		mulu	d2,d3
		move.l	d3,(_buff_req,a5)
Ssw_end:
		move	#MPH_SAVER,(_mode,a5)
		bra	switch_x
Ssw_error:
		moveq	#39,d6
		bra	ERROR_EXIT

switch_is_comma:
		bsr	GetArgChar
		bsr	UngetArgChar
		cmpi.b	#',',d0
		rts

Ssw_Csw:
		bsr	switch_second_char_branch
*Ssw_Csw_table:
		.dc	'm',Ssw_Csw_Msw-$
		.dc	0			;ȊOȂSsw_Csw_only
*Ssw_Csw_only:
		moveq	#1,d0			;-sc
		bra	@f
Ssw_Csw_Msw:
		moveq	#2,d0			;-scm
@@:		move	d0,(_s_clip,a5)
		bra	Ssw_end

Ssw_Msw:
		move	#5,(_s_mode,a5)
		bra	Ssw_end

Ssw_Tsw:
		move	#3,(_gram_disp_mode,a5)
		st	(_s_disp_save_flag,a5)
		bra	Ssw_main

Ssw_Usw:
		st	(_save_not_user_flag,a5)
		bra	switch_x		;Z[uwł͂Ȃ̂Ssw_endł͂Ȃ


* @@-p?FPi֘A --------------------------------------------

Psw:
		bsr	switch_second_char_branch
*Psw_table:
		.dc	'i',Psw_Isw-$
		.dc	's',Psw_Ssw-$
		.dc	'p',Psw_Psw-$
		.dc	-1			;ȊOȂG[

Psw_Isw:
		st	(_O,a5)			* PiZ[uʒu񖳎
		bra	switch_x
Psw_Ssw:
*		st	(_Sflag,a5)		* PiZ[uʒu␳
		st	(_6456_slide_flag,a5)
		bra	switch_x
Psw_Psw:
		move	#MPH_INFO,(_mode,a5)
		bra	switch_x

* @@-q?FQ4֘A --------------------------------------------

Qsw:
		bsr	switch_second_char_branch
*Qsw_table:
		.dc	'c',Csw_Qsw-$		;-qc* = -cq*
		.dc	't',Qsw_Tsw-$
		.dc	-1			;ȊOȂG[
Qsw_Tsw:
		st	(_trans_q4_flag,a5)		* pS̃v[ϊsȂ
		bra	switch_x

* @@-f?FGIF֘A --------------------------------------------

Fsw:
		bsr	GetArgChar
		ori.b	#$20,d0
		cmpi.b	#'i',d0
		bne	ERROR_EXIT
*Fsw_Isw:
		move.b	#1,(_gif_ex_save_flag,a5)	* GIF Interlace ŃZ[u
		bra	switch_x

* @@-m?FMKI, MAG֘A --------------------------------------

Msw:
		bsr	switch_second_char_branch
*Msw_table:
		.dc	'f',Msw_Fsw-$
		.dc	'l',Msw_Lsw-$
		.dc	-1			;ȊOȂG[
Msw_Fsw:
		move.b	#1,(_mag_force_save_flag,a5)	* Z[u
		bra	switch_x
Msw_Lsw:
		bsr	switch_num_read
		move.b	d0,(_MSXflag,a5)	* MKI-HALF
		bra	switch_x

* @@-g?FRo[g\֘A --------------------------------

Gsw:						* GRAMɕ\ȂRo[g
		bsr	switch_second_char_branch
*Gsw_table:
		.dc	'1',Gsw_1sw-$
		.dc	'2',Gsw_2sw-$
		.dc	'3',Gsw_3sw-$
		.dc	't',Gsw_Tsw-$
		.dc	'c',Gsw_Csw-$
		.dc	'w',Gsw_Wsw-$
		.dc	'p',Gsw_Psw-$
		.dc	0			;ȊOȂGsw_def
Gsw_1sw:
Gsw_def:	moveq	#1,d0
		bra	@f
Gsw_2sw:
		moveq	#2,d0
		bra	@f
Gsw_3sw:
*		moveq	#5,d0
		moveq	#1,d0
@@:
		tst.b	(_inline_to_gram_flag,a5)
		bne	switch_x
		move	d0,(_gram_disp_mode,a5)
		bra	switch_x

Gsw_Tsw:
		st	(_text_mask_flag,a5)
		bra	switch_x
Gsw_Csw:
		st	(_gclr_off_flag,a5)
		bra	switch_x
Gsw_Wsw:
		bsr	switch_num_read
		move	d0,(_gram_disp_wait,a5)
		bra	switch_x
Gsw_Psw:
		bsr	switch_num_read
		cmpi	#100,d0
		bhi	switch_x
		move	d0,(_gram_disp_palet,a5)
		bra	switch_x


* @@XCb`O[o ---------------------------------

switch_x:
		bsr	GetArgChar
		tst.b	d0
		bne	swich1
		bra	switch


		.end

* End of File --------------------------------- *
