.comment comments *-------------------------------------------------------------*
|										|
|	PIX Graphic Saver							|
|										|
|					original program v1.00 by Herzen	|
|										|
comments *----------------------------------------------------------------------*

		.include	doscall.mac
		.include	mph.h
		.include	mph_lib.h

		.xdef	_PIXSave__


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*
* PIX摜Z[u
*
* in  Ȃ
*
* out d0.w =        0 : I
*            ȊO : G[R[h
*
* (l) E16F́CPsNZPoCgD
*        EzGRAMpłCGRAMk͂ȂD
*
*----------------------------------------------------------------------------*

_PIXSave__
		movem.l	d3-d7/a3-a6,-(sp)
		bsr	PIXSave
		movem.l	(sp)+,d3-d7/a3-a6
		rts

PIXSave
		bsr	pix_head_write
		tst.w	d0
		bne	@f

		bsr	data_save
		tst.w	d0
		bne	@f

		move.w	d5,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp
		moveq.l	#0,d0
@@:
		rts


*----------------------------------------------------------------------------*
*
* PIXwb_o
*
* in  Ȃ
*
* out d0.w =        0 : 
*            ȊO : G[R[h
*     d5.w = t@Cnh
*
* (l) Epbg܂łoD
*
*----------------------------------------------------------------------------*

pix_head_write:
		move.w	#$20,-(sp)
		pea.l	_dstfile(a5)
		DOS	_CREATE
		addq.l	#6,sp
		moveq.l	#2,d6
		move.w	d0,d5
		bmi	file_error_

		lea.l	_tmp(a5),a0
		move.l	#'TX16',(a0)+

		move.w	_colum(a5),d0	* t@CTCY|WvZ
		move.w	d0,d1
		lsr.w	#4,d0
		and.w	#%1111,d1
		beq	@f
		addq.w	#1,d0
@@:
		add.w	d0,d0
		mulu.w	_line(a5),d0
		lsl.l	#2,d0
		add.l	#16+32-8,d0	* HEADSIZE(16Bytes)+PALET(32bytes)-8
		move.l	d0,(a0)+

		move.l	#0,(a0)+
		move.w	_colum(a5),(a0)+
		move.w	_line(a5),(a0)+

		lea.l	_pal_buf(a5),a1
		moveq.l	#16-1,d0
@@:		move.w	(a1)+,(a0)+
		dbra	d0,@b

		move.l	a0,d0
		lea.l	_tmp(a5),a0
		sub.l	a0,d0
		move.l	d0,-(sp)
		pea.l	_tmp(a5)
		move.w	d5,-(sp)
		DOS	_WRITE		܂ł̃wb_o
		lea	10(sp),sp
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error_
		moveq.l	#0,d0
		rts


*----------------------------------------------------------------------------*
* maske[u

mask_table:
	.dc.w	0				* dummy
	.dc.w	%10000000_00000000
	.dc.w	%11000000_00000000
	.dc.w	%11100000_00000000
	.dc.w	%11110000_00000000
	.dc.w	%11111000_00000000
	.dc.w	%11111100_00000000
	.dc.w	%11111110_00000000
	.dc.w	%11111111_00000000
	.dc.w	%11111111_10000000
	.dc.w	%11111111_11000000
	.dc.w	%11111111_11100000
	.dc.w	%11111111_11110000
	.dc.w	%11111111_11111000
	.dc.w	%11111111_11111100
	.dc.w	%11111111_11111110


*----------------------------------------------------------------------------*
*
* 摜f[^oC
*
*----------------------------------------------------------------------------*

data_save:
	move.w	_colum(a5),d7
	move.w	d7,d6
	lsr.w	#4,d7
	and.w	#%1111,d6
	beq	@f
	addq.w	#1,d7
@@:
	add.w	d7,d7
	move.w	d7,d0
	mulu.w	_line(a5),d0
	movea.l	_save_addr(a5),a0
	lea.l	(a0,d0.l),a1
	lea.l	(a1,d0.l),a2
	lea.l	(a2,d0.l),a3
	move.w	_colum(a5),d7
	lsr.w	#4,d7
	subq.w	#1,d7
	move.w	d7,_tmp(a5)
	move.w	d6,_tmp+2(a5)
	add.w	d6,d6

	lea.l	mask_table(pc,d6.w),a4
	move.w	(a4),_tmp+4(a5)

*----------------------------------------------------------------------------*
* ϊ

		movea.l	_buff_addr(a5),a4
		move.w	_line(a5),d7
		subq.w	#1,d7
outlop:
		move.w	_tmp(a5),d6
inlop:
		.rept 2
		moveq.l	#0,d0		* WJ܂...
		move.w	d0,d1
		move.w	d0,d2
		move.w	d0,d3
			.rept 8
			move.b	(a4)+,d4
			lsr.w	#1,d4
			addx.b	d0,d0
			lsr.w	#1,d4
			addx.b	d1,d1
			lsr.w	#1,d4
			addx.b	d2,d2
			lsr.w	#1,d4
			addx.b	d3,d3
			.endm
		move.b	d0,(a0)+
		move.b	d1,(a1)+
		move.b	d2,(a2)+
		move.b	d3,(a3)+
		.endm

		dbra	d6,inlop
		move.w	_tmp+2(a5),d6		* 16̔{łȂCc
		beq	in_end
		move.l	a4,-(sp)

		.rept 2
		moveq.l	#0,d0		* WJ܂...
		move.w	d0,d1
		move.w	d0,d2
		move.w	d0,d3
			.rept 8
			move.b	(a4)+,d4
			lsr.w	#1,d4
			addx.b	d0,d0
			lsr.w	#1,d4
			addx.b	d1,d1
			lsr.w	#1,d4
			addx.b	d2,d2
			lsr.w	#1,d4
			addx.b	d3,d3
			.endm
		move.b	d0,(a0)+
		move.b	d1,(a1)+
		move.b	d2,(a2)+
		move.b	d3,(a3)+
		.endm

		move.l	(sp)+,a4
		add.w	d6,a4
		move.w	_tmp+4(a5),d6
		and.w	d6,-2(a0)
		and.w	d6,-2(a1)
		and.w	d6,-2(a2)
		and.w	d6,-2(a3)
in_end:
		bsr	ldisp
		dbra	d7,outlop

	suba.l	_save_addr(a5),a3
	move.l	a3,-(sp)
	move.l	_save_addr(a5),-(sp)
	move.w	d5,-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp
	moveq.l	#4,d6
	tst.l	d0
	bmi	file_error_
	moveq.l	#7,d6
	cmp.l	a3,d0
	bne	file_error_

	moveq.l	#0,d0
	rts


*----------------------------------------------------------------------------*
* Z[uoߕ
*----------------------------------------------------------------------------*

ldisp:
		movem.l	d0-d1,-(sp)
		move.w	_line(a5),d0
		move.w	d7,d1
		bsr	line_disp
		movem.l	(sp)+,d0-d1
		rts


*----------------------------------------------------------------------------*
* G[
*----------------------------------------------------------------------------*

file_error_:
		move.l	d6,d0
		rts

		.end
